import { Camera } from "three";
interface WebGPUDeviceContext {
    adapter: GPUAdapter;
    device: GPUDevice;
}
export declare function initWebGPU(): Promise<WebGPUDeviceContext>;
export declare class WebGPURenderer {
    deviceContext: WebGPUDeviceContext;
    canvas: HTMLCanvasElement;
    numParticles: number;
    particleInstanceByteSize: number;
    debug: boolean;
    renderCode: string;
    private numLiveParticles;
    simulationUBOBuffer: GPUBuffer;
    simulationParams: {
        simulate: boolean;
        deltaTime: number;
    };
    private particlesBuffer;
    private particleIndexBuffer;
    private computeBindGroup;
    private computePipeline;
    private context;
    private mvp;
    private uniformBuffer;
    private quadVertexBuffer;
    private renderBindGroup;
    private renderPassDescriptor;
    private renderPipeline;
    cpuReadableBuffer: GPUBuffer;
    constructor(deviceContext: WebGPUDeviceContext, canvas: HTMLCanvasElement, numParticles: number, particleInstanceByteSize: number, code: string, debug?: boolean, renderCode?: string);
    initBuffers(): void;
    initRenderPipeline(): void;
    private initSimulationPipeline;
    frame: (camera: Camera) => Promise<void>;
}
export {};
