import { Behavior } from './Behavior';
import { Particle } from '../Particle';
import { FunctionValueGenerator, ValueGenerator } from '../functions';
import { Quaternion, Vector3 } from 'three';
import { ParticleSystem } from '../ParticleSystem';
import { IParticleSystem } from '../BatchedRenderer';
export declare class ForceOverLife implements Behavior {
    x: FunctionValueGenerator | ValueGenerator;
    y: FunctionValueGenerator | ValueGenerator;
    z: FunctionValueGenerator | ValueGenerator;
    type: string;
    _temp: Vector3;
    ps: IParticleSystem;
    initialize(particle: Particle, particleSystem: ParticleSystem): void;
    constructor(x: FunctionValueGenerator | ValueGenerator, y: FunctionValueGenerator | ValueGenerator, z: FunctionValueGenerator | ValueGenerator);
    update(particle: Particle, delta: number): void;
    toJSON(): any;
    static fromJSON(json: any): Behavior;
    _tempScale: Vector3;
    _tempQ: Quaternion;
    frameUpdate(delta: number): void;
    clone(): Behavior;
    reset(): void;
}
