import { Behavior } from "./Behavior";
import { Particle } from "../Particle";
import { Vector3 } from "three";
import SimplexNoise from "../util/SimplexNoise";
export declare class TurbulenceField implements Behavior {
    scale: Vector3;
    octaves: number;
    velocityMultiplier: Vector3;
    timeScale: Vector3;
    type: string;
    generator: SimplexNoise;
    timeOffset: Vector3;
    temp: Vector3;
    temp2: Vector3;
    constructor(scale: Vector3, octaves: number, velocityMultiplier: Vector3, timeScale: Vector3);
    initialize(particle: Particle): void;
    update(particle: Particle, delta: number): void;
    toJSON(): any;
    frameUpdate(delta: number): void;
    static fromJSON(json: any): Behavior;
    clone(): Behavior;
    reset(): void;
}
