import { RotationGenerator } from './RotationGenerator';
import { Euler, Quaternion } from 'three';
import { FunctionValueGenerator, ValueGenerator } from './ValueGenerator';
import { FunctionJSON } from './FunctionJSON';
import { EulerOrder } from 'three/src/math/Euler';
export declare class EulerGenerator implements RotationGenerator {
    angleX: FunctionValueGenerator | ValueGenerator;
    angleY: FunctionValueGenerator | ValueGenerator;
    angleZ: FunctionValueGenerator | ValueGenerator;
    type: 'rotation';
    eular: Euler;
    constructor(angleX: FunctionValueGenerator | ValueGenerator, angleY: FunctionValueGenerator | ValueGenerator, angleZ: FunctionValueGenerator | ValueGenerator, eulerOrder?: EulerOrder);
    genValue(quat: Quaternion, t?: number): Quaternion;
    toJSON(): FunctionJSON;
    static fromJSON(json: FunctionJSON): EulerGenerator;
    clone(): RotationGenerator;
}
