import { FunctionColorGenerator } from './ColorGenerator';
import { Vector3, Vector4 } from 'three';
import { FunctionJSON } from './FunctionJSON';
import { ContinuousLinearFunction } from './ContinuousLinearFunction';
export declare class Gradient implements FunctionColorGenerator {
    type: 'function';
    color: ContinuousLinearFunction<Vector3>;
    alpha: ContinuousLinearFunction<number>;
    constructor(color?: Array<[Vector3, number]>, alpha?: Array<[number, number]>);
    genColor(color: Vector4, t: number): Vector4;
    toJSON(): FunctionJSON;
    static fromJSON(json: FunctionJSON): Gradient;
    clone(): FunctionColorGenerator;
}
