import { NodeGraph } from './NodeGraph';
import { ExecutionContext } from './NodeDef';
export declare abstract class BaseCompiler {
    static Instance: BaseCompiler;
    constructor();
    visited: Set<string>;
    debug: boolean;
    protected buildExecutionOrder(graph: NodeGraph, context: ExecutionContext): void;
    private _traverseWire;
    private _traverse;
    abstract run(graph: NodeGraph, context: ExecutionContext): void;
    abstract build(graph: NodeGraph, context: ExecutionContext): string;
}
