import { Node, Wire } from './Node';
export declare class NodeGraph {
    uuid: string;
    name: string;
    version: string;
    revision: number;
    inputNodes: Node[];
    outputNodes: Node[];
    allNodes: Map<string, Node>;
    wires: Wire[];
    compiled: boolean;
    nodesInOrder: Array<Node>;
    constructor(name: string);
    addWire(wire: Wire): void;
    addNode(node: Node): void;
    getNode(id: string): Node | undefined;
    deleteNode(node: Node): void;
    deleteWire(wire: Wire): void;
    toJSON(): any;
    clone(): NodeGraph;
}
