import { BaseCompiler } from './BaseCompiler';
import { ExecutionContext } from './NodeDef';
import { NodeGraph } from './NodeGraph';
import { Node } from './Node';
export declare class WebGPUCompiler extends BaseCompiler {
    run(graph: NodeGraph, context: ExecutionContext): void;
    constructor();
    protected nodeResult: Map<Node, string>;
    particleInstanceByteSize: number;
    hasRandom: boolean;
    private calculateMemoryLayout;
    private buildPredefinedStructs;
    private buildHeader;
    private buildFooter;
    private buildWebGPUCode;
    private buildDataFlow;
    build(graph: NodeGraph, context: ExecutionContext): string;
    private buildFromValue;
    private getTypeFromNodeType;
    private buildFromAdapter;
    private getResult;
}
