!function(e){"function"==typeof define&&define.amd?define(e):e()}((function(){"use strict";var e,t;e=void 0,t=function(e,t){var i=t.ShaderChunk;function registerShaderChunks(){i.tile_pars_vertex="\n#ifdef UV_TILE\n    attribute float uvTile;\n    uniform vec2 tileCount;\n    \n    mat3 makeTileTransform(float uvTile) {\n        float col = mod(uvTile, tileCount.x);\n        float row = (tileCount.y - floor(uvTile / tileCount.x) - 1.0);\n        \n        return mat3(\n          1.0 / tileCount.x, 0.0, 0.0,\n          0.0, 1.0 / tileCount.y, 0.0, \n          col / tileCount.x, row / tileCount.y, 1.0);\n    }\n#else\n    mat3 makeTileTransform(float uvTile) {\n        return mat3(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);\n    }\n#endif\n\n#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\n\tvarying vec2 vUv;\n#ifdef TILE_BLEND\n    varying vec2 vUvNext;\n    varying float vUvBlend;\n#endif\n\n#endif\n#ifdef USE_MAP\n\n\tuniform mat3 mapTransform;\n\tvarying vec2 vMapUv;\n#ifdef TILE_BLEND\n    varying vec2 vMapUvNext;\n#endif\n\n#endif\n#ifdef USE_ALPHAMAP\n\n\tuniform mat3 alphaMapTransform;\n\tvarying vec2 vAlphaMapUv;\n\n#endif\n#ifdef USE_LIGHTMAP\n\n\tuniform mat3 lightMapTransform;\n\tvarying vec2 vLightMapUv;\n\n#endif\n#ifdef USE_AOMAP\n\n\tuniform mat3 aoMapTransform;\n\tvarying vec2 vAoMapUv;\n\n#endif\n#ifdef USE_BUMPMAP\n\n\tuniform mat3 bumpMapTransform;\n\tvarying vec2 vBumpMapUv;\n\n#endif\n#ifdef USE_NORMALMAP\n\n\tuniform mat3 normalMapTransform;\n\tvarying vec2 vNormalMapUv;\n\n#endif\n#ifdef USE_DISPLACEMENTMAP\n\n\tuniform mat3 displacementMapTransform;\n\tvarying vec2 vDisplacementMapUv;\n\n#endif\n#ifdef USE_EMISSIVEMAP\n\n\tuniform mat3 emissiveMapTransform;\n\tvarying vec2 vEmissiveMapUv;\n\n#endif\n#ifdef USE_METALNESSMAP\n\n\tuniform mat3 metalnessMapTransform;\n\tvarying vec2 vMetalnessMapUv;\n\n#endif\n#ifdef USE_ROUGHNESSMAP\n\n\tuniform mat3 roughnessMapTransform;\n\tvarying vec2 vRoughnessMapUv;\n\n#endif\n#ifdef USE_ANISOTROPYMAP\n\n\tuniform mat3 anisotropyMapTransform;\n\tvarying vec2 vAnisotropyMapUv;\n\n#endif\n#ifdef USE_CLEARCOATMAP\n\n\tuniform mat3 clearcoatMapTransform;\n\tvarying vec2 vClearcoatMapUv;\n\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\n\tuniform mat3 clearcoatNormalMapTransform;\n\tvarying vec2 vClearcoatNormalMapUv;\n\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\n\tuniform mat3 clearcoatRoughnessMapTransform;\n\tvarying vec2 vClearcoatRoughnessMapUv;\n\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\n\tuniform mat3 sheenColorMapTransform;\n\tvarying vec2 vSheenColorMapUv;\n\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\n\tuniform mat3 sheenRoughnessMapTransform;\n\tvarying vec2 vSheenRoughnessMapUv;\n\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\n\tuniform mat3 iridescenceMapTransform;\n\tvarying vec2 vIridescenceMapUv;\n\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\n\tuniform mat3 iridescenceThicknessMapTransform;\n\tvarying vec2 vIridescenceThicknessMapUv;\n\n#endif\n#ifdef USE_SPECULARMAP\n\n\tuniform mat3 specularMapTransform;\n\tvarying vec2 vSpecularMapUv;\n\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\n\tuniform mat3 specularColorMapTransform;\n\tvarying vec2 vSpecularColorMapUv;\n\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\n\tuniform mat3 specularIntensityMapTransform;\n\tvarying vec2 vSpecularIntensityMapUv;\n\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\n\tuniform mat3 transmissionMapTransform;\n\tvarying vec2 vTransmissionMapUv;\n\n#endif\n#ifdef USE_THICKNESSMAP\n\n\tuniform mat3 thicknessMapTransform;\n\tvarying vec2 vThicknessMapUv;\n\n#endif\n",i.tile_vertex="\n#ifdef UV_TILE\n    mat3 tileTransform = makeTileTransform(floor(uvTile));\n    #ifdef TILE_BLEND\n        mat3 nextTileTransform = makeTileTransform(ceil(uvTile));\n        vUvBlend = fract(uvTile);\n    #endif\n#else\n    mat3 tileTransform = makeTileTransform(0.0);\n#endif\n\n#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\nvUv = (tileTransform *vec3( uv, 1 )).xy;\n#if defined( TILE_BLEND ) && defined( UV_TILE )\n    vUvNext = (nextTileTransform *vec3( uv, 1 )).xy;\n#endif\n\n#endif\n#ifdef USE_MAP\n\nvMapUv = ( tileTransform * (mapTransform * vec3( MAP_UV, 1 ) )).xy;\n#if defined( TILE_BLEND ) && defined( UV_TILE )\n    vMapUvNext = (nextTileTransform * (mapTransform * vec3( MAP_UV, 1 ))).xy;\n#endif\n\n#endif\n#ifdef USE_ALPHAMAP\n\nvAlphaMapUv = ( tileTransform * (alphaMapTransform * vec3( ALPHAMAP_UV, 1 ) )).xy;\n    \n#endif\n#ifdef USE_LIGHTMAP\n\nvLightMapUv = ( tileTransform * (lightMapTransform * vec3( LIGHTMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_AOMAP\n\nvAoMapUv = ( tileTransform * (aoMapTransform * vec3( AOMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_BUMPMAP\n\nvBumpMapUv = ( tileTransform * (bumpMapTransform * vec3( BUMPMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_NORMALMAP\n\nvNormalMapUv = ( tileTransform * (normalMapTransform * vec3( NORMALMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_DISPLACEMENTMAP\n\nvDisplacementMapUv = ( tileTransform * (displacementMapTransform * vec3( DISPLACEMENTMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_EMISSIVEMAP\n\nvEmissiveMapUv = ( tileTransform * (emissiveMapTransform * vec3( EMISSIVEMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_METALNESSMAP\n\nvMetalnessMapUv = ( tileTransform * (metalnessMapTransform * vec3( METALNESSMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_ROUGHNESSMAP\n\nvRoughnessMapUv = ( tileTransform * (roughnessMapTransform * vec3( ROUGHNESSMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_ANISOTROPYMAP\n\nvAnisotropyMapUv = ( tileTransform * (anisotropyMapTransform * vec3( ANISOTROPYMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_CLEARCOATMAP\n\nvClearcoatMapUv = ( tileTransform * (clearcoatMapTransform * vec3( CLEARCOATMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\nvClearcoatNormalMapUv = ( tileTransform * (clearcoatNormalMapTransform * vec3( CLEARCOAT_NORMALMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\nvClearcoatRoughnessMapUv = ( tileTransform * (clearcoatRoughnessMapTransform * vec3( CLEARCOAT_ROUGHNESSMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\nvIridescenceMapUv = ( tileTransform * (iridescenceMapTransform * vec3( IRIDESCENCEMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\nvIridescenceThicknessMapUv = ( tileTransform * (iridescenceThicknessMapTransform * vec3( IRIDESCENCE_THICKNESSMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\nvSheenColorMapUv = ( tileTransform * (sheenColorMapTransform * vec3( SHEEN_COLORMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\nvSheenRoughnessMapUv = ( tileTransform * (sheenRoughnessMapTransform * vec3( SHEEN_ROUGHNESSMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_SPECULARMAP\n\nvSpecularMapUv = ( tileTransform * (specularMapTransform * vec3( SPECULARMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\nvSpecularColorMapUv = ( tileTransform * (specularColorMapTransform * vec3( SPECULAR_COLORMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\nvSpecularIntensityMapUv = ( tileTransform * (specularIntensityMapTransform * vec3( SPECULAR_INTENSITYMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\nvTransmissionMapUv = ( tileTransform * transmissionMapTransform * vec3( TRANSMISSIONMAP_UV, 1 ) )).xy;\n\n#endif\n#ifdef USE_THICKNESSMAP\n\nvThicknessMapUv = ( tileTransform * thicknessMapTransform * vec3( THICKNESSMAP_UV, 1 ) )).xy;\n\n#endif\n\n",i.tile_pars_fragment="\n#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\n\tvarying vec2 vUv;\n#ifdef TILE_BLEND\n    varying vec2 vUvNext;\n    varying float vUvBlend;\n#endif\n\n#endif\n#ifdef USE_MAP\n\n\tuniform mat3 mapTransform;\n\tvarying vec2 vMapUv;\n#ifdef TILE_BLEND\n    varying vec2 vMapUvNext;\n#endif\n\n#endif\n#ifdef USE_ALPHAMAP\n\n\tuniform mat3 alphaMapTransform;\n\tvarying vec2 vAlphaMapUv;\n\n#endif\n#ifdef USE_LIGHTMAP\n\n\tuniform mat3 lightMapTransform;\n\tvarying vec2 vLightMapUv;\n\n#endif\n#ifdef USE_AOMAP\n\n\tuniform mat3 aoMapTransform;\n\tvarying vec2 vAoMapUv;\n\n#endif\n#ifdef USE_BUMPMAP\n\n\tuniform mat3 bumpMapTransform;\n\tvarying vec2 vBumpMapUv;\n\n#endif\n#ifdef USE_NORMALMAP\n\n\tuniform mat3 normalMapTransform;\n\tvarying vec2 vNormalMapUv;\n\n#endif\n#ifdef USE_DISPLACEMENTMAP\n\n\tuniform mat3 displacementMapTransform;\n\tvarying vec2 vDisplacementMapUv;\n\n#endif\n#ifdef USE_EMISSIVEMAP\n\n\tuniform mat3 emissiveMapTransform;\n\tvarying vec2 vEmissiveMapUv;\n\n#endif\n#ifdef USE_METALNESSMAP\n\n\tuniform mat3 metalnessMapTransform;\n\tvarying vec2 vMetalnessMapUv;\n\n#endif\n#ifdef USE_ROUGHNESSMAP\n\n\tuniform mat3 roughnessMapTransform;\n\tvarying vec2 vRoughnessMapUv;\n\n#endif\n#ifdef USE_ANISOTROPYMAP\n\n\tuniform mat3 anisotropyMapTransform;\n\tvarying vec2 vAnisotropyMapUv;\n\n#endif\n#ifdef USE_CLEARCOATMAP\n\n\tuniform mat3 clearcoatMapTransform;\n\tvarying vec2 vClearcoatMapUv;\n\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\n\tuniform mat3 clearcoatNormalMapTransform;\n\tvarying vec2 vClearcoatNormalMapUv;\n\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\n\tuniform mat3 clearcoatRoughnessMapTransform;\n\tvarying vec2 vClearcoatRoughnessMapUv;\n\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\n\tuniform mat3 sheenColorMapTransform;\n\tvarying vec2 vSheenColorMapUv;\n\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\n\tuniform mat3 sheenRoughnessMapTransform;\n\tvarying vec2 vSheenRoughnessMapUv;\n\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\n\tuniform mat3 iridescenceMapTransform;\n\tvarying vec2 vIridescenceMapUv;\n\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\n\tuniform mat3 iridescenceThicknessMapTransform;\n\tvarying vec2 vIridescenceThicknessMapUv;\n\n#endif\n#ifdef USE_SPECULARMAP\n\n\tuniform mat3 specularMapTransform;\n\tvarying vec2 vSpecularMapUv;\n\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\n\tuniform mat3 specularColorMapTransform;\n\tvarying vec2 vSpecularColorMapUv;\n\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\n\tuniform mat3 specularIntensityMapTransform;\n\tvarying vec2 vSpecularIntensityMapUv;\n\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\n\tuniform mat3 transmissionMapTransform;\n\tvarying vec2 vTransmissionMapUv;\n\n#endif\n#ifdef USE_THICKNESSMAP\n\n\tuniform mat3 thicknessMapTransform;\n\tvarying vec2 vThicknessMapUv;\n\n#endif\n",i.tile_fragment="\n#ifdef USE_MAP\n    vec4 texelColor = texture2D( map, vUv);\n    #ifdef TILE_BLEND\n        texelColor = mix( texelColor, texture2D( map, vUvNext ), vUvBlend );\n    #endif\n    diffuseColor *= texelColor;\n#endif\n",i.soft_pars_vertex="\n#ifdef SOFT_PARTICLES\n    varying vec4 projPosition;\n    varying float linearDepth;\n#endif\n",i.soft_vertex="\n#ifdef SOFT_PARTICLES\n    projPosition = gl_Position;\n    linearDepth = -mvPosition.z;\n#endif\n",i.soft_pars_fragment="\n#ifdef SOFT_PARTICLES\n\n    uniform sampler2D depthTexture;\n    uniform vec4 projParams;\n    uniform vec2 softParams;\n\n    varying vec4 projPosition;\n    varying float linearDepth;\n\n    #define SOFT_NEAR_FADE softParams.x\n    #define SOFT_INV_FADE_DISTANCE softParams.y\n\n    #define zNear projParams.x\n    #define zFar projParams.y\n\n    float linearize_depth(float d)\n    {\n        return (zFar * zNear) / (zFar - d * (zFar - zNear));\n    }\n\n#endif\n",i.soft_fragment="\n#ifdef SOFT_PARTICLES\n\n    /* #ifdef LOGDEPTH\n    float distSample = linearize_depth_log(sampleDepth, near, far);\n    #else\n    float distSample = ortho ? linearize_depth_ortho(sampleDepth, near, far) : linearize_depth(sampleDepth, near, far);\n    #endif */\n\n    vec2 p2 = projPosition.xy / projPosition.w;\n    \n    p2 = 0.5 * p2 + 0.5;\n\n    float readDepth = texture2D(depthTexture, p2.xy).r;\n    float viewDepth = linearize_depth(readDepth);\n\n    float softParticlesFade = saturate(SOFT_INV_FADE_DISTANCE * ((viewDepth - SOFT_NEAR_FADE) - linearDepth));\n    \n    gl_FragColor *= softParticlesFade;\n\n    //gl_FragColor = vec4(softParticlesFade , 0, 0, 1);\n#endif\n"}function _regeneratorRuntime(){_regeneratorRuntime=function(){return t};var e,t={},i=Object.prototype,n=i.hasOwnProperty,r=Object.defineProperty||function(e,t,i){e[t]=i.value},o="function"==typeof Symbol?Symbol:{},a=o.iterator||"@@iterator",s=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function define(e,t,i){return Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{define({},"")}catch(e){define=function(e,t,i){return e[t]=i}}function wrap(e,t,i,n){var o=t&&t.prototype instanceof Generator?t:Generator,a=Object.create(o.prototype),s=new Context(n||[]);return r(a,"_invoke",{value:makeInvokeMethod(e,i,s)}),a}function tryCatch(e,t,i){try{return{type:"normal",arg:e.call(t,i)}}catch(e){return{type:"throw",arg:e}}}t.wrap=wrap;var l="suspendedStart",c="suspendedYield",d="executing",f="completed",h={};function Generator(){}function GeneratorFunction(){}function GeneratorFunctionPrototype(){}var p={};define(p,a,(function(){return this}));var m=Object.getPrototypeOf,v=m&&m(m(values([])));v&&v!==i&&n.call(v,a)&&(p=v);var y=GeneratorFunctionPrototype.prototype=Generator.prototype=Object.create(p);function defineIteratorMethods(e){["next","throw","return"].forEach((function(t){define(e,t,(function(e){return this._invoke(t,e)}))}))}function AsyncIterator(e,t){function invoke(i,r,o,a){var s=tryCatch(e[i],e,r);if("throw"!==s.type){var u=s.arg,l=u.value;return l&&"object"==typeof l&&n.call(l,"__await")?t.resolve(l.__await).then((function(e){invoke("next",e,o,a)}),(function(e){invoke("throw",e,o,a)})):t.resolve(l).then((function(e){u.value=e,o(u)}),(function(e){return invoke("throw",e,o,a)}))}a(s.arg)}var i;r(this,"_invoke",{value:function(e,n){function callInvokeWithMethodAndArg(){return new t((function(t,i){invoke(e,n,t,i)}))}return i=i?i.then(callInvokeWithMethodAndArg,callInvokeWithMethodAndArg):callInvokeWithMethodAndArg()}})}function makeInvokeMethod(t,i,n){var r=l;return function(o,a){if(r===d)throw new Error("Generator is already running");if(r===f){if("throw"===o)throw a;return{value:e,done:!0}}for(n.method=o,n.arg=a;;){var s=n.delegate;if(s){var u=maybeInvokeDelegate(s,n);if(u){if(u===h)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===l)throw r=f,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=d;var p=tryCatch(t,i,n);if("normal"===p.type){if(r=n.done?f:c,p.arg===h)continue;return{value:p.arg,done:n.done}}"throw"===p.type&&(r=f,n.method="throw",n.arg=p.arg)}}}function maybeInvokeDelegate(t,i){var n=i.method,r=t.iterator[n];if(r===e)return i.delegate=null,"throw"===n&&t.iterator.return&&(i.method="return",i.arg=e,maybeInvokeDelegate(t,i),"throw"===i.method)||"return"!==n&&(i.method="throw",i.arg=new TypeError("The iterator does not provide a '"+n+"' method")),h;var o=tryCatch(r,t.iterator,i.arg);if("throw"===o.type)return i.method="throw",i.arg=o.arg,i.delegate=null,h;var a=o.arg;return a?a.done?(i[t.resultName]=a.value,i.next=t.nextLoc,"return"!==i.method&&(i.method="next",i.arg=e),i.delegate=null,h):a:(i.method="throw",i.arg=new TypeError("iterator result is not an object"),i.delegate=null,h)}function pushTryEntry(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function resetTryEntry(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function Context(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(pushTryEntry,this),this.reset(!0)}function values(t){if(t||""===t){var i=t[a];if(i)return i.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,o=function next(){for(;++r<t.length;)if(n.call(t,r))return next.value=t[r],next.done=!1,next;return next.value=e,next.done=!0,next};return o.next=o}}throw new TypeError(typeof t+" is not iterable")}return GeneratorFunction.prototype=GeneratorFunctionPrototype,r(y,"constructor",{value:GeneratorFunctionPrototype,configurable:!0}),r(GeneratorFunctionPrototype,"constructor",{value:GeneratorFunction,configurable:!0}),GeneratorFunction.displayName=define(GeneratorFunctionPrototype,u,"GeneratorFunction"),t.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===GeneratorFunction||"GeneratorFunction"===(t.displayName||t.name))},t.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,GeneratorFunctionPrototype):(e.__proto__=GeneratorFunctionPrototype,define(e,u,"GeneratorFunction")),e.prototype=Object.create(y),e},t.awrap=function(e){return{__await:e}},defineIteratorMethods(AsyncIterator.prototype),define(AsyncIterator.prototype,s,(function(){return this})),t.AsyncIterator=AsyncIterator,t.async=function(e,i,n,r,o){void 0===o&&(o=Promise);var a=new AsyncIterator(wrap(e,i,n,r),o);return t.isGeneratorFunction(i)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},defineIteratorMethods(y),define(y,u,"Generator"),define(y,a,(function(){return this})),define(y,"toString",(function(){return"[object Generator]"})),t.keys=function(e){var t=Object(e),i=[];for(var n in t)i.push(n);return i.reverse(),function next(){for(;i.length;){var e=i.pop();if(e in t)return next.value=e,next.done=!1,next}return next.done=!0,next}},t.values=values,Context.prototype={constructor:Context,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(resetTryEntry),!t)for(var i in this)"t"===i.charAt(0)&&n.call(this,i)&&!isNaN(+i.slice(1))&&(this[i]=e)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var i=this;function handle(n,r){return a.type="throw",a.arg=t,i.next=n,r&&(i.method="next",i.arg=e),!!r}for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r],a=o.completion;if("root"===o.tryLoc)return handle("end");if(o.tryLoc<=this.prev){var s=n.call(o,"catchLoc"),u=n.call(o,"finallyLoc");if(s&&u){if(this.prev<o.catchLoc)return handle(o.catchLoc,!0);if(this.prev<o.finallyLoc)return handle(o.finallyLoc)}else if(s){if(this.prev<o.catchLoc)return handle(o.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return handle(o.finallyLoc)}}}},abrupt:function(e,t){for(var i=this.tryEntries.length-1;i>=0;--i){var r=this.tryEntries[i];if(r.tryLoc<=this.prev&&n.call(r,"finallyLoc")&&this.prev<r.finallyLoc){var o=r;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=e,a.arg=t,o?(this.method="next",this.next=o.finallyLoc,h):this.complete(a)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),h},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var i=this.tryEntries[t];if(i.finallyLoc===e)return this.complete(i.completion,i.afterLoc),resetTryEntry(i),h}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var i=this.tryEntries[t];if(i.tryLoc===e){var n=i.completion;if("throw"===n.type){var r=n.arg;resetTryEntry(i)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(t,i,n){return this.delegate={iterator:values(t),resultName:i,nextLoc:n},"next"===this.method&&(this.arg=e),h}},t}function _typeof(e){return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_typeof(e)}function asyncGeneratorStep(e,t,i,n,r,o,a){try{var s=e[o](a),u=s.value}catch(e){return void i(e)}s.done?t(u):Promise.resolve(u).then(n,r)}function _asyncToGenerator(e){return function(){var t=this,i=arguments;return new Promise((function(n,r){var o=e.apply(t,i);function _next(e){asyncGeneratorStep(o,n,r,_next,_throw,"next",e)}function _throw(e){asyncGeneratorStep(o,n,r,_next,_throw,"throw",e)}_next(void 0)}))}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,_toPropertyKey(n.key),n)}}function _createClass(e,t,i){return t&&_defineProperties(e.prototype,t),i&&_defineProperties(e,i),Object.defineProperty(e,"prototype",{writable:!1}),e}function _defineProperty(e,t,i){return(t=_toPropertyKey(t))in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&_setPrototypeOf(e,t)}function _getPrototypeOf(e){return _getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf.bind():function _getPrototypeOf(e){return e.__proto__||Object.getPrototypeOf(e)},_getPrototypeOf(e)}function _setPrototypeOf(e,t){return _setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function _setPrototypeOf(e,t){return e.__proto__=t,e},_setPrototypeOf(e,t)}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _createSuper(e){var t=function _isNativeReflectConstruct(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function _createSuperInternal(){var i,n=_getPrototypeOf(e);if(t){var r=_getPrototypeOf(this).constructor;i=Reflect.construct(n,arguments,r)}else i=n.apply(this,arguments);return function _possibleConstructorReturn(e,t){if(t&&("object"==typeof t||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(e)}(this,i)}}function _get(){return _get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function _get(e,t,i){var n=function _superPropBase(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=_getPrototypeOf(e)););return e}(e,t);if(n){var r=Object.getOwnPropertyDescriptor(n,t);return r.get?r.get.call(arguments.length<3?e:i):r.value}},_get.apply(this,arguments)}function _slicedToArray(e,t){return function _arrayWithHoles(e){if(Array.isArray(e))return e}(e)||function _iterableToArrayLimit(e,t){var i=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=i){var n,r,o,a,s=[],u=!0,l=!1;try{if(o=(i=i.call(e)).next,0===t){if(Object(i)!==i)return;u=!1}else for(;!(u=(n=o.call(i)).done)&&(s.push(n.value),s.length!==t);u=!0);}catch(e){l=!0,r=e}finally{try{if(!u&&null!=i.return&&(a=i.return(),Object(a)!==a))return}finally{if(l)throw r}}return s}}(e,t)||_unsupportedIterableToArray(e,t)||function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _unsupportedIterableToArray(e,t){if(e){if("string"==typeof e)return _arrayLikeToArray(e,t);var i=Object.prototype.toString.call(e).slice(8,-1);return"Object"===i&&e.constructor&&(i=e.constructor.name),"Map"===i||"Set"===i?Array.from(e):"Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i)?_arrayLikeToArray(e,t):void 0}}function _arrayLikeToArray(e,t){(null==t||t>e.length)&&(t=e.length);for(var i=0,n=new Array(t);i<t;i++)n[i]=e[i];return n}function _createForOfIteratorHelper(e,t){var i="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!i){if(Array.isArray(e)||(i=_unsupportedIterableToArray(e))||t&&e&&"number"==typeof e.length){i&&(e=i);var n=0,F=function(){};return{s:F,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,o=!0,a=!1;return{s:function(){i=i.call(e)},n:function(){var e=i.next();return o=e.done,e},e:function(e){a=!0,r=e},f:function(){try{o||null==i.return||i.return()}finally{if(a)throw r}}}}function _toPropertyKey(e){var t=function _toPrimitive(e,t){if("object"!=typeof e||null===e)return e;var i=e[Symbol.toPrimitive];if(void 0!==i){var n=i.call(e,t||"default");if("object"!=typeof n)return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==typeof t?t:String(t)}var n=function(e){_inherits(ParticleEmitter,e);var t=_createSuper(ParticleEmitter);function ParticleEmitter(e){var i;return _classCallCheck(this,ParticleEmitter),_defineProperty(_assertThisInitialized(i=t.call(this)),"type","ParticleEmitter"),_defineProperty(_assertThisInitialized(i),"system",void 0),i.system=e,i}return _createClass(ParticleEmitter,[{key:"clone",value:function clone(){var e=this.system.clone();return e.emitter.copy(this,!0),e.emitter}},{key:"dispose",value:function dispose(){}},{key:"extractFromCache",value:function extractFromCache(e){var t=[];for(var i in e){var n=e[i];delete n.metadata,t.push(n)}return t}},{key:"toJSON",value:function toJSON(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=void 0===e||"string"==typeof e,n={};i&&(e={geometries:{},materials:{},textures:{},images:{},shapes:{},skeletons:{},animations:{},nodes:{}},n.metadata={version:4.5,type:"Object",generator:"Object3D.toJSON"});var r={};if(r.uuid=this.uuid,r.type=this.type,""!==this.name&&(r.name=this.name),!0===this.castShadow&&(r.castShadow=!0),!0===this.receiveShadow&&(r.receiveShadow=!0),!1===this.visible&&(r.visible=!1),!1===this.frustumCulled&&(r.frustumCulled=!1),0!==this.renderOrder&&(r.renderOrder=this.renderOrder),"{}"!==JSON.stringify(this.userData)&&(r.userData=this.userData),r.layers=this.layers.mask,r.matrix=this.matrix.toArray(),!1===this.matrixAutoUpdate&&(r.matrixAutoUpdate=!1),null!==this.system&&(r.ps=this.system.toJSON(e,t)),this.children.length>0){r.children=[];for(var o=0;o<this.children.length;o++)"ParticleSystemPreview"!==this.children[o].type&&r.children.push(this.children[o].toJSON(e).object)}if(i){var a=this.extractFromCache(e.geometries),s=this.extractFromCache(e.materials),u=this.extractFromCache(e.textures),l=this.extractFromCache(e.images);a.length>0&&(n.geometries=a),s.length>0&&(n.materials=s),u.length>0&&(n.textures=u),l.length>0&&(n.images=l)}return n.object=r,n}}]),ParticleEmitter}(t.Object3D),r=function(){function LinkedListNode(e){_classCallCheck(this,LinkedListNode),_defineProperty(this,"data",void 0),_defineProperty(this,"next",void 0),_defineProperty(this,"prev",void 0),this.data=e,this.next=null,this.prev=null}return _createClass(LinkedListNode,[{key:"hasPrev",value:function hasPrev(){return null!==this.prev}},{key:"hasNext",value:function hasNext(){return null!==this.next}}]),LinkedListNode}(),o=function(){function LinkedList(){_classCallCheck(this,LinkedList),_defineProperty(this,"length",void 0),_defineProperty(this,"head",void 0),_defineProperty(this,"tail",void 0),this.length=0,this.head=this.tail=null}return _createClass(LinkedList,[{key:"isEmpty",value:function isEmpty(){return null===this.head}},{key:"clear",value:function clear(){this.length=0,this.head=this.tail=null}},{key:"front",value:function front(){return null===this.head?null:this.head.data}},{key:"back",value:function back(){return null===this.tail?null:this.tail.data}},{key:"dequeue",value:function dequeue(){if(this.head){var e=this.head.data;return this.head=this.head.next,this.head?this.head.prev=null:this.tail=null,this.length--,e}}},{key:"pop",value:function pop(){if(this.tail){var e=this.tail.data;return this.tail=this.tail.prev,this.tail?this.tail.next=null:this.head=null,this.length--,e}}},{key:"queue",value:function queue(e){var t=new r(e);this.tail||(this.tail=t),this.head&&(this.head.prev=t,t.next=this.head),this.head=t,this.length++}},{key:"push",value:function push(e){var t=new r(e);this.head||(this.head=t),this.tail&&(this.tail.next=t,t.prev=this.tail),this.tail=t,this.length++}},{key:"insertBefore",value:function insertBefore(e,t){var i=new r(t);i.next=e,i.prev=e.prev,null!==i.prev&&(i.prev.next=i),i.next.prev=i,e==this.head&&(this.head=i),this.length++}},{key:"remove",value:function remove(e){if(null!==this.head&&null!==this.tail){var t=this.head;for(e===this.head.data&&(this.head=this.head.next),e===this.tail.data&&(this.tail=this.tail.prev);null!==t.next&&t.data!==e;)t=t.next;t.data===e&&(null!==t.prev&&(t.prev.next=t.next),null!==t.next&&(t.next.prev=t.prev),this.length--)}}},{key:"values",value:_regeneratorRuntime().mark((function values(){var e;return _regeneratorRuntime().wrap((function values$(t){for(;;)switch(t.prev=t.next){case 0:e=this.head;case 1:if(null===e){t.next=7;break}return t.next=4,e.data;case 4:e=e.next,t.next=1;break;case 7:case"end":return t.stop()}}),values,this)}))}]),LinkedList}(),a=function(){function NodeParticle(){_classCallCheck(this,NodeParticle),_defineProperty(this,"position",new t.Vector3),_defineProperty(this,"velocity",new t.Vector3),_defineProperty(this,"age",0),_defineProperty(this,"life",1),_defineProperty(this,"size",1),_defineProperty(this,"angularVelocity",void 0),_defineProperty(this,"rotation",0),_defineProperty(this,"color",new t.Vector4(1,1,1,1)),_defineProperty(this,"uvTile",0)}return _createClass(NodeParticle,[{key:"died",get:function get(){return this.age>=this.life}},{key:"reset",value:function reset(){this.position.set(0,0,0),this.velocity.set(0,0,0),this.age=0,this.life=1,this.size=1,this.rotation=0,this.color.set(1,1,1,1),this.uvTile=0}}]),NodeParticle}(),s=function(){function SpriteParticle(){_classCallCheck(this,SpriteParticle),_defineProperty(this,"parentMatrix",void 0),_defineProperty(this,"startSpeed",0),_defineProperty(this,"startColor",new t.Vector4),_defineProperty(this,"startSize",1),_defineProperty(this,"position",new t.Vector3),_defineProperty(this,"velocity",new t.Vector3),_defineProperty(this,"age",0),_defineProperty(this,"life",1),_defineProperty(this,"size",1),_defineProperty(this,"speedModifier",1),_defineProperty(this,"angularVelocity",void 0),_defineProperty(this,"rotation",0),_defineProperty(this,"color",new t.Vector4),_defineProperty(this,"uvTile",0)}return _createClass(SpriteParticle,[{key:"died",get:function get(){return this.age>=this.life}}]),SpriteParticle}(),u=_createClass((function RecordState(e,t,i){_classCallCheck(this,RecordState),this.position=e,this.size=t,this.color=i})),l=function(){function TrailParticle(){_classCallCheck(this,TrailParticle),_defineProperty(this,"parentMatrix",void 0),_defineProperty(this,"startSpeed",0),_defineProperty(this,"startColor",new t.Vector4),_defineProperty(this,"startSize",1),_defineProperty(this,"position",new t.Vector3),_defineProperty(this,"localPosition",void 0),_defineProperty(this,"velocity",new t.Vector3),_defineProperty(this,"age",0),_defineProperty(this,"life",1),_defineProperty(this,"size",1),_defineProperty(this,"length",100),_defineProperty(this,"speedModifier",1),_defineProperty(this,"color",new t.Vector4),_defineProperty(this,"previous",new o),_defineProperty(this,"uvTile",0)}return _createClass(TrailParticle,[{key:"update",value:function update(){for(this.age<=this.life?this.previous.push(new u(this.position.clone(),this.size,this.color.clone())):this.previous.length>0&&this.previous.dequeue();this.previous.length>this.length;)this.previous.dequeue()}},{key:"died",get:function get(){return this.age>=this.life}},{key:"reset",value:function reset(){this.previous.clear()}}]),TrailParticle}(),c=function(){function Bezier(e,t,i,n){_classCallCheck(this,Bezier),_defineProperty(this,"p",void 0),this.p=[e,t,i,n]}return _createClass(Bezier,[{key:"genValue",value:function genValue(e){var t=e*e,i=e*e*e,n=1-e,r=n*n,o=r*n;return this.p[0]*o+this.p[1]*r*e*3+this.p[2]*n*t*3+this.p[3]*i}},{key:"derivativeCoefficients",value:function derivativeCoefficients(e){for(var t=[],i=e,n=i.length-1;n>0;n--){for(var r=[],o=0;o<n;o++){var a=n*(i[o+1]-i[o]);r.push(a)}t.push(r),i=r}return t}},{key:"getSlope",value:function getSlope(e){var t=this.derivativeCoefficients(this.p)[0],i=1-e,n=i*e*2,r=e*e;return i*i*t[0]+n*t[1]+r*t[2]}},{key:"controlCurve",value:function controlCurve(e,t){this.p[1]=e/3+this.p[0],this.p[2]=this.p[3]-t/3}},{key:"hull",value:function hull(e){var t,i=this.p,n=[],r=0,o=0,a=0,s=[];for(s[r++]=i[0],s[r++]=i[1],s[r++]=i[2],s[r++]=i[3];i.length>1;){for(n=[],o=0,a=i.length-1;o<a;o++)t=e*i[o]+(1-e)*i[o+1],s[r++]=t,n.push(t);i=n}return s}},{key:"split",value:function split(e){var t=this.hull(e);return{left:new Bezier(t[0],t[4],t[7],t[9]),right:new Bezier(t[9],t[8],t[6],t[3]),span:t}}},{key:"clone",value:function clone(){return new Bezier(this.p[0],this.p[1],this.p[2],this.p[3])}},{key:"toJSON",value:function toJSON(){return{p0:this.p[0],p1:this.p[1],p2:this.p[2],p3:this.p[3]}}}],[{key:"fromJSON",value:function fromJSON(e){return new Bezier(e.p0,e.p1,e.p2,e.p3)}}]),Bezier}(),d=function ColorToJSON(e){return{r:e.x,g:e.y,b:e.z,a:e.w}},f=function JSONToColor(e){return new t.Vector4(e.r,e.g,e.b,e.a)},h=function JSONToValue(e,i){switch(i){case"Vector3":return new t.Vector3(e.x,e.y,e.z);case"Vector4":return new t.Vector4(e.x,e.y,e.z,e.w);case"Color":return new t.Vector3(e.r,e.g,e.b);default:return e}},p=function ValueToJSON(e,t){switch(t){case"Vector3":return{x:e.x,y:e.y,z:e.z};case"Vector4":return{x:e.x,y:e.y,z:e.z,w:e.w};case"Color":return{r:e.x,g:e.y,b:e.z};default:return e}},m=function(){function RandomColor(e,t){_classCallCheck(this,RandomColor),_defineProperty(this,"type",void 0),this.a=e,this.b=t,this.type="value"}return _createClass(RandomColor,[{key:"genColor",value:function genColor(e){var t=Math.random();return e.copy(this.a).lerp(this.b,t)}},{key:"toJSON",value:function toJSON(){return{type:"RandomColor",a:d(this.a),b:d(this.b)}}},{key:"clone",value:function clone(){return new RandomColor(this.a.clone(),this.b.clone())}}],[{key:"fromJSON",value:function fromJSON(e){return new RandomColor(f(e.a),f(e.b))}}]),RandomColor}(),v=function(){function ColorRange(e,t){_classCallCheck(this,ColorRange),_defineProperty(this,"type",void 0),this.a=e,this.b=t,this.type="value"}return _createClass(ColorRange,[{key:"genColor",value:function genColor(e,t){return e.copy(this.a).lerp(this.b,Math.random())}},{key:"toJSON",value:function toJSON(){return{type:"ColorRange",a:d(this.a),b:d(this.b)}}},{key:"clone",value:function clone(){return new ColorRange(this.a.clone(),this.b.clone())}}],[{key:"fromJSON",value:function fromJSON(e){return new ColorRange(f(e.a),f(e.b))}}]),ColorRange}(),y=function(){function ContinuousLinearFunction(e,t){_classCallCheck(this,ContinuousLinearFunction),_defineProperty(this,"keys",void 0),_defineProperty(this,"type",void 0),_defineProperty(this,"subType",void 0),this.subType=t,this.type="function",this.keys=e}return _createClass(ContinuousLinearFunction,[{key:"findKey",value:function findKey(e){for(var t=0,i=0,n=this.keys.length-1;i+1<n;)if(t=Math.floor((i+n)/2),e<this.getStartX(t))n=t-1;else{if(!(e>this.getEndX(t)))return t;i=t+1}for(var r=i;r<=n;r++)if(e>=this.getStartX(r)&&e<=this.getEndX(r))return r;return-1}},{key:"getStartX",value:function getStartX(e){return this.keys[e][1]}},{key:"getEndX",value:function getEndX(e){return e+1<this.keys.length?this.keys[e+1][1]:1}},{key:"genValue",value:function genValue(e,t){var i=this.findKey(t);return"Number"===this.subType?-1===i?this.keys[0][0]:i+1>=this.keys.length?this.keys[this.keys.length-1][0]:(this.keys[i+1][0]-this.keys[i][0])*((t-this.getStartX(i))/(this.getEndX(i)-this.getStartX(i)))+this.keys[i][0]:-1===i?e.copy(this.keys[0][0]):i+1>=this.keys.length?e.copy(this.keys[this.keys.length-1][0]):e.copy(this.keys[i][0]).lerp(this.keys[i+1][0],(t-this.getStartX(i))/(this.getEndX(i)-this.getStartX(i)))}},{key:"toJSON",value:function toJSON(){var e=this;return this.keys[0][0].constructor.name,{type:"CLinearFunction",subType:this.subType,keys:this.keys.map((function(t){var i=_slicedToArray(t,2),n=i[0],r=i[1];return{value:p(n,e.subType),pos:r}}))}}},{key:"clone",value:function clone(){return"Number"===this.subType?new ContinuousLinearFunction(this.keys.map((function(e){var t=_slicedToArray(e,2);return[t[0],t[1]]})),this.subType):new ContinuousLinearFunction(this.keys.map((function(e){var t=_slicedToArray(e,2),i=t[0],n=t[1];return[i.clone(),n]})),this.subType)}}],[{key:"fromJSON",value:function fromJSON(e){return new ContinuousLinearFunction(e.keys.map((function(t){return[h(t.value,e.subType),t.pos]})),e.subType)}}]),ContinuousLinearFunction}(),g=new t.Vector3,S=function(){function Gradient(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[[new t.Vector3(0,0,0),0],[new t.Vector3(1,1,1),0]],i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[[1,0],[1,1]];_classCallCheck(this,Gradient),_defineProperty(this,"type",void 0),_defineProperty(this,"color",void 0),_defineProperty(this,"alpha",void 0),this.type="function",this.color=new y(e,"Color"),this.alpha=new y(i,"Number")}return _createClass(Gradient,[{key:"genColor",value:function genColor(e,t){return this.color.genValue(g,t),e.set(g.x,g.y,g.z,this.alpha.genValue(1,t))}},{key:"toJSON",value:function toJSON(){return{type:"Gradient",color:this.color.toJSON(),alpha:this.alpha.toJSON()}}},{key:"clone",value:function clone(){var e=new Gradient;return e.alpha=this.alpha.clone(),e.color=this.color.clone(),e}}],[{key:"fromJSON",value:function fromJSON(e){if(e.functions){var i=e.functions.map((function(e){return[v.fromJSON(e.function).a,e.start]}));return e.functions.length>0&&i.push([v.fromJSON(e.functions[e.functions.length-1].function).b,1]),new Gradient(i.map((function(e){return[new t.Vector3(e[0].x,e[0].y,e[0].z),e[1]]})),i.map((function(e){return[e[0].w,e[1]]})))}var n=new Gradient;return n.alpha=y.fromJSON(e.alpha),n.color=y.fromJSON(e.color),n}}]),Gradient}(),_=new t.Vector4,x=function(){function RandomColorBetweenGradient(e,t){_classCallCheck(this,RandomColorBetweenGradient),_defineProperty(this,"gradient1",void 0),_defineProperty(this,"gradient2",void 0),_defineProperty(this,"type",void 0),this.type="memorizedFunction",this.gradient1=e,this.gradient2=t}return _createClass(RandomColorBetweenGradient,[{key:"startGen",value:function startGen(e){e.rand=Math.random()}},{key:"genColor",value:function genColor(e,t,i){return this.gradient1.genColor(e,t),this.gradient2.genColor(_,t),i&&i.rand?e.lerp(_,i.rand):e.lerp(_,Math.random()),e}},{key:"toJSON",value:function toJSON(){return{type:"RandomColorBetweenGradient",gradient1:this.gradient1.toJSON(),gradient2:this.gradient2.toJSON()}}},{key:"clone",value:function clone(){return new RandomColorBetweenGradient(this.gradient1.clone(),this.gradient2.clone())}}],[{key:"fromJSON",value:function fromJSON(e){return new RandomColorBetweenGradient(S.fromJSON(e.gradient1),S.fromJSON(e.gradient2))}}]),RandomColorBetweenGradient}(),P=function(){function ConstantColor(e){_classCallCheck(this,ConstantColor),_defineProperty(this,"type",void 0),this.color=e,this.type="value"}return _createClass(ConstantColor,[{key:"genColor",value:function genColor(e){return e.copy(this.color)}},{key:"toJSON",value:function toJSON(){return{type:"ConstantColor",color:d(this.color)}}},{key:"clone",value:function clone(){return new ConstantColor(this.color.clone())}}],[{key:"fromJSON",value:function fromJSON(e){return new ConstantColor(f(e.color))}}]),ConstantColor}();function ColorGeneratorFromJSON(e){switch(e.type){case"ConstantColor":return P.fromJSON(e);case"ColorRange":return v.fromJSON(e);case"RandomColor":return m.fromJSON(e);case"Gradient":return S.fromJSON(e);case"RandomColorBetweenGradient":return x.fromJSON(e);default:return new P(new t.Vector4(1,1,1,1))}}var b=function(){function ConstantValue(e){_classCallCheck(this,ConstantValue),_defineProperty(this,"type",void 0),this.value=e,this.type="value"}return _createClass(ConstantValue,[{key:"genValue",value:function genValue(){return this.value}},{key:"toJSON",value:function toJSON(){return{type:"ConstantValue",value:this.value}}},{key:"clone",value:function clone(){return new ConstantValue(this.value)}}],[{key:"fromJSON",value:function fromJSON(e){return new ConstantValue(e.value)}}]),ConstantValue}(),w=function(){function IntervalValue(e,t){_classCallCheck(this,IntervalValue),_defineProperty(this,"type",void 0),this.a=e,this.b=t,this.type="value"}return _createClass(IntervalValue,[{key:"genValue",value:function genValue(){return t.MathUtils.lerp(this.a,this.b,Math.random())}},{key:"toJSON",value:function toJSON(){return{type:"IntervalValue",a:this.a,b:this.b}}},{key:"clone",value:function clone(){return new IntervalValue(this.a,this.b)}}],[{key:"fromJSON",value:function fromJSON(e){return new IntervalValue(e.a,e.b)}}]),IntervalValue}(),O=function(){function PiecewiseFunction(){_classCallCheck(this,PiecewiseFunction),_defineProperty(this,"functions",void 0),this.functions=new Array}return _createClass(PiecewiseFunction,[{key:"findFunction",value:function findFunction(e){for(var t=0,i=0,n=this.functions.length-1;i+1<n;)if(t=Math.floor((i+n)/2),e<this.getStartX(t))n=t-1;else{if(!(e>this.getEndX(t)))return t;i=t+1}for(var r=i;r<=n;r++)if(e>=this.functions[r][1]&&e<=this.getEndX(r))return r;return-1}},{key:"getStartX",value:function getStartX(e){return this.functions[e][1]}},{key:"setStartX",value:function setStartX(e,t){e>0&&(this.functions[e][1]=t)}},{key:"getEndX",value:function getEndX(e){return e+1<this.functions.length?this.functions[e+1][1]:1}},{key:"setEndX",value:function setEndX(e,t){e+1<this.functions.length&&(this.functions[e+1][1]=t)}},{key:"insertFunction",value:function insertFunction(e,t){var i=this.findFunction(e);this.functions.splice(i+1,0,[t,e])}},{key:"removeFunction",value:function removeFunction(e){return this.functions.splice(e,1)[0][0]}},{key:"getFunction",value:function getFunction(e){return this.functions[e][0]}},{key:"setFunction",value:function setFunction(e,t){this.functions[e][0]=t}},{key:"numOfFunctions",get:function get(){return this.functions.length}}]),PiecewiseFunction}(),N=function(e){_inherits(PiecewiseBezier,e);var t=_createSuper(PiecewiseBezier);function PiecewiseBezier(){var e,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[[new c(0,1/3,1/3*2,1),0]];return _classCallCheck(this,PiecewiseBezier),_defineProperty(_assertThisInitialized(e=t.call(this)),"type",void 0),e.type="function",e.functions=i,e}return _createClass(PiecewiseBezier,[{key:"genValue",value:function genValue(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,t=this.findFunction(e);return-1===t?0:this.functions[t][0].genValue((e-this.getStartX(t))/(this.getEndX(t)-this.getStartX(t)))}},{key:"toSVG",value:function toSVG(e,t){if(t<1)return"";for(var i=["M",0,this.functions[0][0].p[0]].join(" "),n=1/t;n<=1;n+=1/t)i=[i,"L",n*e,this.genValue(n)].join(" ");return i}},{key:"toJSON",value:function toJSON(){return{type:"PiecewiseBezier",functions:this.functions.map((function(e){var t=_slicedToArray(e,2),i=t[0],n=t[1];return{function:i.toJSON(),start:n}}))}}},{key:"clone",value:function clone(){return new PiecewiseBezier(this.functions.map((function(e){var t=_slicedToArray(e,2),i=t[0],n=t[1];return[i.clone(),n]})))}}],[{key:"fromJSON",value:function fromJSON(e){return new PiecewiseBezier(e.functions.map((function(e){return[c.fromJSON(e.function),e.start]})))}}]),PiecewiseBezier}(O);function ValueGeneratorFromJSON(e){switch(e.type){case"ConstantValue":return b.fromJSON(e);case"IntervalValue":return w.fromJSON(e);case"PiecewiseBezier":return N.fromJSON(e);default:return new b(0)}}var M=function(){function RandomQuatGenerator(){_classCallCheck(this,RandomQuatGenerator),_defineProperty(this,"type",void 0),this.type="rotation"}return _createClass(RandomQuatGenerator,[{key:"genValue",value:function genValue(e,t){var i,n,r,o,a,s;do{r=(i=2*Math.random()-1)*i+(n=2*Math.random()-1)*n}while(r>1);do{s=(o=2*Math.random()-1)*o+(a=2*Math.random()-1)*a}while(s>1);var u=Math.sqrt((1-r)/s);return e.set(i,n,u*o,u*a),e}},{key:"toJSON",value:function toJSON(){return{type:"RandomQuat"}}},{key:"clone",value:function clone(){return new RandomQuatGenerator}}],[{key:"fromJSON",value:function fromJSON(e){return new RandomQuatGenerator}}]),RandomQuatGenerator}(),k=function(){function AxisAngleGenerator(e,t){_classCallCheck(this,AxisAngleGenerator),_defineProperty(this,"type",void 0),this.axis=e,this.angle=t,this.type="rotation"}return _createClass(AxisAngleGenerator,[{key:"genValue",value:function genValue(e,t){return e.setFromAxisAngle(this.axis,this.angle.genValue(t))}},{key:"toJSON",value:function toJSON(){return{type:"AxisAngle",axis:{x:this.axis.x,y:this.axis.y,z:this.axis.z},angle:this.angle.toJSON()}}},{key:"clone",value:function clone(){return new AxisAngleGenerator(this.axis.clone(),this.angle.clone())}}],[{key:"fromJSON",value:function fromJSON(e){return new AxisAngleGenerator(new t.Vector3(e.axis.x,e.axis.y,e.axis.z),ValueGeneratorFromJSON(e.angle))}}]),AxisAngleGenerator}(),C=function(){function EulerGenerator(e,i,n,r){_classCallCheck(this,EulerGenerator),_defineProperty(this,"type",void 0),_defineProperty(this,"eular",void 0),this.angleX=e,this.angleY=i,this.angleZ=n,this.type="rotation",this.eular=new t.Euler(0,0,0,r)}return _createClass(EulerGenerator,[{key:"genValue",value:function genValue(e,t){return this.eular.set(this.angleX.genValue(t),this.angleY.genValue(t),this.angleZ.genValue(t)),e.setFromEuler(this.eular)}},{key:"toJSON",value:function toJSON(){return{type:"Euler",angleX:this.angleX.toJSON(),angleY:this.angleY.toJSON(),angleZ:this.angleZ.toJSON(),eulerOrder:this.eular.order}}},{key:"clone",value:function clone(){return new EulerGenerator(this.angleX,this.angleY,this.angleZ,this.eular.order)}}],[{key:"fromJSON",value:function fromJSON(e){return new EulerGenerator(ValueGeneratorFromJSON(e.angleX),ValueGeneratorFromJSON(e.angleY),ValueGeneratorFromJSON(e.angleZ),e.eulerOrder)}}]),EulerGenerator}();function RotationGeneratorFromJSON(e){switch(e.type){case"AxisAngle":return k.fromJSON(e);case"Euler":return C.fromJSON(e);case"RandomQuat":return M.fromJSON(e);default:return new M}}function GeneratorFromJSON(e){switch(e.type){case"ConstantValue":case"IntervalValue":case"PiecewiseBezier":return ValueGeneratorFromJSON(e);case"AxisAngle":case"RandomQuat":case"Euler":return RotationGeneratorFromJSON(e);default:return new b(0)}}var T=function(){function ColorOverLife(e){_classCallCheck(this,ColorOverLife),_defineProperty(this,"type","ColorOverLife"),this.color=e}return _createClass(ColorOverLife,[{key:"initialize",value:function initialize(e){"memorizedFunction"===this.color.type&&(e.colorOverLifeMemory={},this.color.startGen(e.colorOverLifeMemory))}},{key:"update",value:function update(e,t){"memorizedFunction"===this.color.type?this.color.genColor(e.color,e.age/e.life,e.colorOverLifeMemory):this.color.genColor(e.color,e.age/e.life),e.color.x*=e.startColor.x,e.color.y*=e.startColor.y,e.color.z*=e.startColor.z,e.color.w*=e.startColor.w}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,color:this.color.toJSON()}}},{key:"clone",value:function clone(){return new ColorOverLife(this.color.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new ColorOverLife(ColorGeneratorFromJSON(e.color))}}]),ColorOverLife}(),E=function(){function RotationOverLife(e){_classCallCheck(this,RotationOverLife),_defineProperty(this,"type","RotationOverLife"),_defineProperty(this,"dynamic",void 0),this.angularVelocity=e,this.dynamic=!(e instanceof b||e instanceof w)}return _createClass(RotationOverLife,[{key:"initialize",value:function initialize(e){this.dynamic=!(this.angularVelocity instanceof b||this.angularVelocity instanceof w),this.dynamic||"number"!=typeof e.rotation||(e.angularVelocity=this.angularVelocity.genValue())}},{key:"update",value:function update(e,t){this.dynamic?"number"==typeof e.rotation&&(e.rotation+=t*this.angularVelocity.genValue(e.age/e.life)):"number"==typeof e.rotation&&(e.rotation+=t*e.angularVelocity)}},{key:"toJSON",value:function toJSON(){return{type:this.type,angularVelocity:this.angularVelocity.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new RotationOverLife(this.angularVelocity.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new RotationOverLife(ValueGeneratorFromJSON(e.angularVelocity))}}]),RotationOverLife}(),B=new t.Quaternion,V=function(){function Rotation3DOverLife(e){_classCallCheck(this,Rotation3DOverLife),_defineProperty(this,"type","Rotation3DOverLife"),_defineProperty(this,"tempQuat",new t.Quaternion),_defineProperty(this,"dynamic",void 0),this.angularVelocity=e,this.dynamic=!(e instanceof M)}return _createClass(Rotation3DOverLife,[{key:"initialize",value:function initialize(e){this.dynamic=!(this.angularVelocity instanceof M),e.rotation instanceof t.Quaternion&&(e.angularVelocity=new t.Quaternion,this.angularVelocity.genValue(e.angularVelocity))}},{key:"update",value:function update(e,i){e.rotation instanceof t.Quaternion&&(this.dynamic?(this.angularVelocity.genValue(this.tempQuat,e.age/e.life),this.tempQuat.slerpQuaternions(B,this.tempQuat,i),e.rotation.multiply(this.tempQuat)):(this.tempQuat.slerpQuaternions(B,e.angularVelocity,i),e.rotation.multiply(this.tempQuat)))}},{key:"toJSON",value:function toJSON(){return{type:this.type,angularVelocity:this.angularVelocity.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new Rotation3DOverLife(this.angularVelocity.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new Rotation3DOverLife(RotationGeneratorFromJSON(e.angularVelocity))}}]),Rotation3DOverLife}(),A=function(){function ForceOverLife(e,i,n){_classCallCheck(this,ForceOverLife),_defineProperty(this,"type","ForceOverLife"),_defineProperty(this,"_temp",new t.Vector3),_defineProperty(this,"ps",void 0),_defineProperty(this,"_tempScale",new t.Vector3),_defineProperty(this,"_tempQ",new t.Quaternion),this.x=e,this.y=i,this.z=n}return _createClass(ForceOverLife,[{key:"initialize",value:function initialize(e,t){this.ps=t}},{key:"update",value:function update(e,t){this._temp.set(this.x.genValue(e.age/e.life),this.y.genValue(e.age/e.life),this.z.genValue(e.age/e.life)),this.ps.worldSpace||this._temp.multiply(this._tempScale).applyQuaternion(this._tempQ),e.velocity.addScaledVector(this._temp,t)}},{key:"toJSON",value:function toJSON(){return{type:this.type,x:this.x.toJSON(),y:this.y.toJSON(),z:this.z.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){if(this.ps&&!this.ps.worldSpace){var t=this._temp,i=this._tempQ,n=this._tempScale;this.ps.emitter.matrixWorld.decompose(t,i,n),i.invert(),n.set(1/n.x,1/n.y,1/n.z)}}},{key:"clone",value:function clone(){return new ForceOverLife(this.x.clone(),this.y.clone(),this.z.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new ForceOverLife(ValueGeneratorFromJSON(e.x),ValueGeneratorFromJSON(e.y),ValueGeneratorFromJSON(e.z))}}]),ForceOverLife}(),U=function(){function SizeOverLife(e){_classCallCheck(this,SizeOverLife),_defineProperty(this,"type","SizeOverLife"),this.size=e}return _createClass(SizeOverLife,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e){e.size=e.startSize*this.size.genValue(e.age/e.life)}},{key:"toJSON",value:function toJSON(){return{type:this.type,size:this.size.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new SizeOverLife(this.size.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new SizeOverLife(ValueGeneratorFromJSON(e.size))}}]),SizeOverLife}(),z=function(){function SpeedOverLife(e){_classCallCheck(this,SpeedOverLife),_defineProperty(this,"type","SpeedOverLife"),this.speed=e}return _createClass(SpeedOverLife,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e){e.speedModifier=this.speed.genValue(e.age/e.life)}},{key:"toJSON",value:function toJSON(){return{type:this.type,speed:this.speed.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new SpeedOverLife(this.speed.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new SpeedOverLife(ValueGeneratorFromJSON(e.speed))}}]),SpeedOverLife}(),I=function(){function FrameOverLife(e){_classCallCheck(this,FrameOverLife),_defineProperty(this,"type","FrameOverLife"),this.frame=e}return _createClass(FrameOverLife,[{key:"initialize",value:function initialize(e){this.frame instanceof N||(e.uvTile=this.frame.genValue(0))}},{key:"update",value:function update(e,t){this.frame instanceof N&&(e.uvTile=this.frame.genValue(e.age/e.life))}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,frame:this.frame.toJSON()}}},{key:"clone",value:function clone(){return new FrameOverLife(this.frame.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new FrameOverLife(ValueGeneratorFromJSON(e.frame))}}]),FrameOverLife}();new t.Vector3(0,0,1);var R=function(){function OrbitOverLife(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:new t.Vector3(0,1,0);_classCallCheck(this,OrbitOverLife),_defineProperty(this,"type","OrbitOverLife"),_defineProperty(this,"rotation",void 0),_defineProperty(this,"line",void 0),_defineProperty(this,"temp",new t.Vector3),this.orbitSpeed=e,this.axis=i,this.rotation=new t.Quaternion,this.line=new t.Line3}return _createClass(OrbitOverLife,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,i){this.line.set(new t.Vector3(0,0,0),this.axis),this.line.closestPointToPoint(e.position,!1,this.temp),this.rotation.setFromAxisAngle(this.axis,this.orbitSpeed.genValue(e.age/e.life)*i),e.position.sub(this.temp),e.position.applyQuaternion(this.rotation),e.position.add(this.temp)}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,orbitSpeed:this.orbitSpeed.toJSON(),axis:[this.axis.x,this.axis.y,this.axis.z]}}},{key:"clone",value:function clone(){return new OrbitOverLife(this.orbitSpeed.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new OrbitOverLife(ValueGeneratorFromJSON(e.orbitSpeed),e.axis?new t.Vector3(e.axis[0],e.axis[1],e.axis[2]):void 0)}}]),OrbitOverLife}(),L=function(){function WidthOverLength(e){_classCallCheck(this,WidthOverLength),_defineProperty(this,"type","WidthOverLength"),this.width=e}return _createClass(WidthOverLength,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e){if(e instanceof l)for(var t=e.previous.values(),i=0;i<e.previous.length;i++)t.next().value.size=this.width.genValue((e.previous.length-i)/e.length)}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,width:this.width.toJSON()}}},{key:"clone",value:function clone(){return new WidthOverLength(this.width.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new WidthOverLength(ValueGeneratorFromJSON(e.width))}}]),WidthOverLength}(),J=function(){function ApplyForce(e,t){_classCallCheck(this,ApplyForce),_defineProperty(this,"type","ApplyForce"),_defineProperty(this,"magnitudeValue",void 0),this.direction=e,this.magnitude=t,this.magnitudeValue=this.magnitude.genValue()}return _createClass(ApplyForce,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){e.velocity.addScaledVector(this.direction,this.magnitudeValue*t)}},{key:"frameUpdate",value:function frameUpdate(e){this.magnitudeValue=this.magnitude.genValue()}},{key:"toJSON",value:function toJSON(){return{type:this.type,direction:[this.direction.x,this.direction.y,this.direction.z],magnitude:this.magnitude.toJSON()}}},{key:"clone",value:function clone(){return new ApplyForce(this.direction.clone(),this.magnitude.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){var i;return new ApplyForce(new t.Vector3(e.direction[0],e.direction[1],e.direction[2]),ValueGeneratorFromJSON(null!==(i=e.magnitude)&&void 0!==i?i:e.force))}}]),ApplyForce}(),G=function(){function GravityForce(e,i){_classCallCheck(this,GravityForce),_defineProperty(this,"type","GravityForce"),_defineProperty(this,"temp",new t.Vector3),this.center=e,this.magnitude=i}return _createClass(GravityForce,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){this.temp.copy(this.center).sub(e.position).normalize(),e.velocity.addScaledVector(this.temp,this.magnitude/e.position.distanceToSquared(this.center)*t)}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,center:[this.center.x,this.center.y,this.center.z],magnitude:this.magnitude}}},{key:"clone",value:function clone(){return new GravityForce(this.center.clone(),this.magnitude)}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new GravityForce(new t.Vector3(e.center[0],e.center[1],e.center[2]),e.magnitude)}}]),GravityForce}();new t.Vector3(0,0,1);var D=function(){function ChangeEmitDirection(e){_classCallCheck(this,ChangeEmitDirection),_defineProperty(this,"type","ChangeEmitDirection"),_defineProperty(this,"_temp",new t.Vector3),_defineProperty(this,"_q",new t.Quaternion),this.angle=e}return _createClass(ChangeEmitDirection,[{key:"initialize",value:function initialize(e){var t=e.velocity.length();0!=t&&(e.velocity.normalize(),0===e.velocity.x&&0===e.velocity.y?this._temp.set(0,e.velocity.z,0):this._temp.set(-e.velocity.y,e.velocity.x,0),this._q.setFromAxisAngle(this._temp.normalize(),this.angle.genValue()),this._temp.copy(e.velocity),e.velocity.applyQuaternion(this._q),this._q.setFromAxisAngle(this._temp,Math.random()*Math.PI*2),e.velocity.applyQuaternion(this._q),e.velocity.setLength(t))}},{key:"update",value:function update(e,t){}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,angle:this.angle.toJSON()}}},{key:"clone",value:function clone(){return new ChangeEmitDirection(this.angle)}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new ChangeEmitDirection(ValueGeneratorFromJSON(e.angle))}}]),ChangeEmitDirection}(),q=new t.Vector3(1,1,1),W=new t.Vector3(0,0,1),j=function(e){return e[e.Death=0]="Death",e[e.Birth=1]="Birth",e[e.Frame=2]="Frame",e}({}),H=function(){function EmitSubParticleSystem(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:j.Frame,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1;_classCallCheck(this,EmitSubParticleSystem),_defineProperty(this,"type","EmitSubParticleSystem"),_defineProperty(this,"q_",new t.Quaternion),_defineProperty(this,"v_",new t.Vector3),_defineProperty(this,"v2_",new t.Vector3),_defineProperty(this,"subEmissions",new Array),this.particleSystem=e,this.useVelocityAsBasis=i,this.subParticleSystem=n,this.mode=r,this.emitProbability=o,this.subParticleSystem&&this.subParticleSystem.system&&(this.subParticleSystem.system.onlyUsedByOther=!0)}return _createClass(EmitSubParticleSystem,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){(this.mode===j.Frame||this.mode===j.Birth&&0===e.age||this.mode===j.Death&&e.age+t>=e.life)&&this.emit(e,t)}},{key:"emit",value:function emit(e,i){if(this.subParticleSystem&&!(Math.random()>this.emitProbability)){var n=new t.Matrix4;this.setMatrixFromParticle(n,e),this.subEmissions.push({burstParticleCount:0,burstParticleIndex:0,isBursting:!1,burstIndex:0,burstWaveIndex:0,time:0,waitEmiting:0,matrix:n,travelDistance:0,particle:e})}}},{key:"frameUpdate",value:function frameUpdate(e){if(this.subParticleSystem)for(var t=0;t<this.subEmissions.length;t++)if(this.subEmissions[t].time>=this.subParticleSystem.system.duration)this.subEmissions[t]=this.subEmissions[this.subEmissions.length-1],this.subEmissions.length=this.subEmissions.length-1,t--;else{var i=this.subEmissions[t];i.particle&&i.particle.age<i.particle.life?this.setMatrixFromParticle(i.matrix,i.particle):i.particle=void 0,this.subParticleSystem.system.emit(e,i,i.matrix)}}},{key:"toJSON",value:function toJSON(){return{type:this.type,subParticleSystem:this.subParticleSystem?this.subParticleSystem.uuid:"",useVelocityAsBasis:this.useVelocityAsBasis,mode:this.mode,emitProbability:this.emitProbability}}},{key:"clone",value:function clone(){return new EmitSubParticleSystem(this.particleSystem,this.useVelocityAsBasis,this.subParticleSystem,this.mode,this.emitProbability)}},{key:"reset",value:function reset(){}},{key:"setMatrixFromParticle",value:function setMatrixFromParticle(e,i){var n;if(void 0===i.rotation||this.useVelocityAsBasis)if(0!==i.velocity.x||0!==i.velocity.y||1!==i.velocity.z&&0!==i.velocity.z){this.v_.copy(W).cross(i.velocity),this.v2_.copy(i.velocity).cross(this.v_);var r=this.v_.length(),o=this.v2_.length();e.set(this.v_.x/r,this.v2_.x/o,i.velocity.x,i.position.x,this.v_.y/r,this.v2_.y/o,i.velocity.y,i.position.y,this.v_.z/r,this.v2_.z/o,i.velocity.z,i.position.z,0,0,0,1)}else e.set(1,0,0,i.position.x,0,1,0,i.position.y,0,0,1,i.position.z,0,0,0,1);else i.rotation instanceof t.Quaternion?n=i.rotation:(this.q_.setFromAxisAngle(W,i.rotation),n=this.q_),e.compose(i.position,n,q);this.particleSystem.worldSpace||e.multiplyMatrices(this.particleSystem.emitter.matrixWorld,e)}}],[{key:"fromJSON",value:function fromJSON(e,t){return new EmitSubParticleSystem(t,e.useVelocityAsBasis,e.subParticleSystem,e.mode,e.emitProbability)}}]),EmitSubParticleSystem}(),X=.5*(Math.sqrt(3)-1),Q=(3-Math.sqrt(3))/6,Y=1/6,Z=(Math.sqrt(5)-1)/4,K=(5-Math.sqrt(5))/20,$=new Float32Array([1,1,0,-1,1,0,1,-1,0,-1,-1,0,1,0,1,-1,0,1,1,0,-1,-1,0,-1,0,1,1,0,-1,1,0,1,-1,0,-1,-1]),ee=new Float32Array([0,1,1,1,0,1,1,-1,0,1,-1,1,0,1,-1,-1,0,-1,1,1,0,-1,1,-1,0,-1,-1,1,0,-1,-1,-1,1,0,1,1,1,0,1,-1,1,0,-1,1,1,0,-1,-1,-1,0,1,1,-1,0,1,-1,-1,0,-1,1,-1,0,-1,-1,1,1,0,1,1,1,0,-1,1,-1,0,1,1,-1,0,-1,-1,1,0,1,-1,1,0,-1,-1,-1,0,1,-1,-1,0,-1,1,1,1,0,1,1,-1,0,1,-1,1,0,1,-1,-1,0,-1,1,1,0,-1,1,-1,0,-1,-1,1,0,-1,-1,-1,0]),te=function(){function SimplexNoise(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:Math.random;_classCallCheck(this,SimplexNoise),_defineProperty(this,"p",void 0),_defineProperty(this,"perm",void 0),_defineProperty(this,"permMod12",void 0);var t="function"==typeof e?e:function alea(e){var t=0,i=0,n=0,r=1,o=function masher(){var e=4022871197;return function(t){t=t.toString();for(var i=0;i<t.length;i++){var n=.02519603282416938*(e+=t.charCodeAt(i));n-=e=n>>>0,e=(n*=e)>>>0,e+=4294967296*(n-=e)}return 2.3283064365386963e-10*(e>>>0)}}();return t=o(" "),i=o(" "),n=o(" "),(t-=o(e))<0&&(t+=1),(i-=o(e))<0&&(i+=1),(n-=o(e))<0&&(n+=1),function(){var e=2091639*t+2.3283064365386963e-10*r;return t=i,i=n,n=e-(r=0|e)}}(e);this.p=function buildPermutationTable(e){for(var t=new Uint8Array(256),i=0;i<256;i++)t[i]=i;for(var n=0;n<255;n++){var r=n+~~(e()*(256-n)),o=t[n];t[n]=t[r],t[r]=o}return t}(t),this.perm=new Uint8Array(512),this.permMod12=new Uint8Array(512);for(var i=0;i<512;i++)this.perm[i]=this.p[255&i],this.permMod12[i]=this.perm[i]%12}return _createClass(SimplexNoise,[{key:"noise2D",value:function noise2D(e,t){var i,n,r=this.permMod12,o=this.perm,a=0,s=0,u=0,l=(e+t)*X,c=Math.floor(e+l),d=Math.floor(t+l),f=(c+d)*Q,h=e-(c-f),p=t-(d-f);h>p?(i=1,n=0):(i=0,n=1);var m=h-i+Q,v=p-n+Q,y=h-1+2*Q,g=p-1+2*Q,S=255&c,_=255&d,x=.5-h*h-p*p;if(x>=0){var P=3*r[S+o[_]];a=(x*=x)*x*($[P]*h+$[P+1]*p)}var b=.5-m*m-v*v;if(b>=0){var w=3*r[S+i+o[_+n]];s=(b*=b)*b*($[w]*m+$[w+1]*v)}var O=.5-y*y-g*g;if(O>=0){var N=3*r[S+1+o[_+1]];u=(O*=O)*O*($[N]*y+$[N+1]*g)}return 70*(a+s+u)}},{key:"noise3D",value:function noise3D(e,t,i){var n,r,o,a,s,u,l,c,d,f,h=this.permMod12,p=this.perm,m=.3333333333333333*(e+t+i),v=Math.floor(e+m),y=Math.floor(t+m),g=Math.floor(i+m),S=(v+y+g)*Y,_=e-(v-S),x=t-(y-S),P=i-(g-S);_>=x?x>=P?(s=1,u=0,l=0,c=1,d=1,f=0):_>=P?(s=1,u=0,l=0,c=1,d=0,f=1):(s=0,u=0,l=1,c=1,d=0,f=1):x<P?(s=0,u=0,l=1,c=0,d=1,f=1):_<P?(s=0,u=1,l=0,c=0,d=1,f=1):(s=0,u=1,l=0,c=1,d=1,f=0);var b=_-s+Y,w=x-u+Y,O=P-l+Y,N=_-c+2*Y,M=x-d+2*Y,k=P-f+2*Y,C=_-1+.5,T=x-1+.5,E=P-1+.5,B=255&v,V=255&y,A=255&g,U=.6-_*_-x*x-P*P;if(U<0)n=0;else{var z=3*h[B+p[V+p[A]]];n=(U*=U)*U*($[z]*_+$[z+1]*x+$[z+2]*P)}var I=.6-b*b-w*w-O*O;if(I<0)r=0;else{var R=3*h[B+s+p[V+u+p[A+l]]];r=(I*=I)*I*($[R]*b+$[R+1]*w+$[R+2]*O)}var L=.6-N*N-M*M-k*k;if(L<0)o=0;else{var J=3*h[B+c+p[V+d+p[A+f]]];o=(L*=L)*L*($[J]*N+$[J+1]*M+$[J+2]*k)}var G=.6-C*C-T*T-E*E;if(G<0)a=0;else{var D=3*h[B+1+p[V+1+p[A+1]]];a=(G*=G)*G*($[D]*C+$[D+1]*T+$[D+2]*E)}return 32*(n+r+o+a)}},{key:"noise4D",value:function noise4D(e,t,i,n){var r,o,a,s,u,l=this.perm,c=(e+t+i+n)*Z,d=Math.floor(e+c),f=Math.floor(t+c),h=Math.floor(i+c),p=Math.floor(n+c),m=(d+f+h+p)*K,v=e-(d-m),y=t-(f-m),g=i-(h-m),S=n-(p-m),_=0,x=0,P=0,b=0;v>y?_++:x++,v>g?_++:P++,v>S?_++:b++,y>g?x++:P++,y>S?x++:b++,g>S?P++:b++;var w=_>=3?1:0,O=x>=3?1:0,N=P>=3?1:0,M=b>=3?1:0,k=_>=2?1:0,C=x>=2?1:0,T=P>=2?1:0,E=b>=2?1:0,B=_>=1?1:0,V=x>=1?1:0,A=P>=1?1:0,U=b>=1?1:0,z=v-w+K,I=y-O+K,R=g-N+K,L=S-M+K,J=v-k+2*K,G=y-C+2*K,D=g-T+2*K,q=S-E+2*K,W=v-B+3*K,j=y-V+3*K,H=g-A+3*K,X=S-U+3*K,Q=v-1+4*K,Y=y-1+4*K,$=g-1+4*K,te=S-1+4*K,ie=255&d,ne=255&f,re=255&h,oe=255&p,ae=.6-v*v-y*y-g*g-S*S;if(ae<0)r=0;else{var se=l[ie+l[ne+l[re+l[oe]]]]%32*4;r=(ae*=ae)*ae*(ee[se]*v+ee[se+1]*y+ee[se+2]*g+ee[se+3]*S)}var ue=.6-z*z-I*I-R*R-L*L;if(ue<0)o=0;else{var le=l[ie+w+l[ne+O+l[re+N+l[oe+M]]]]%32*4;o=(ue*=ue)*ue*(ee[le]*z+ee[le+1]*I+ee[le+2]*R+ee[le+3]*L)}var ce=.6-J*J-G*G-D*D-q*q;if(ce<0)a=0;else{var de=l[ie+k+l[ne+C+l[re+T+l[oe+E]]]]%32*4;a=(ce*=ce)*ce*(ee[de]*J+ee[de+1]*G+ee[de+2]*D+ee[de+3]*q)}var fe=.6-W*W-j*j-H*H-X*X;if(fe<0)s=0;else{var he=l[ie+B+l[ne+V+l[re+A+l[oe+U]]]]%32*4;s=(fe*=fe)*fe*(ee[he]*W+ee[he+1]*j+ee[he+2]*H+ee[he+3]*X)}var pe=.6-Q*Q-Y*Y-$*$-te*te;if(pe<0)u=0;else{var me=l[ie+1+l[ne+1+l[re+1+l[oe+1]]]]%32*4;u=(pe*=pe)*pe*(ee[me]*Q+ee[me+1]*Y+ee[me+2]*$+ee[me+3]*te)}return 27*(r+o+a+s+u)}}]),SimplexNoise}(),ie=function(){function TurbulenceField(e,i,n,r){_classCallCheck(this,TurbulenceField),_defineProperty(this,"type","TurbulenceField"),_defineProperty(this,"generator",new te),_defineProperty(this,"timeOffset",new t.Vector3),_defineProperty(this,"temp",new t.Vector3),_defineProperty(this,"temp2",new t.Vector3),this.scale=e,this.octaves=i,this.velocityMultiplier=n,this.timeScale=r,this.timeOffset.x=Math.random()/this.scale.x*this.timeScale.x,this.timeOffset.y=Math.random()/this.scale.y*this.timeScale.y,this.timeOffset.z=Math.random()/this.scale.z*this.timeScale.z}return _createClass(TurbulenceField,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){var i=e.position.x/this.scale.x,n=e.position.y/this.scale.y,r=e.position.z/this.scale.z;this.temp.set(0,0,0);for(var o=1,a=0;a<this.octaves;a++)this.temp2.set(this.generator.noise4D(i*o,n*o,r*o,this.timeOffset.x*o)/o,this.generator.noise4D(i*o,n*o,r*o,this.timeOffset.y*o)/o,this.generator.noise4D(i*o,n*o,r*o,this.timeOffset.z*o)/o),this.temp.add(this.temp2),o*=2;this.temp.multiply(this.velocityMultiplier),e.velocity.addScaledVector(this.temp,t)}},{key:"toJSON",value:function toJSON(){return{type:this.type,scale:[this.scale.x,this.scale.y,this.scale.z],octaves:this.octaves,velocityMultiplier:[this.velocityMultiplier.x,this.velocityMultiplier.y,this.velocityMultiplier.z],timeScale:[this.timeScale.x,this.timeScale.y,this.timeScale.z]}}},{key:"frameUpdate",value:function frameUpdate(e){this.timeOffset.x+=e*this.timeScale.x,this.timeOffset.y+=e*this.timeScale.y,this.timeOffset.z+=e*this.timeScale.z}},{key:"clone",value:function clone(){return new TurbulenceField(this.scale.clone(),this.octaves,this.velocityMultiplier.clone(),this.timeScale.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new TurbulenceField(new t.Vector3(e.scale[0],e.scale[1],e.scale[2]),e.octaves,new t.Vector3(e.velocityMultiplier[0],e.velocityMultiplier[1],e.velocityMultiplier[2]),new t.Vector3(e.timeScale[0],e.timeScale[1],e.timeScale[2]))}}]),TurbulenceField}();function randomInt(e,t){return Math.floor(Math.random()*(t-e))+e}var ne=[],re=new t.Vector3,oe=new t.Quaternion,ae=function(){function Noise(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:new b(1),n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:new b(0);if(_classCallCheck(this,Noise),_defineProperty(this,"type","Noise"),_defineProperty(this,"duration",0),this.frequency=e,this.power=t,this.positionAmount=i,this.rotationAmount=n,0===ne.length)for(var r=0;r<100;r++)ne.push(new te)}return _createClass(Noise,[{key:"initialize",value:function initialize(e){e.lastPosNoise=new t.Vector3,"number"==typeof e.rotation?e.lastRotNoise=0:e.lastRotNoise=new t.Quaternion,e.generatorIndex=[randomInt(0,100),randomInt(0,100),randomInt(0,100),randomInt(0,100)]}},{key:"update",value:function update(e,t){var i=this.frequency.genValue(e.age/e.life),n=this.power.genValue(e.age/e.life),r=this.positionAmount.genValue(e.age/e.life),o=this.rotationAmount.genValue(e.age/e.life);r>0&&void 0!==e.lastPosNoise&&(e.position.sub(e.lastPosNoise),re.set(ne[e.generatorIndex[0]].noise2D(0,e.age*i)*n*r,ne[e.generatorIndex[1]].noise2D(0,e.age*i)*n*r,ne[e.generatorIndex[2]].noise2D(0,e.age*i)*n*r),e.position.add(re),e.lastPosNoise.copy(re)),o>0&&void 0!==e.lastRotNoise&&("number"==typeof e.rotation?(e.rotation-=e.lastRotNoise,e.rotation+=ne[e.generatorIndex[3]].noise2D(0,e.age*i)*Math.PI*n*o):(e.lastRotNoise.invert(),e.rotation.multiply(e.lastRotNoise),oe.set(ne[e.generatorIndex[0]].noise2D(0,e.age*i)*n*o,ne[e.generatorIndex[1]].noise2D(0,e.age*i)*n*o,ne[e.generatorIndex[2]].noise2D(0,e.age*i)*n*o,ne[e.generatorIndex[3]].noise2D(0,e.age*i)*n*o).normalize(),e.rotation.multiply(oe),e.lastRotNoise.copy(oe)))}},{key:"toJSON",value:function toJSON(){return{type:this.type,frequency:this.frequency.toJSON(),power:this.power.toJSON(),positionAmount:this.positionAmount.toJSON(),rotationAmount:this.rotationAmount.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){this.duration+=e}},{key:"clone",value:function clone(){return new Noise(this.frequency.clone(),this.power.clone(),this.positionAmount.clone(),this.rotationAmount.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new Noise(ValueGeneratorFromJSON(e.frequency),ValueGeneratorFromJSON(e.power),ValueGeneratorFromJSON(e.positionAmount),ValueGeneratorFromJSON(e.rotationAmount))}}]),Noise}(),se=function(){function TextureSequencer(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:new t.Vector3;_classCallCheck(this,TextureSequencer),_defineProperty(this,"locations",[]),this.scaleX=e,this.scaleY=i,this.position=n}return _createClass(TextureSequencer,[{key:"transform",value:function transform(e,t){e.x=this.locations[t%this.locations.length].x*this.scaleX+this.position.x,e.y=this.locations[t%this.locations.length].y*this.scaleY+this.position.y,e.z=this.position.z}},{key:"clone",value:function clone(){var e=new TextureSequencer(this.scaleX,this.scaleY,this.position.clone());return e.locations=this.locations.map((function(e){return e.clone()})),e}},{key:"toJSON",value:function toJSON(){return{scaleX:this.scaleX,scaleY:this.scaleY,position:this.position,locations:this.locations.map((function(e){return{x:e.x,y:e.y}}))}}},{key:"fromImage",value:function fromImage(e,i){var n=document.createElement("canvas");n.width=e.width,n.height=e.height;var r=n.getContext("2d");if(r){r.drawImage(e,0,0);var o=r.getImageData(0,0,n.width,n.height,{colorSpace:"srgb"});n.remove(),this.locations.length=0;for(var a=0;a<o.height;a++)for(var s=0;s<o.width;s++)o.data[4*(a*o.width+s)+3]>i&&this.locations.push(new t.Vector2(s,o.height-a))}}}],[{key:"fromJSON",value:function fromJSON(e){var i=new TextureSequencer(e.scaleX,e.scaleY,new t.Vector3(e.position[0],e.position[1],e.position[2]));return i.locations=e.locations.map((function(e){return new t.Vector2(e.x,e.y)})),i}}]),TextureSequencer}();function SequencerFromJSON(e){return"TextureSequencer"===e.type?se.fromJSON(e):new se}var ue,le=function(){function ApplySequences(e){_classCallCheck(this,ApplySequences),_defineProperty(this,"type","ApplySequences"),_defineProperty(this,"sequencers",[]),_defineProperty(this,"time",0),_defineProperty(this,"index",0),_defineProperty(this,"pCount",0),_defineProperty(this,"delay",void 0),_defineProperty(this,"tempV",new t.Vector3),this.delay=e}return _createClass(ApplySequences,[{key:"initialize",value:function initialize(e){e.id=this.pCount,e.dst=new t.Vector3,e.begin=new t.Vector3,e.inMotion=!1,this.pCount++}},{key:"reset",value:function reset(){this.time=0,this.index=0,this.pCount=0}},{key:"update",value:function update(e,t){var i=this.sequencers[this.index],n=e.id*this.delay;this.time>=i[0].a+n&&this.time<=i[0].b+n?(e.inMotion||(e.inMotion=!0,e.begin.copy(e.position),i[1].transform(e.dst,e.id)),e.position.lerpVectors(e.begin,e.dst,ApplySequences.BEZIER.genValue((this.time-i[0].a-n)/(i[0].b-i[0].a)))):this.time>i[0].b+n&&(e.inMotion=!1)}},{key:"frameUpdate",value:function frameUpdate(e){for(;this.index+1<this.sequencers.length&&this.time>=this.sequencers[this.index+1][0].a;)this.index++;this.time+=e}},{key:"appendSequencer",value:function appendSequencer(e,t){this.sequencers.push([e,t])}},{key:"toJSON",value:function toJSON(){return{type:this.type,delay:this.delay,sequencers:this.sequencers.map((function(e){var t=_slicedToArray(e,2),i=t[0],n=t[1];return{range:i.toJSON(),sequencer:n.toJSON()}}))}}},{key:"clone",value:function clone(){var e=new ApplySequences(this.delay);return e.sequencers=this.sequencers.map((function(e){return[e[0].clone(),e[1].clone()]})),e}}],[{key:"fromJSON",value:function fromJSON(e){var t=new ApplySequences(e.delay);return e.sequencers.forEach((function(e){t.sequencers.push([ValueGeneratorFromJSON(e.range),SequencerFromJSON(e.sequencer)])})),t}}]),ApplySequences}();function getPhysicsResolver(){return ue}_defineProperty(le,"BEZIER",new c(0,0,1,1));var ce=function(){function ApplyCollision(e,i){_classCallCheck(this,ApplyCollision),_defineProperty(this,"type","ApplyCollision"),_defineProperty(this,"tempV",new t.Vector3),this.resolver=e,this.bounce=i}return _createClass(ApplyCollision,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){this.resolver.resolve(e.position,this.tempV)&&e.velocity.reflect(this.tempV).multiplyScalar(this.bounce)}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,bounce:this.bounce}}},{key:"clone",value:function clone(){return new ApplyCollision(this.resolver,this.bounce)}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new ApplyCollision(getPhysicsResolver(),e.bounce)}}]),ApplyCollision}(),de=function(){function ColorBySpeed(e,t){_classCallCheck(this,ColorBySpeed),_defineProperty(this,"type","ColorBySpeed"),this.color=e,this.speedRange=t}return _createClass(ColorBySpeed,[{key:"initialize",value:function initialize(e){"memorizedFunction"===this.color.type&&(e.colorOverLifeMemory={},this.color.startGen(e.colorOverLifeMemory))}},{key:"update",value:function update(e,t){var i=(e.startSpeed-this.speedRange.a)/(this.speedRange.b-this.speedRange.a);"memorizedFunction"===this.color.type?this.color.genColor(e.color,i,e.colorOverLifeMemory):this.color.genColor(e.color,i),e.color.x*=e.startColor.x,e.color.y*=e.startColor.y,e.color.z*=e.startColor.z,e.color.w*=e.startColor.w}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"toJSON",value:function toJSON(){return{type:this.type,color:this.color.toJSON(),speedRange:this.speedRange.toJSON()}}},{key:"clone",value:function clone(){return new ColorBySpeed(this.color.clone(),this.speedRange.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new ColorBySpeed(ColorGeneratorFromJSON(e.color),w.fromJSON(e.speedRange))}}]),ColorBySpeed}(),fe=function(){function SizeBySpeed(e,t){_classCallCheck(this,SizeBySpeed),_defineProperty(this,"type","SizeBySpeed"),this.size=e,this.speedRange=t}return _createClass(SizeBySpeed,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e){var t=(e.startSpeed-this.speedRange.a)/(this.speedRange.b-this.speedRange.a);e.size=e.startSize*this.size.genValue(t)}},{key:"toJSON",value:function toJSON(){return{type:this.type,size:this.size.toJSON(),speedRange:this.speedRange.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new SizeBySpeed(this.size.clone(),this.speedRange.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new SizeBySpeed(ValueGeneratorFromJSON(e.size),w.fromJSON(e.speedRange))}}]),SizeBySpeed}(),he=function(){function RotationBySpeed(e,i){_classCallCheck(this,RotationBySpeed),_defineProperty(this,"type","RotationBySpeed"),_defineProperty(this,"tempQuat",new t.Quaternion),this.angularVelocity=e,this.speedRange=i}return _createClass(RotationBySpeed,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){var i=(e.startSpeed-this.speedRange.a)/(this.speedRange.b-this.speedRange.a);e.rotation+=t*this.angularVelocity.genValue(i)}},{key:"toJSON",value:function toJSON(){return{type:this.type,angularVelocity:this.angularVelocity.toJSON(),speedRange:this.speedRange.toJSON()}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new RotationBySpeed(this.angularVelocity.clone(),this.speedRange.clone())}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new RotationBySpeed(ValueGeneratorFromJSON(e.angularVelocity),w.fromJSON(e.speedRange))}}]),RotationBySpeed}(),pe=function(){function LimitSpeedOverLife(e,t){_classCallCheck(this,LimitSpeedOverLife),_defineProperty(this,"type","LimitSpeedOverLife"),this.speed=e,this.dampen=t}return _createClass(LimitSpeedOverLife,[{key:"initialize",value:function initialize(e){}},{key:"update",value:function update(e,t){var i=e.velocity.length(),n=this.speed.genValue(e.age/e.life);if(i>n){var r=(i-n)/i;e.velocity.multiplyScalar(1-r*this.dampen*t*20)}}},{key:"toJSON",value:function toJSON(){return{type:this.type,speed:this.speed.toJSON(),dampen:this.dampen}}},{key:"frameUpdate",value:function frameUpdate(e){}},{key:"clone",value:function clone(){return new LimitSpeedOverLife(this.speed.clone(),this.dampen)}},{key:"reset",value:function reset(){}}],[{key:"fromJSON",value:function fromJSON(e){return new LimitSpeedOverLife(ValueGeneratorFromJSON(e.speed),e.dampen)}}]),LimitSpeedOverLife}(),me={ApplyForce:{type:"ApplyForce",constructor:J,params:[["direction","vec3"],["magnitude","value"]],loadJSON:J.fromJSON},Noise:{type:"Noise",constructor:ae,params:[["frequency","value"],["power","value"],["positionAmount","value"],["rotationAmount","value"]],loadJSON:ae.fromJSON},TurbulenceField:{type:"TurbulenceField",constructor:ie,params:[["scale","vec3"],["octaves","number"],["velocityMultiplier","vec3"],["timeScale","vec3"]],loadJSON:ie.fromJSON},GravityForce:{type:"GravityForce",constructor:G,params:[["center","vec3"],["magnitude","number"]],loadJSON:G.fromJSON},ColorOverLife:{type:"ColorOverLife",constructor:T,params:[["color","colorFunc"]],loadJSON:T.fromJSON},RotationOverLife:{type:"RotationOverLife",constructor:E,params:[["angularVelocity","valueFunc"]],loadJSON:E.fromJSON},Rotation3DOverLife:{type:"Rotation3DOverLife",constructor:V,params:[["angularVelocity","rotationFunc"]],loadJSON:V.fromJSON},SizeOverLife:{type:"SizeOverLife",constructor:U,params:[["size","valueFunc"]],loadJSON:U.fromJSON},ColorBySpeed:{type:"ColorBySpeed",constructor:de,params:[["color","colorFunc"],["speedRange","range"]],loadJSON:de.fromJSON},RotationBySpeed:{type:"RotationBySpeed",constructor:he,params:[["angularVelocity","valueFunc"],["speedRange","range"]],loadJSON:he.fromJSON},SizeBySpeed:{type:"SizeBySpeed",constructor:fe,params:[["size","valueFunc"],["speedRange","range"]],loadJSON:fe.fromJSON},SpeedOverLife:{type:"SpeedOverLife",constructor:z,params:[["speed","valueFunc"]],loadJSON:z.fromJSON},FrameOverLife:{type:"FrameOverLife",constructor:I,params:[["frame","valueFunc"]],loadJSON:I.fromJSON},ForceOverLife:{type:"ForceOverLife",constructor:A,params:[["x","valueFunc"],["y","valueFunc"],["z","valueFunc"]],loadJSON:A.fromJSON},OrbitOverLife:{type:"OrbitOverLife",constructor:R,params:[["orbitSpeed","valueFunc"],["axis","vec3"]],loadJSON:R.fromJSON},WidthOverLength:{type:"WidthOverLength",constructor:L,params:[["width","valueFunc"]],loadJSON:L.fromJSON},ChangeEmitDirection:{type:"ChangeEmitDirection",constructor:D,params:[["angle","value"]],loadJSON:D.fromJSON},EmitSubParticleSystem:{type:"EmitSubParticleSystem",constructor:H,params:[["particleSystem","self"],["useVelocityAsBasis","boolean"],["subParticleSystem","particleSystem"],["mode","number"],["emitProbability","number"]],loadJSON:H.fromJSON},LimitSpeedOverLife:{type:"LimitSpeedOverLife",constructor:pe,params:[["speed","valueFunc"],["dampen","number"]],loadJSON:pe.fromJSON}};function BehaviorFromJSON(e,t){return me[e.type].loadJSON(e,t)}var ve=function(e){return e[e.Random=0]="Random",e[e.Loop=1]="Loop",e[e.PingPong=2]="PingPong",e[e.Burst=3]="Burst",e}({});function getValueFromEmitterMode(e,t,i,n){var r;switch(ve.Random===e?t=Math.random():ve.Burst===e&&n.isBursting&&(t=n.burstParticleIndex/n.burstParticleCount),r=i>0?Math.floor(t/i)*i:t,e){case ve.Loop:r%=1;break;case ve.PingPong:r=Math.abs(r%2-1)}return r}var ye=function(){function ConeEmitter(){var e,t,i,n,r,o,a,s=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,ConeEmitter),_defineProperty(this,"type","cone"),_defineProperty(this,"radius",void 0),_defineProperty(this,"arc",void 0),_defineProperty(this,"thickness",void 0),_defineProperty(this,"angle",void 0),_defineProperty(this,"mode",void 0),_defineProperty(this,"spread",void 0),_defineProperty(this,"speed",void 0),_defineProperty(this,"currentValue",0),this.radius=null!==(e=s.radius)&&void 0!==e?e:10,this.arc=null!==(t=s.arc)&&void 0!==t?t:2*Math.PI,this.thickness=null!==(i=s.thickness)&&void 0!==i?i:1,this.angle=null!==(n=s.angle)&&void 0!==n?n:Math.PI/6,this.mode=null!==(r=s.mode)&&void 0!==r?r:ve.Random,this.spread=null!==(o=s.spread)&&void 0!==o?o:0,this.speed=null!==(a=s.speed)&&void 0!==a?a:new b(1)}return _createClass(ConeEmitter,[{key:"update",value:function update(e,t){ve.Random!=this.mode&&(this.currentValue+=this.speed.genValue(e.emissionState.time/e.duration)*t)}},{key:"initialize",value:function initialize(e,i){var n=getValueFromEmitterMode(this.mode,this.currentValue,this.spread,i),r=t.MathUtils.lerp(1-this.thickness,1,Math.random()),o=n*this.arc,a=Math.sqrt(r),s=Math.sin(o),u=Math.cos(o);e.position.x=a*u,e.position.y=a*s,e.position.z=0;var l=this.angle*a;e.velocity.set(0,0,Math.cos(l)).addScaledVector(e.position,Math.sin(l)).multiplyScalar(e.startSpeed),e.position.multiplyScalar(this.radius)}},{key:"toJSON",value:function toJSON(){return{type:"cone",radius:this.radius,arc:this.arc,thickness:this.thickness,angle:this.angle,mode:this.mode,spread:this.spread,speed:this.speed.toJSON()}}},{key:"clone",value:function clone(){return new ConeEmitter({radius:this.radius,arc:this.arc,thickness:this.thickness,angle:this.angle,mode:this.mode,speed:this.speed.clone(),spread:this.spread})}}],[{key:"fromJSON",value:function fromJSON(e){return new ConeEmitter({radius:e.radius,arc:e.arc,thickness:e.thickness,angle:e.angle,mode:e.mode,speed:e.speed?ValueGeneratorFromJSON(e.speed):void 0,spread:e.spread})}}]),ConeEmitter}(),ge=function(){function CircleEmitter(){var e,t,i,n,r,o,a=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,CircleEmitter),_defineProperty(this,"type","circle"),_defineProperty(this,"radius",void 0),_defineProperty(this,"arc",void 0),_defineProperty(this,"thickness",void 0),_defineProperty(this,"mode",void 0),_defineProperty(this,"spread",void 0),_defineProperty(this,"speed",void 0),_defineProperty(this,"currentValue",0),this.radius=null!==(e=a.radius)&&void 0!==e?e:10,this.arc=null!==(t=a.arc)&&void 0!==t?t:2*Math.PI,this.thickness=null!==(i=a.thickness)&&void 0!==i?i:1,this.mode=null!==(n=a.mode)&&void 0!==n?n:ve.Random,this.spread=null!==(r=a.spread)&&void 0!==r?r:0,this.speed=null!==(o=a.speed)&&void 0!==o?o:new b(1)}return _createClass(CircleEmitter,[{key:"update",value:function update(e,t){this.currentValue+=this.speed.genValue(e.emissionState.time/e.duration)*t}},{key:"initialize",value:function initialize(e,i){var n=getValueFromEmitterMode(this.mode,this.currentValue,this.spread,i),r=t.MathUtils.lerp(1-this.thickness,1,Math.random()),o=n*this.arc;e.position.x=Math.cos(o),e.position.y=Math.sin(o),e.position.z=0,e.velocity.copy(e.position).multiplyScalar(e.startSpeed),e.position.multiplyScalar(this.radius*r)}},{key:"toJSON",value:function toJSON(){return{type:"circle",radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,spread:this.spread,speed:this.speed.toJSON()}}},{key:"clone",value:function clone(){return new CircleEmitter({radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,speed:this.speed.clone(),spread:this.spread})}}],[{key:"fromJSON",value:function fromJSON(e){return new CircleEmitter({radius:e.radius,arc:e.arc,thickness:e.thickness,mode:e.mode,speed:e.speed?ValueGeneratorFromJSON(e.speed):void 0,spread:e.spread})}}]),CircleEmitter}(),Se=function(){function DonutEmitter(){var e,t,i,n,r,o,a,s=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,DonutEmitter),_defineProperty(this,"type","donut"),_defineProperty(this,"radius",void 0),_defineProperty(this,"donutRadius",void 0),_defineProperty(this,"arc",void 0),_defineProperty(this,"thickness",void 0),_defineProperty(this,"mode",void 0),_defineProperty(this,"spread",void 0),_defineProperty(this,"speed",void 0),_defineProperty(this,"currentValue",0),this.radius=null!==(e=s.radius)&&void 0!==e?e:10,this.arc=null!==(t=s.arc)&&void 0!==t?t:2*Math.PI,this.thickness=null!==(i=s.thickness)&&void 0!==i?i:1,this.donutRadius=null!==(n=s.donutRadius)&&void 0!==n?n:.2*this.radius,this.mode=null!==(r=s.mode)&&void 0!==r?r:ve.Random,this.spread=null!==(o=s.spread)&&void 0!==o?o:0,this.speed=null!==(a=s.speed)&&void 0!==a?a:new b(1)}return _createClass(DonutEmitter,[{key:"update",value:function update(e,t){ve.Random!=this.mode&&(this.currentValue+=this.speed.genValue(e.emissionState.time/e.duration)*t)}},{key:"initialize",value:function initialize(e,i){var n=getValueFromEmitterMode(this.mode,this.currentValue,this.spread,i),r=Math.random(),o=t.MathUtils.lerp(1-this.thickness,1,Math.random()),a=n*this.arc,s=r*Math.PI*2,u=Math.sin(a),l=Math.cos(a);e.position.x=this.radius*l,e.position.y=this.radius*u,e.position.z=0,e.velocity.z=this.donutRadius*o*Math.sin(s),e.velocity.x=this.donutRadius*o*Math.cos(s)*l,e.velocity.y=this.donutRadius*o*Math.cos(s)*u,e.position.add(e.velocity),e.velocity.normalize().multiplyScalar(e.startSpeed)}},{key:"toJSON",value:function toJSON(){return{type:"donut",radius:this.radius,arc:this.arc,thickness:this.thickness,donutRadius:this.donutRadius,mode:this.mode,spread:this.spread,speed:this.speed.toJSON()}}},{key:"clone",value:function clone(){return new DonutEmitter({radius:this.radius,arc:this.arc,thickness:this.thickness,donutRadius:this.donutRadius,mode:this.mode,speed:this.speed.clone(),spread:this.spread})}}],[{key:"fromJSON",value:function fromJSON(e){return new DonutEmitter({radius:e.radius,arc:e.arc,thickness:e.thickness,donutRadius:e.donutRadius,mode:e.mode,speed:e.speed?ValueGeneratorFromJSON(e.speed):void 0,spread:e.spread})}}]),DonutEmitter}(),_e=function(){function PointEmitter(){_classCallCheck(this,PointEmitter),_defineProperty(this,"type","point")}return _createClass(PointEmitter,[{key:"update",value:function update(e,t){}},{key:"initialize",value:function initialize(e){var t=Math.random(),i=Math.random(),n=t*Math.PI*2,r=Math.acos(2*i-1),o=Math.cbrt(Math.random()),a=Math.sin(n),s=Math.cos(n),u=Math.sin(r),l=Math.cos(r);e.velocity.x=o*u*s,e.velocity.y=o*u*a,e.velocity.z=o*l,e.velocity.multiplyScalar(e.startSpeed),e.position.setScalar(0)}},{key:"toJSON",value:function toJSON(){return{type:"point"}}},{key:"clone",value:function clone(){return new PointEmitter}}],[{key:"fromJSON",value:function fromJSON(e){return new PointEmitter}}]),PointEmitter}(),xe=function(){function SphereEmitter(){var e,t,i,n,r,o,a=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,SphereEmitter),_defineProperty(this,"type","sphere"),_defineProperty(this,"radius",void 0),_defineProperty(this,"arc",void 0),_defineProperty(this,"thickness",void 0),_defineProperty(this,"mode",void 0),_defineProperty(this,"spread",void 0),_defineProperty(this,"speed",void 0),_defineProperty(this,"currentValue",0),this.radius=null!==(e=a.radius)&&void 0!==e?e:10,this.arc=null!==(t=a.arc)&&void 0!==t?t:2*Math.PI,this.thickness=null!==(i=a.thickness)&&void 0!==i?i:1,this.mode=null!==(n=a.mode)&&void 0!==n?n:ve.Random,this.spread=null!==(r=a.spread)&&void 0!==r?r:0,this.speed=null!==(o=a.speed)&&void 0!==o?o:new b(1)}return _createClass(SphereEmitter,[{key:"update",value:function update(e,t){ve.Random!=this.mode&&(this.currentValue+=this.speed.genValue(e.emissionState.time/e.duration)*t)}},{key:"initialize",value:function initialize(e,i){var n=getValueFromEmitterMode(this.mode,this.currentValue,this.spread,i),r=Math.random(),o=t.MathUtils.lerp(1-this.thickness,1,Math.random()),a=n*this.arc,s=Math.acos(2*r-1),u=Math.sin(a),l=Math.cos(a),c=Math.sin(s),d=Math.cos(s);e.position.x=c*l,e.position.y=c*u,e.position.z=d,e.velocity.copy(e.position).multiplyScalar(e.startSpeed),e.position.multiplyScalar(this.radius*o)}},{key:"toJSON",value:function toJSON(){return{type:"sphere",radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,spread:this.spread,speed:this.speed.toJSON()}}},{key:"clone",value:function clone(){return new SphereEmitter({radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,speed:this.speed.clone(),spread:this.spread})}}],[{key:"fromJSON",value:function fromJSON(e){return new SphereEmitter({radius:e.radius,arc:e.arc,thickness:e.thickness,mode:e.mode,speed:e.speed?ValueGeneratorFromJSON(e.speed):void 0,spread:e.spread})}}]),SphereEmitter}(),Pe=function(){function HemisphereEmitter(){var e,t,i,n,r,o,a=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,HemisphereEmitter),_defineProperty(this,"type","sphere"),_defineProperty(this,"radius",void 0),_defineProperty(this,"arc",void 0),_defineProperty(this,"thickness",void 0),_defineProperty(this,"mode",void 0),_defineProperty(this,"spread",void 0),_defineProperty(this,"speed",void 0),_defineProperty(this,"currentValue",0),this.radius=null!==(e=a.radius)&&void 0!==e?e:10,this.arc=null!==(t=a.arc)&&void 0!==t?t:2*Math.PI,this.thickness=null!==(i=a.thickness)&&void 0!==i?i:1,this.mode=null!==(n=a.mode)&&void 0!==n?n:ve.Random,this.spread=null!==(r=a.spread)&&void 0!==r?r:0,this.speed=null!==(o=a.speed)&&void 0!==o?o:new b(1)}return _createClass(HemisphereEmitter,[{key:"update",value:function update(e,t){ve.Random!=this.mode&&(this.currentValue+=this.speed.genValue(e.emissionState.time/e.duration)*t)}},{key:"initialize",value:function initialize(e,i){var n=getValueFromEmitterMode(this.mode,this.currentValue,this.spread,i),r=Math.random(),o=t.MathUtils.lerp(1-this.thickness,1,Math.random()),a=n*this.arc,s=Math.acos(r),u=Math.sin(a),l=Math.cos(a),c=Math.sin(s),d=Math.cos(s);e.position.x=c*l,e.position.y=c*u,e.position.z=d,e.velocity.copy(e.position).multiplyScalar(e.startSpeed),e.position.multiplyScalar(this.radius*o)}},{key:"toJSON",value:function toJSON(){return{type:"hemisphere",radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,spread:this.spread,speed:this.speed.toJSON()}}},{key:"clone",value:function clone(){return new HemisphereEmitter({radius:this.radius,arc:this.arc,thickness:this.thickness,mode:this.mode,speed:this.speed.clone(),spread:this.spread})}}],[{key:"fromJSON",value:function fromJSON(e){return new HemisphereEmitter({radius:e.radius,arc:e.arc,thickness:e.thickness,mode:e.mode,speed:e.speed?ValueGeneratorFromJSON(e.speed):void 0,spread:e.spread})}}]),HemisphereEmitter}(),be=function(){function GridEmitter(){var e,t,i,n,r=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,GridEmitter),_defineProperty(this,"type","grid"),_defineProperty(this,"width",void 0),_defineProperty(this,"height",void 0),_defineProperty(this,"column",void 0),_defineProperty(this,"row",void 0),this.width=null!==(e=r.width)&&void 0!==e?e:1,this.height=null!==(t=r.height)&&void 0!==t?t:1,this.column=null!==(i=r.column)&&void 0!==i?i:10,this.row=null!==(n=r.row)&&void 0!==n?n:10}return _createClass(GridEmitter,[{key:"initialize",value:function initialize(e){var t=Math.floor(Math.random()*this.row),i=Math.floor(Math.random()*this.column);e.position.x=i*this.width/this.column-this.width/2,e.position.y=t*this.height/this.row-this.height/2,e.position.z=0,e.velocity.set(0,0,e.startSpeed)}},{key:"toJSON",value:function toJSON(){return{type:"grid",width:this.width,height:this.height,column:this.column,row:this.row}}},{key:"clone",value:function clone(){return new GridEmitter({width:this.width,height:this.height,column:this.column,row:this.row})}},{key:"update",value:function update(e,t){}}],[{key:"fromJSON",value:function fromJSON(e){return new GridEmitter(e)}}]),GridEmitter}(),we=function(){function MeshSurfaceEmitter(e){_classCallCheck(this,MeshSurfaceEmitter),_defineProperty(this,"type","mesh_surface"),_defineProperty(this,"_triangleIndexToArea",[]),_defineProperty(this,"_geometry",void 0),_defineProperty(this,"_tempA",new t.Vector3),_defineProperty(this,"_tempB",new t.Vector3),_defineProperty(this,"_tempC",new t.Vector3),e&&(this.geometry=e)}return _createClass(MeshSurfaceEmitter,[{key:"geometry",get:function get(){return this._geometry},set:function set(e){if(this._geometry=e,void 0!==e&&"string"!=typeof e){var i=new t.Triangle;this._triangleIndexToArea.length=0;var n=0;if(e.getIndex()){var r=e.getIndex().array,o=r.length/3;this._triangleIndexToArea.push(0);for(var a=0;a<o;a++)i.setFromAttributeAndIndices(e.getAttribute("position"),r[3*a],r[3*a+1],r[3*a+2]),n+=i.getArea(),this._triangleIndexToArea.push(n);e.userData.triangleIndexToArea=this._triangleIndexToArea}}}},{key:"initialize",value:function initialize(e){var t=this._geometry;if(!t||null===t.getIndex())return e.position.set(0,0,0),void e.velocity.set(0,0,1).multiplyScalar(e.startSpeed);for(var i=this._triangleIndexToArea.length-1,n=0,r=i,o=Math.random()*this._triangleIndexToArea[i];n+1<r;){var a=Math.floor((n+r)/2);o<this._triangleIndexToArea[a]?r=a:n=a}var s=Math.random(),u=Math.random();s+u>1&&(s=1-s,u=1-u);var l=t.getIndex().array[3*n],c=t.getIndex().array[3*n+1],d=t.getIndex().array[3*n+2],f=t.getAttribute("position");this._tempA.fromBufferAttribute(f,l),this._tempB.fromBufferAttribute(f,c),this._tempC.fromBufferAttribute(f,d),this._tempB.sub(this._tempA),this._tempC.sub(this._tempA),this._tempA.addScaledVector(this._tempB,s).addScaledVector(this._tempC,u),e.position.copy(this._tempA),this._tempA.copy(this._tempB).cross(this._tempC).normalize(),e.velocity.copy(this._tempA).normalize().multiplyScalar(e.startSpeed)}},{key:"toJSON",value:function toJSON(){return{type:"mesh_surface",mesh:this._geometry?this._geometry.uuid:""}}},{key:"clone",value:function clone(){return new MeshSurfaceEmitter(this._geometry)}},{key:"update",value:function update(e,t){}}],[{key:"fromJSON",value:function fromJSON(e,t){return new MeshSurfaceEmitter(t.geometries[e.geometry])}}]),MeshSurfaceEmitter}(),Oe={circle:{type:"circle",params:[["radius","number"],["arc","radian"],["thickness","number"],["mode","emitterMode"],["spread","number"],["speed","valueFunc"]],constructor:ge,loadJSON:ge.fromJSON},cone:{type:"cone",params:[["radius","number"],["arc","radian"],["thickness","number"],["angle","radian"],["mode","emitterMode"],["spread","number"],["speed","valueFunc"]],constructor:ye,loadJSON:ye.fromJSON},donut:{type:"donut",params:[["radius","number"],["arc","radian"],["thickness","number"],["donutRadius","number"],["mode","emitterMode"],["spread","number"],["speed","valueFunc"]],constructor:Se,loadJSON:Se.fromJSON},point:{type:"point",params:[],constructor:_e,loadJSON:_e.fromJSON},sphere:{type:"sphere",params:[["radius","number"],["arc","radian"],["thickness","number"],["angle","radian"],["mode","emitterMode"],["spread","number"],["speed","valueFunc"]],constructor:xe,loadJSON:xe.fromJSON},hemisphere:{type:"hemisphere",params:[["radius","number"],["arc","radian"],["thickness","number"],["angle","radian"],["mode","emitterMode"],["spread","number"],["speed","valueFunc"]],constructor:Pe,loadJSON:Pe.fromJSON},grid:{type:"grid",params:[["width","number"],["height","number"],["rows","number"],["column","number"]],constructor:be,loadJSON:be.fromJSON},mesh_surface:{type:"mesh_surface",params:[["geometry","geometry"]],constructor:we,loadJSON:we.fromJSON}};function EmitterFromJSON(e,t){return Oe[e.type].loadJSON(e,t)}var Ne=function(e){return e[e.BillBoard=0]="BillBoard",e[e.StretchedBillBoard=1]="StretchedBillBoard",e[e.Mesh=2]="Mesh",e[e.Trail=3]="Trail",e[e.HorizontalBillBoard=4]="HorizontalBillBoard",e[e.VerticalBillBoard=5]="VerticalBillBoard",e}({}),Me=function(e){_inherits(VFXBatch,e);var i=_createSuper(VFXBatch);function VFXBatch(e){var n;_classCallCheck(this,VFXBatch),_defineProperty(_assertThisInitialized(n=i.call(this)),"type","VFXBatch"),_defineProperty(_assertThisInitialized(n),"systems",void 0),_defineProperty(_assertThisInitialized(n),"settings",void 0),_defineProperty(_assertThisInitialized(n),"maxParticles",void 0),n.maxParticles=1e3,n.systems=new Set;var r=new t.Layers;r.mask=e.layers.mask;var o=e.material.clone();return o.defines={},Object.assign(o.defines,e.material.defines),n.settings={instancingGeometry:e.instancingGeometry,renderMode:e.renderMode,renderOrder:e.renderOrder,material:o,uTileCount:e.uTileCount,vTileCount:e.vTileCount,blendTiles:e.blendTiles,softParticles:e.softParticles,softNearFade:e.softNearFade,softFarFade:e.softFarFade,layers:r},n.frustumCulled=!1,n.renderOrder=n.settings.renderOrder,n}return _createClass(VFXBatch,[{key:"addSystem",value:function addSystem(e){this.systems.add(e)}},{key:"removeSystem",value:function removeSystem(e){this.systems.delete(e)}},{key:"applyDepthTexture",value:function applyDepthTexture(e){var t=this.material.uniforms.depthTexture;t&&t.value!==e&&(t.value=e,this.material.needsUpdate=!0)}}]),VFXBatch}(t.Mesh),ke=new t.Vector3(0,0,1),Ce=new t.Quaternion,Te=new t.Vector3,Ee=new t.Vector3;new t.Vector3;var Be=new t.PlaneGeometry(1,1,1,1),Ve=function(){function ParticleSystem(e){var i,r,o,a,s,u,l,c,d,f,h,p,m,v,y,g,S,_,x,w,O,N,M,k;if(_classCallCheck(this,ParticleSystem),_defineProperty(this,"autoDestroy",void 0),_defineProperty(this,"prewarm",void 0),_defineProperty(this,"looping",void 0),_defineProperty(this,"duration",void 0),_defineProperty(this,"startLife",void 0),_defineProperty(this,"startSpeed",void 0),_defineProperty(this,"startRotation",void 0),_defineProperty(this,"startSize",void 0),_defineProperty(this,"startColor",void 0),_defineProperty(this,"startTileIndex",void 0),_defineProperty(this,"rendererEmitterSettings",void 0),_defineProperty(this,"emissionOverTime",void 0),_defineProperty(this,"emissionOverDistance",void 0),_defineProperty(this,"emissionBursts",void 0),_defineProperty(this,"onlyUsedByOther",void 0),_defineProperty(this,"worldSpace",void 0),_defineProperty(this,"particleNum",void 0),_defineProperty(this,"paused",void 0),_defineProperty(this,"particles",void 0),_defineProperty(this,"emitterShape",void 0),_defineProperty(this,"emitter",void 0),_defineProperty(this,"rendererSettings",void 0),_defineProperty(this,"neededToUpdateRender",void 0),_defineProperty(this,"behaviors",void 0),_defineProperty(this,"emissionState",void 0),_defineProperty(this,"prewarmed",void 0),_defineProperty(this,"emitEnded",void 0),_defineProperty(this,"markForDestroy",void 0),_defineProperty(this,"previousWorldPos",void 0),_defineProperty(this,"temp",new t.Vector3),_defineProperty(this,"travelDistance",0),_defineProperty(this,"normalMatrix",new t.Matrix3),_defineProperty(this,"_renderer",void 0),_defineProperty(this,"firstTimeUpdate",!0),this.autoDestroy=void 0!==e.autoDestroy&&e.autoDestroy,this.duration=null!==(i=e.duration)&&void 0!==i?i:1,this.looping=void 0===e.looping||e.looping,this.prewarm=void 0!==e.prewarm&&e.prewarm,this.startLife=null!==(r=e.startLife)&&void 0!==r?r:new b(5),this.startSpeed=null!==(o=e.startSpeed)&&void 0!==o?o:new b(0),this.startRotation=null!==(a=e.startRotation)&&void 0!==a?a:new b(0),this.startSize=null!==(s=e.startSize)&&void 0!==s?s:new b(1),this.startColor=null!==(u=e.startColor)&&void 0!==u?u:new P(new t.Vector4(1,1,1,1)),this.emissionOverTime=null!==(l=e.emissionOverTime)&&void 0!==l?l:new b(10),this.emissionOverDistance=null!==(c=e.emissionOverDistance)&&void 0!==c?c:new b(0),this.emissionBursts=null!==(d=e.emissionBursts)&&void 0!==d?d:[],this.onlyUsedByOther=null!==(f=e.onlyUsedByOther)&&void 0!==f&&f,this.emitterShape=null!==(h=e.shape)&&void 0!==h?h:new xe,this.behaviors=null!==(p=e.behaviors)&&void 0!==p?p:new Array,this.worldSpace=null!==(m=e.worldSpace)&&void 0!==m&&m,this.rendererEmitterSettings=null!==(v=e.rendererEmitterSettings)&&void 0!==v?v:{},e.renderMode===Ne.StretchedBillBoard){var C,T,E=this.rendererEmitterSettings;void 0!==e.speedFactor&&(E.speedFactor=e.speedFactor),E.speedFactor=null!==(C=E.speedFactor)&&void 0!==C?C:0,E.lengthFactor=null!==(T=E.lengthFactor)&&void 0!==T?T:0}this.rendererSettings={instancingGeometry:null!==(y=e.instancingGeometry)&&void 0!==y?y:Be,renderMode:null!==(g=e.renderMode)&&void 0!==g?g:Ne.BillBoard,renderOrder:null!==(S=e.renderOrder)&&void 0!==S?S:0,material:e.material,uTileCount:null!==(_=e.uTileCount)&&void 0!==_?_:1,vTileCount:null!==(x=e.vTileCount)&&void 0!==x?x:1,blendTiles:null!==(w=e.blendTiles)&&void 0!==w&&w,softParticles:null!==(O=e.softParticles)&&void 0!==O&&O,softNearFade:null!==(N=e.softNearFade)&&void 0!==N?N:0,softFarFade:null!==(M=e.softFarFade)&&void 0!==M?M:0,layers:null!==(k=e.layers)&&void 0!==k?k:new t.Layers},this.neededToUpdateRender=!0,this.particles=new Array,this.startTileIndex=e.startTileIndex||new b(0),this.emitter=new n(this),this.paused=!1,this.particleNum=0,this.emissionState={isBursting:!1,burstParticleIndex:0,burstParticleCount:0,burstIndex:0,burstWaveIndex:0,time:0,waitEmiting:0,travelDistance:0},this.emitEnded=!1,this.markForDestroy=!1,this.prewarmed=!1}return _createClass(ParticleSystem,[{key:"time",get:function get(){return this.emissionState.time},set:function set(e){this.emissionState.time=e}},{key:"layers",get:function get(){return this.rendererSettings.layers}},{key:"texture",get:function get(){return this.rendererSettings.material.map},set:function set(e){this.rendererSettings.material.map=e,this.neededToUpdateRender=!0}},{key:"material",get:function get(){return this.rendererSettings.material},set:function set(e){this.rendererSettings.material=e,this.neededToUpdateRender=!0}},{key:"uTileCount",get:function get(){return this.rendererSettings.uTileCount},set:function set(e){this.rendererSettings.uTileCount=e,this.neededToUpdateRender=!0}},{key:"vTileCount",get:function get(){return this.rendererSettings.vTileCount},set:function set(e){this.rendererSettings.vTileCount=e,this.neededToUpdateRender=!0}},{key:"blendTiles",get:function get(){return this.rendererSettings.blendTiles},set:function set(e){this.rendererSettings.blendTiles=e,this.neededToUpdateRender=!0}},{key:"softParticles",get:function get(){return this.rendererSettings.softParticles},set:function set(e){this.rendererSettings.softParticles=e,this.neededToUpdateRender=!0}},{key:"softNearFade",get:function get(){return this.rendererSettings.softNearFade},set:function set(e){this.rendererSettings.softNearFade=e,this.neededToUpdateRender=!0}},{key:"softFarFade",get:function get(){return this.rendererSettings.softFarFade},set:function set(e){this.rendererSettings.softFarFade=e,this.neededToUpdateRender=!0}},{key:"instancingGeometry",get:function get(){return this.rendererSettings.instancingGeometry},set:function set(e){this.restart(),this.particles.length=0,this.rendererSettings.instancingGeometry=e,this.neededToUpdateRender=!0}},{key:"renderMode",get:function get(){return this.rendererSettings.renderMode},set:function set(e){if((this.rendererSettings.renderMode!=Ne.Trail&&e===Ne.Trail||this.rendererSettings.renderMode==Ne.Trail&&e!==Ne.Trail)&&(this.restart(),this.particles.length=0),this.rendererSettings.renderMode!==e)switch(e){case Ne.Trail:this.rendererEmitterSettings={startLength:new b(30),followLocalOrigin:!1};break;case Ne.Mesh:this.rendererEmitterSettings={geometry:new t.PlaneGeometry(1,1)},this.startRotation=new k(new t.Vector3(0,1,0),new b(0));break;case Ne.StretchedBillBoard:this.rendererEmitterSettings={speedFactor:0,lengthFactor:2},this.rendererSettings.renderMode===Ne.Mesh&&(this.startRotation=new b(0));break;case Ne.BillBoard:case Ne.VerticalBillBoard:case Ne.HorizontalBillBoard:this.rendererEmitterSettings={},this.rendererSettings.renderMode===Ne.Mesh&&(this.startRotation=new b(0))}this.rendererSettings.renderMode=e,this.neededToUpdateRender=!0}},{key:"renderOrder",get:function get(){return this.rendererSettings.renderOrder},set:function set(e){this.rendererSettings.renderOrder=e,this.neededToUpdateRender=!0}},{key:"blending",get:function get(){return this.rendererSettings.material.blending},set:function set(e){this.rendererSettings.material.blending=e,this.neededToUpdateRender=!0}},{key:"pause",value:function pause(){this.paused=!0}},{key:"play",value:function play(){this.paused=!1}},{key:"spawn",value:function spawn(e,i,n){Ce.setFromRotationMatrix(n);var r=Te,o=Ce,a=Ee;n.decompose(r,o,a);for(var u=0;u<e;u++){for(i.burstParticleIndex=u,this.particleNum++;this.particles.length<this.particleNum;)this.rendererSettings.renderMode===Ne.Trail?this.particles.push(new l):this.particles.push(new s);var c=this.particles[this.particleNum-1];if(c.speedModifier=1,this.startColor.genColor(c.startColor,this.emissionState.time,{}),c.color.copy(c.startColor),c.startSpeed=this.startSpeed.genValue(i.time/this.duration),c.life=this.startLife.genValue(i.time/this.duration),c.age=0,c.startSize=this.startSize.genValue(i.time/this.duration),c.uvTile=this.startTileIndex.genValue(),c.size=c.startSize,this.rendererSettings.renderMode===Ne.Mesh||this.rendererSettings.renderMode===Ne.BillBoard||this.rendererSettings.renderMode===Ne.VerticalBillBoard||this.rendererSettings.renderMode===Ne.HorizontalBillBoard||this.rendererSettings.renderMode===Ne.StretchedBillBoard){var d=c;this.rendererSettings.renderMode===Ne.Mesh?(d.rotation instanceof t.Quaternion||(d.rotation=new t.Quaternion),"rotation"===this.startRotation.type?this.startRotation.genValue(d.rotation,i.time/this.duration):d.rotation.setFromAxisAngle(ke,this.startRotation.genValue(i.time/this.duration))):"rotation"===this.startRotation.type?d.rotation=0:d.rotation=this.startRotation.genValue(i.time/this.duration)}else this.rendererSettings.renderMode===Ne.Trail&&(c.length=this.rendererEmitterSettings.startLength.genValue(i.time/this.duration));if(this.emitterShape.initialize(c,i),this.rendererSettings.renderMode===Ne.Trail&&this.rendererEmitterSettings.followLocalOrigin){var f=c;f.localPosition=(new t.Vector3).copy(f.position)}this.worldSpace?(c.position.applyMatrix4(n),c.startSize=c.startSize*(Math.abs(a.x)+Math.abs(a.y)+Math.abs(a.z))/3,c.size=c.startSize,c.velocity.multiply(a).applyMatrix3(this.normalMatrix),c.rotation&&c.rotation instanceof t.Quaternion&&c.rotation.multiplyQuaternions(Ce,c.rotation)):this.onlyUsedByOther&&(c.parentMatrix=n);for(var h=0;h<this.behaviors.length;h++)this.behaviors[h].initialize(c,this)}}},{key:"endEmit",value:function endEmit(){this.emitEnded=!0,this.autoDestroy&&(this.markForDestroy=!0)}},{key:"dispose",value:function dispose(){this._renderer&&this._renderer.deleteSystem(this),this.emitter.dispose(),this.emitter.parent&&this.emitter.parent.remove(this.emitter)}},{key:"restart",value:function restart(){this.paused=!1,this.particleNum=0,this.emissionState.isBursting=!1,this.emissionState.burstIndex=0,this.emissionState.burstWaveIndex=0,this.emissionState.time=0,this.emissionState.waitEmiting=0,this.behaviors.forEach((function(e){e.reset()})),this.emitEnded=!1,this.markForDestroy=!1,this.prewarmed=!1}},{key:"update",value:function update(e){if(!this.paused){for(var t=this.emitter;t.parent;)t=t.parent;if("Scene"===t.type)if(this.firstTimeUpdate&&(this.firstTimeUpdate=!1,this.emitter.updateWorldMatrix(!0,!1)),this.emitEnded&&0===this.particleNum)this.markForDestroy&&this.emitter.parent&&this.dispose();else{if(this.looping&&this.prewarm&&!this.prewarmed){this.prewarmed=!0;for(var i=0;i<60*this.duration;i++)this.update(1/60)}e>.1&&(e=.1),this.neededToUpdateRender&&(this._renderer&&this._renderer.updateSystem(this),this.neededToUpdateRender=!1),this.onlyUsedByOther||this.emit(e,this.emissionState,this.emitter.matrixWorld),this.emitterShape.update(this,e);for(var n=0;n<this.behaviors.length;n++){this.behaviors[n].frameUpdate(e);for(var r=0;r<this.particleNum;r++)this.particles[r].died||this.behaviors[n].update(this.particles[r],e)}for(var o=0;o<this.particleNum;o++)this.rendererEmitterSettings.followLocalOrigin&&this.particles[o].localPosition?(this.particles[o].position.copy(this.particles[o].localPosition),this.particles[o].parentMatrix?this.particles[o].position.applyMatrix4(this.particles[o].parentMatrix):this.particles[o].position.applyMatrix4(this.emitter.matrixWorld)):this.particles[o].position.addScaledVector(this.particles[o].velocity,e*this.particles[o].speedModifier),this.particles[o].age+=e;if(this.rendererSettings.renderMode===Ne.Trail)for(var a=0;a<this.particleNum;a++)this.particles[a].update();for(var s=0;s<this.particleNum;s++){var u=this.particles[s];!u.died||u instanceof l&&0!==u.previous.length||(this.particles[s]=this.particles[this.particleNum-1],this.particles[this.particleNum-1]=u,this.particleNum--,s--)}}else this.dispose()}}},{key:"emit",value:function emit(e,i,n){i.time>this.duration&&(this.looping?(i.time-=this.duration,i.burstIndex=0,this.behaviors.forEach((function(e){e.reset()}))):this.emitEnded||this.onlyUsedByOther||this.endEmit()),this.normalMatrix.getNormalMatrix(n);var r=Math.ceil(i.waitEmiting);for(this.spawn(r,i,n),i.waitEmiting-=r;i.burstIndex<this.emissionBursts.length&&this.emissionBursts[i.burstIndex].time<=i.time;){if(Math.random()<this.emissionBursts[i.burstIndex].probability){var o=this.emissionBursts[i.burstIndex].count.genValue(this.time);i.isBursting=!0,i.burstParticleCount=o,this.spawn(o,i,n),i.isBursting=!1}i.burstIndex++}if(!this.emitEnded&&(i.waitEmiting+=e*this.emissionOverTime.genValue(i.time/this.duration),null!=i.previousWorldPos)){this.temp.set(n.elements[12],n.elements[13],n.elements[14]),i.travelDistance+=i.previousWorldPos.distanceTo(this.temp);var a=this.emissionOverDistance.genValue(i.time/this.duration);if(i.travelDistance*a>0){var s=Math.floor(i.travelDistance*a);i.travelDistance-=s/a,i.waitEmiting+=s}}void 0===i.previousWorldPos&&(i.previousWorldPos=new t.Vector3),i.previousWorldPos.set(n.elements[12],n.elements[13],n.elements[14]),i.time+=e}},{key:"toJSON",value:function toJSON(e){var t,i,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if((void 0===e||"string"==typeof e)&&(e={geometries:{},materials:{},textures:{},images:{},shapes:{},skeletons:{},animations:{},nodes:{}}),e.materials[this.rendererSettings.material.uuid]=this.rendererSettings.material.toJSON(e),n.useUrlForImage&&void 0!==(null===(t=this.texture)||void 0===t?void 0:t.source)){var r=this.texture.source;e.images[r.uuid]={uuid:r.uuid,url:this.texture.image.url}}i=this.renderMode===Ne.Trail?{startLength:this.rendererEmitterSettings.startLength.toJSON(),followLocalOrigin:this.rendererEmitterSettings.followLocalOrigin}:this.renderMode===Ne.Mesh?{}:this.renderMode===Ne.StretchedBillBoard?{speedFactor:this.rendererEmitterSettings.speedFactor,lengthFactor:this.rendererEmitterSettings.lengthFactor}:{};var o=this.rendererSettings.instancingGeometry;return e.geometries&&!e.geometries[o.uuid]&&(e.geometries[o.uuid]=o.toJSON()),{version:"3.0",autoDestroy:this.autoDestroy,looping:this.looping,prewarm:this.prewarm,duration:this.duration,shape:this.emitterShape.toJSON(),startLife:this.startLife.toJSON(),startSpeed:this.startSpeed.toJSON(),startRotation:this.startRotation.toJSON(),startSize:this.startSize.toJSON(),startColor:this.startColor.toJSON(),emissionOverTime:this.emissionOverTime.toJSON(),emissionOverDistance:this.emissionOverDistance.toJSON(),emissionBursts:this.emissionBursts.map((function(e){return{time:e.time,count:e.count.toJSON(),probability:e.probability,interval:e.interval,cycle:e.cycle}})),onlyUsedByOther:this.onlyUsedByOther,instancingGeometry:this.rendererSettings.instancingGeometry.uuid,renderOrder:this.renderOrder,renderMode:this.renderMode,rendererEmitterSettings:i,material:this.rendererSettings.material.uuid,layers:this.layers.mask,startTileIndex:this.startTileIndex.toJSON(),uTileCount:this.uTileCount,vTileCount:this.vTileCount,blendTiles:this.blendTiles,softParticles:this.rendererSettings.softParticles,softFarFade:this.rendererSettings.softFarFade,softNearFade:this.rendererSettings.softNearFade,behaviors:this.behaviors.map((function(e){return e.toJSON()})),worldSpace:this.worldSpace}}},{key:"addBehavior",value:function addBehavior(e){this.behaviors.push(e)}},{key:"getRendererSettings",value:function getRendererSettings(){return this.rendererSettings}},{key:"clone",value:function clone(){var e,i=[],n=_createForOfIteratorHelper(this.emissionBursts);try{for(n.s();!(e=n.n()).done;){var r=e.value,o={};Object.assign(o,r),i.push(o)}}catch(e){n.e(e)}finally{n.f()}var a,s,u=[],l=_createForOfIteratorHelper(this.behaviors);try{for(l.s();!(a=l.n()).done;){var c=a.value;u.push(c.clone())}}catch(e){l.e(e)}finally{l.f()}s=this.renderMode===Ne.Trail?{startLength:this.rendererEmitterSettings.startLength.clone(),followLocalOrigin:this.rendererEmitterSettings.followLocalOrigin}:{};var d=new t.Layers;return d.mask=this.layers.mask,new ParticleSystem({autoDestroy:this.autoDestroy,looping:this.looping,duration:this.duration,shape:this.emitterShape.clone(),startLife:this.startLife.clone(),startSpeed:this.startSpeed.clone(),startRotation:this.startRotation.clone(),startSize:this.startSize.clone(),startColor:this.startColor.clone(),emissionOverTime:this.emissionOverTime.clone(),emissionOverDistance:this.emissionOverDistance.clone(),emissionBursts:i,onlyUsedByOther:this.onlyUsedByOther,instancingGeometry:this.rendererSettings.instancingGeometry,renderMode:this.renderMode,renderOrder:this.renderOrder,rendererEmitterSettings:s,material:this.rendererSettings.material,startTileIndex:this.startTileIndex,uTileCount:this.uTileCount,vTileCount:this.vTileCount,blendTiles:this.blendTiles,softParticles:this.softParticles,softFarFade:this.softFarFade,softNearFade:this.softNearFade,behaviors:u,worldSpace:this.worldSpace,layers:d})}}],[{key:"fromJSON",value:function fromJSON(e,i,n){var r,o,a,s=EmitterFromJSON(e.shape,i);if(e.renderMode===Ne.Trail){var u=e.rendererEmitterSettings;a={startLength:null!=u.startLength?ValueGeneratorFromJSON(u.startLength):new b(30),followLocalOrigin:u.followLocalOrigin}}else e.renderMode===Ne.Mesh?a={}:e.renderMode===Ne.StretchedBillBoard?(a=e.rendererEmitterSettings,null!=e.speedFactor&&(a.speedFactor=e.speedFactor)):a={};var l=new t.Layers;e.layers&&(l.mask=e.layers);var c=new ParticleSystem({autoDestroy:e.autoDestroy,looping:e.looping,prewarm:e.prewarm,duration:e.duration,shape:s,startLife:ValueGeneratorFromJSON(e.startLife),startSpeed:ValueGeneratorFromJSON(e.startSpeed),startRotation:GeneratorFromJSON(e.startRotation),startSize:ValueGeneratorFromJSON(e.startSize),startColor:ColorGeneratorFromJSON(e.startColor),emissionOverTime:ValueGeneratorFromJSON(e.emissionOverTime),emissionOverDistance:ValueGeneratorFromJSON(e.emissionOverDistance),emissionBursts:null===(r=e.emissionBursts)||void 0===r?void 0:r.map((function(e){return{time:e.time,count:"number"==typeof e.count?new b(e.count):ValueGeneratorFromJSON(e.count),probability:e.probability,interval:e.interval,cycle:e.cycle}})),onlyUsedByOther:e.onlyUsedByOther,instancingGeometry:i.geometries[e.instancingGeometry],renderMode:e.renderMode,rendererEmitterSettings:a,renderOrder:e.renderOrder,layers:l,material:e.material?i.materials[e.material]:e.texture?new t.MeshBasicMaterial({map:i.textures[e.texture],transparent:null===(o=e.transparent)||void 0===o||o,blending:e.blending,side:t.DoubleSide}):new t.MeshBasicMaterial({color:16777215,transparent:!0,blending:t.AdditiveBlending,side:t.DoubleSide}),startTileIndex:"number"==typeof e.startTileIndex?new b(e.startTileIndex):ValueGeneratorFromJSON(e.startTileIndex),uTileCount:e.uTileCount,vTileCount:e.vTileCount,blendTiles:e.blendTiles,softParticles:e.softParticles,softFarFade:e.softFarFade,softNearFade:e.softNearFade,behaviors:[],worldSpace:e.worldSpace});return c.behaviors=e.behaviors.map((function(e){var t=BehaviorFromJSON(e,c);return"EmitSubParticleSystem"===t.type&&(n[e.subParticleSystem]=t),t})),c}}]),ParticleSystem}(),Ae="\n\n#include <common>\n#include <color_pars_fragment>\n#include <map_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n#include <alphatest_pars_fragment>\n\n#include <tile_pars_fragment>\n#include <soft_pars_fragment>\n\nvoid main() {\n\n    #include <clipping_planes_fragment>\n    \n    vec3 outgoingLight = vec3( 0.0 );\n    vec4 diffuseColor = vColor;\n    \n    #include <logdepthbuf_fragment>\n    \n    #include <tile_fragment>\n    #include <alphatest_fragment>\n\n    outgoingLight = diffuseColor.rgb;\n    \n    #ifdef USE_COLOR_AS_ALPHA\n    gl_FragColor = vec4( outgoingLight, diffuseColor.r );\n    #else\n    gl_FragColor = vec4( outgoingLight, diffuseColor.a );\n    #endif\n    \n    #include <soft_fragment>\n    #include <tonemapping_fragment>\n}\n";function getMaterialUVChannelName(e){return 0===e?"uv":"uv".concat(e)}new t.Vector3(0,0,1);var Ue=function(e){_inherits(SpriteBatch,e);var i=_createSuper(SpriteBatch);function SpriteBatch(e){var n;return _classCallCheck(this,SpriteBatch),_defineProperty(_assertThisInitialized(n=i.call(this,e)),"offsetBuffer",void 0),_defineProperty(_assertThisInitialized(n),"rotationBuffer",void 0),_defineProperty(_assertThisInitialized(n),"sizeBuffer",void 0),_defineProperty(_assertThisInitialized(n),"colorBuffer",void 0),_defineProperty(_assertThisInitialized(n),"uvTileBuffer",void 0),_defineProperty(_assertThisInitialized(n),"velocityBuffer",void 0),_defineProperty(_assertThisInitialized(n),"vector_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"vector2_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"vector3_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"quaternion_",new t.Quaternion),_defineProperty(_assertThisInitialized(n),"quaternion2_",new t.Quaternion),_defineProperty(_assertThisInitialized(n),"quaternion3_",new t.Quaternion),_defineProperty(_assertThisInitialized(n),"rotationMat_",new t.Matrix3),_defineProperty(_assertThisInitialized(n),"rotationMat2_",new t.Matrix3),n.maxParticles=1e3,n.setupBuffers(),n.rebuildMaterial(),n}return _createClass(SpriteBatch,[{key:"buildExpandableBuffers",value:function buildExpandableBuffers(){this.offsetBuffer=new t.InstancedBufferAttribute(new Float32Array(3*this.maxParticles),3),this.offsetBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("offset",this.offsetBuffer),this.colorBuffer=new t.InstancedBufferAttribute(new Float32Array(4*this.maxParticles),4),this.colorBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("color",this.colorBuffer),this.settings.renderMode===Ne.Mesh?(this.rotationBuffer=new t.InstancedBufferAttribute(new Float32Array(4*this.maxParticles),4),this.rotationBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("rotation",this.rotationBuffer)):this.settings.renderMode!==Ne.BillBoard&&this.settings.renderMode!==Ne.HorizontalBillBoard&&this.settings.renderMode!==Ne.VerticalBillBoard&&this.settings.renderMode!==Ne.StretchedBillBoard||(this.rotationBuffer=new t.InstancedBufferAttribute(new Float32Array(this.maxParticles),1),this.rotationBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("rotation",this.rotationBuffer)),this.sizeBuffer=new t.InstancedBufferAttribute(new Float32Array(this.maxParticles),1),this.sizeBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("size",this.sizeBuffer),this.uvTileBuffer=new t.InstancedBufferAttribute(new Float32Array(this.maxParticles),1),this.uvTileBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("uvTile",this.uvTileBuffer),this.settings.renderMode===Ne.StretchedBillBoard&&(this.velocityBuffer=new t.InstancedBufferAttribute(new Float32Array(4*this.maxParticles),4),this.velocityBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("velocity",this.velocityBuffer))}},{key:"setupBuffers",value:function setupBuffers(){this.geometry&&this.geometry.dispose(),this.geometry=new t.InstancedBufferGeometry,this.geometry.setIndex(this.settings.instancingGeometry.getIndex()),this.settings.instancingGeometry.hasAttribute("normal")&&this.geometry.setAttribute("normal",this.settings.instancingGeometry.getAttribute("normal")),this.geometry.setAttribute("position",this.settings.instancingGeometry.getAttribute("position")),this.geometry.setAttribute("uv",this.settings.instancingGeometry.getAttribute("uv")),this.buildExpandableBuffers()}},{key:"expandBuffers",value:function expandBuffers(e){for(;e>=this.maxParticles;)this.maxParticles*=2;this.setupBuffers()}},{key:"rebuildMaterial",value:function rebuildMaterial(){var e;this.layers.mask=this.settings.layers.mask;var i={};if("MeshStandardMaterial"===this.settings.material.type||"MeshPhysicalMaterial"===this.settings.material.type){var n=this.settings.material;(e=t.UniformsUtils.merge([t.UniformsLib.common,t.UniformsLib.envmap,t.UniformsLib.aomap,t.UniformsLib.lightmap,t.UniformsLib.emissivemap,t.UniformsLib.bumpmap,t.UniformsLib.normalmap,t.UniformsLib.displacementmap,t.UniformsLib.roughnessmap,t.UniformsLib.metalnessmap,t.UniformsLib.fog,t.UniformsLib.lights,{emissive:{value:new t.Color(0)},roughness:{value:1},metalness:{value:0},envMapIntensity:{value:1}}])).diffuse.value=n.color,e.opacity.value=n.opacity,e.emissive.value=n.emissive,e.roughness.value=n.roughness,e.metalness.value=n.metalness,n.envMap&&(e.envMap.value=n.envMap,e.envMapIntensity.value=n.envMapIntensity),n.normalMap&&(e.normalMap.value=n.normalMap,e.normalScale.value=n.normalScale),n.roughnessMap&&(e.roughnessMap.value=n.roughnessMap),n.metalnessMap&&(e.metalnessMap.value=n.metalnessMap),n.map&&(e.map=new t.Uniform(n.map))}else(e={}).map=new t.Uniform(this.settings.material.map);this.settings.material.alphaTest&&(i.USE_ALPHATEST="",e.alphaTest=new t.Uniform(this.settings.material.alphaTest)),i.USE_UV="";var r,o=this.settings.uTileCount,a=this.settings.vTileCount;if((o>1||a>1)&&(i.UV_TILE="",e.tileCount=new t.Uniform(new t.Vector2(o,a))),this.settings.material.defines&&void 0!==this.settings.material.defines.USE_COLOR_AS_ALPHA&&(i.USE_COLOR_AS_ALPHA=""),this.settings.material.normalMap&&(i.USE_NORMALMAP="",i.NORMALMAP_UV=getMaterialUVChannelName(this.settings.material.normalMap.channel),e.normalMapTransform=new t.Uniform((new t.Matrix3).copy(this.settings.material.normalMap.matrix))),this.settings.material.map&&(i.USE_MAP="",this.settings.blendTiles&&(i.TILE_BLEND=""),i.MAP_UV=getMaterialUVChannelName(this.settings.material.map.channel),e.mapTransform=new t.Uniform((new t.Matrix3).copy(this.settings.material.map.matrix))),i.USE_COLOR_ALPHA="",this.settings.softParticles){i.SOFT_PARTICLES="";var s=this.settings.softNearFade,u=1/(this.settings.softFarFade-this.settings.softNearFade);e.softParams=new t.Uniform(new t.Vector2(s,u)),e.depthTexture=new t.Uniform(null);var l=e.projParams=new t.Uniform(new t.Vector4);r=function onBeforeRender(e,t,i){l.value.set(i.near,i.far,0,0)}}var c=!1;if(this.settings.renderMode===Ne.BillBoard||this.settings.renderMode===Ne.VerticalBillBoard||this.settings.renderMode===Ne.HorizontalBillBoard||this.settings.renderMode===Ne.Mesh){var d,f;this.settings.renderMode===Ne.Mesh?"MeshStandardMaterial"===this.settings.material.type||"MeshPhysicalMaterial"===this.settings.material.type?(i.USE_COLOR="",d="\n#define STANDARD\nvarying vec3 vViewPosition;\n#ifdef USE_TRANSMISSION\n\tvarying vec3 vWorldPosition;\n#endif\n#include <common>\n\nattribute vec3 offset;\nattribute vec4 rotation;\nattribute float size;\n#include <tile_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n    #include <tile_vertex>\n    float x2 = rotation.x + rotation.x, y2 = rotation.y + rotation.y, z2 = rotation.z + rotation.z;\n    float xx = rotation.x * x2, xy = rotation.x * y2, xz = rotation.x * z2;\n    float yy = rotation.y * y2, yz = rotation.y * z2, zz = rotation.z * z2;\n    float wx = rotation.w * x2, wy = rotation.w * y2, wz = rotation.w * z2;\n    float sx = size, sy = size, sz = size;\n\n    mat4 particleMatrix = mat4(( 1.0 - ( yy + zz ) ) * sx, ( xy + wz ) * sx, ( xz - wy ) * sx, 0.0,  // 1. column\n                      ( xy - wz ) * sy, ( 1.0 - ( xx + zz ) ) * sy, ( yz + wx ) * sy, 0.0,  // 2. column\n                      ( xz + wy ) * sz, ( yz - wx ) * sz, ( 1.0 - ( xx + yy ) ) * sz, 0.0,  // 3. column\n                      offset.x, offset.y, offset.z, 1.0);\n\n#include <color_vertex>\n#include <morphinstance_vertex>\n#include <morphcolor_vertex>\n#include <batching_vertex>\n\n#include <beginnormal_vertex>\n#include <morphnormal_vertex>\n#include <skinbase_vertex>\n#include <skinnormal_vertex>\n\n\t// replace defaultnormal_vertex\n\tvec3 transformedNormal = objectNormal;\n    mat3 m = mat3( particleMatrix );\n    transformedNormal /= vec3( dot( m[ 0 ], m[ 0 ] ), dot( m[ 1 ], m[ 1 ] ), dot( m[ 2 ], m[ 2 ] ) );\n    transformedNormal = m * transformedNormal;\n    transformedNormal = normalMatrix * transformedNormal;\n    #ifdef FLIP_SIDED\n        transformedNormal = - transformedNormal;\n    #endif\n    #ifdef USE_TANGENT\n        vec3 transformedTangent = ( modelViewMatrix * vec4( objectTangent, 0.0 ) ).xyz;\n        #ifdef FLIP_SIDED\n        transformedTangent = - transformedTangent;\n        #endif\n    #endif\n\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\n\t// replace include <project_vertex>\n  vec4 mvPosition = vec4( transformed, 1.0 );\n  mvPosition = modelViewMatrix * (particleMatrix * mvPosition);\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t\n\tvViewPosition = - mvPosition.xyz;\n\t\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n#ifdef USE_TRANSMISSION\n    vWorldPosition = worldPosition.xyz;\n#endif\n}\n",f="\n#define STANDARD\n\n#ifdef PHYSICAL\n#define IOR\n#define USE_SPECULAR\n#endif\n\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float roughness;\nuniform float metalness;\nuniform float opacity;\n\n#ifdef IOR\nuniform float ior;\n#endif\n\n#ifdef USE_SPECULAR\nuniform float specularIntensity;\nuniform vec3 specularColor;\n\n#ifdef USE_SPECULAR_COLORMAP\nuniform sampler2D specularColorMap;\n#endif\n\n#ifdef USE_SPECULAR_INTENSITYMAP\nuniform sampler2D specularIntensityMap;\n#endif\n#endif\n\n#ifdef USE_CLEARCOAT\nuniform float clearcoat;\nuniform float clearcoatRoughness;\n#endif\n\n#ifdef USE_DISPERSION\nuniform float dispersion;\n#endif\n\n#ifdef USE_IRIDESCENCE\nuniform float iridescence;\nuniform float iridescenceIOR;\nuniform float iridescenceThicknessMinimum;\nuniform float iridescenceThicknessMaximum;\n#endif\n\n#ifdef USE_SHEEN\nuniform vec3 sheenColor;\nuniform float sheenRoughness;\n\n#ifdef USE_SHEEN_COLORMAP\nuniform sampler2D sheenColorMap;\n#endif\n\n#ifdef USE_SHEEN_ROUGHNESSMAP\nuniform sampler2D sheenRoughnessMap;\n#endif\n#endif\n\n#ifdef USE_ANISOTROPY\nuniform vec2 anisotropyVector;\n\n#ifdef USE_ANISOTROPYMAP\nuniform sampler2D anisotropyMap;\n#endif\n#endif\n\nvarying vec3 vViewPosition;\n\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <iridescence_fragment>\n#include <cube_uv_reflection_fragment>\n#include <envmap_common_pars_fragment>\n#include <envmap_physical_pars_fragment>\n#include <fog_pars_fragment>\n#include <lights_pars_begin>\n#include <normal_pars_fragment>\n#include <lights_physical_pars_fragment>\n#include <transmission_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <clearcoat_pars_fragment>\n#include <iridescence_pars_fragment>\n#include <roughnessmap_pars_fragment>\n#include <metalnessmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\nvec4 diffuseColor = vec4( diffuse, opacity );\n#include <clipping_planes_fragment>\n\nReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\nvec3 totalEmissiveRadiance = emissive;\n\n#include <logdepthbuf_fragment>\n#include <map_fragment>\n#include <color_fragment>\n#include <alphamap_fragment>\n#include <alphatest_fragment>\n#include <alphahash_fragment>\n#include <roughnessmap_fragment>\n#include <metalnessmap_fragment>\n#include <normal_fragment_begin>\n#include <normal_fragment_maps>\n#include <clearcoat_normal_fragment_begin>\n#include <clearcoat_normal_fragment_maps>\n#include <emissivemap_fragment>\n\n// accumulation\n#include <lights_physical_fragment>\n#include <lights_fragment_begin>\n#include <lights_fragment_maps>\n#include <lights_fragment_end>\n\n// modulation\n#include <aomap_fragment>\n\nvec3 totalDiffuse = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse;\nvec3 totalSpecular = reflectedLight.directSpecular + reflectedLight.indirectSpecular;\n\n#include <transmission_fragment>\n\nvec3 outgoingLight = totalDiffuse + totalSpecular + totalEmissiveRadiance;\n\n#ifdef USE_SHEEN\n\n// Sheen energy compensation approximation calculation can be found at the end of\n// https://drive.google.com/file/d/1T0D1VSyR4AllqIJTQAraEIzjlb5h4FKH/view?usp=sharing\nfloat sheenEnergyComp = 1.0 - 0.157 * max3( material.sheenColor );\n\noutgoingLight = outgoingLight * sheenEnergyComp + sheenSpecularDirect + sheenSpecularIndirect;\n\n#endif\n\n#ifdef USE_CLEARCOAT\n\nfloat dotNVcc = saturate( dot( geometryClearcoatNormal, geometryViewDir ) );\n\nvec3 Fcc = F_Schlick( material.clearcoatF0, material.clearcoatF90, dotNVcc );\n\noutgoingLight = outgoingLight * ( 1.0 - material.clearcoat * Fcc ) + ( clearcoatSpecularDirect + clearcoatSpecularIndirect ) * material.clearcoat;\n\n#endif\n\n#include <opaque_fragment>\n#include <tonemapping_fragment>\n#include <colorspace_fragment>\n#include <fog_fragment>\n#include <premultiplied_alpha_fragment>\n#include <dithering_fragment>\n}",c=!0):(d="\n#include <common>\n#include <color_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n#include <tile_pars_vertex>\n#include <soft_pars_vertex>\n\nattribute vec3 offset;\nattribute vec4 rotation;\nattribute float size;\n// attribute vec4 color;\n\nvoid main() {\n\n    float x2 = rotation.x + rotation.x, y2 = rotation.y + rotation.y, z2 = rotation.z + rotation.z;\n    float xx = rotation.x * x2, xy = rotation.x * y2, xz = rotation.x * z2;\n    float yy = rotation.y * y2, yz = rotation.y * z2, zz = rotation.z * z2;\n    float wx = rotation.w * x2, wy = rotation.w * y2, wz = rotation.w * z2;\n    float sx = size, sy = size, sz = size;\n    \n    mat4 matrix = mat4(( 1.0 - ( yy + zz ) ) * sx, ( xy + wz ) * sx, ( xz - wy ) * sx, 0.0,  // 1. column\n                      ( xy - wz ) * sy, ( 1.0 - ( xx + zz ) ) * sy, ( yz + wx ) * sy, 0.0,  // 2. column\n                      ( xz + wy ) * sz, ( yz - wx ) * sz, ( 1.0 - ( xx + yy ) ) * sz, 0.0,  // 3. column\n                      offset.x, offset.y, offset.z, 1.0);\n    \n    vec4 mvPosition = modelViewMatrix * (matrix * vec4( position, 1.0 ));\n\n\tvColor = color;\n\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n    #include <tile_vertex>\n    #include <soft_vertex>\n}\n",f=Ae):(d="\n#include <common>\n#include <color_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\n#include <tile_pars_vertex>\n#include <soft_pars_vertex>\n\nattribute vec3 offset;\nattribute float rotation;\nattribute float size;\n\nvoid main() {\n\t\n    vec2 alignedPosition = ( position.xy ) * size;\n    \n    vec2 rotatedPosition;\n    rotatedPosition.x = cos( rotation ) * alignedPosition.x - sin( rotation ) * alignedPosition.y;\n    rotatedPosition.y = sin( rotation ) * alignedPosition.x + cos( rotation ) * alignedPosition.y;\n#ifdef HORIZONTAL\n    vec4 mvPosition = modelMatrix * vec4( offset, 1.0 );\n    mvPosition.x += rotatedPosition.x;\n    mvPosition.z -= rotatedPosition.y;\n    mvPosition = viewMatrix * mvPosition;\n#elif defined(VERTICAL)\n    vec4 mvPosition = modelMatrix * vec4( offset, 1.0 );\n    mvPosition.y += rotatedPosition.y;\n    mvPosition = viewMatrix * mvPosition;\n    mvPosition.x += rotatedPosition.x;\n#else\n    vec4 mvPosition = modelViewMatrix * vec4( offset, 1.0 );\n    mvPosition.xy += rotatedPosition;\n#endif\n\n\tvColor = color;\n\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\n\t#include <clipping_planes_vertex>\n\n\t#include <tile_vertex>\n\t#include <soft_vertex>\n}\n",f=Ae),this.settings.renderMode===Ne.VerticalBillBoard?i.VERTICAL="":this.settings.renderMode===Ne.HorizontalBillBoard&&(i.HORIZONTAL=""),this.material=new t.ShaderMaterial({uniforms:e,defines:i,vertexShader:d,fragmentShader:f,transparent:this.settings.material.transparent,depthWrite:!this.settings.material.transparent,blending:this.settings.material.blending,side:this.settings.material.side,alphaTest:this.settings.material.alphaTest,lights:c})}else{if(this.settings.renderMode!==Ne.StretchedBillBoard)throw new Error("render mode unavailable");e.speedFactor=new t.Uniform(1),this.material=new t.ShaderMaterial({uniforms:e,defines:i,vertexShader:"\n#include <common>\n#include <color_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\n#include <tile_pars_vertex>\n#include <soft_pars_vertex>\n\nattribute vec3 offset;\nattribute float rotation;\nattribute float size;\nattribute vec4 velocity;\n\nuniform float speedFactor;\n\nvoid main() {\n    float lengthFactor = velocity.w;\n#ifdef USE_SKEW\n    vec4 mvPosition = modelViewMatrix * vec4( offset, 1.0 );\n    vec3 viewVelocity = normalMatrix * velocity.xyz;\n\n    vec3 scaledPos = vec3(position.xy * size, position.z);\n    float vlength = length(viewVelocity);\n    vec3 projVelocity =  dot(scaledPos, viewVelocity) * viewVelocity / vlength;\n    mvPosition.xyz += scaledPos + projVelocity * (speedFactor / size + lengthFactor / vlength);\n#else\n    vec4 mvPosition = modelViewMatrix * vec4( offset, 1.0 );\n    vec3 viewVelocity = normalMatrix * velocity.xyz;\n    float vlength = length(viewVelocity); \n    mvPosition.xyz += position.y * normalize(cross(mvPosition.xyz, viewVelocity)) * size; // switch the cross to  match unity implementation\n    mvPosition.xyz -= (position.x + 0.5) * viewVelocity * (1.0 + lengthFactor / vlength) * size; // minus position.x to match unity implementation\n#endif\n\tvColor = color;\n\tgl_Position = projectionMatrix * mvPosition;\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <tile_vertex>\n\t#include <soft_vertex>\n}\n",fragmentShader:Ae,transparent:this.settings.material.transparent,depthWrite:!this.settings.material.transparent,blending:this.settings.material.blending,side:this.settings.material.side,alphaTest:this.settings.material.alphaTest})}this.material&&r&&(this.material.onBeforeRender=r)}},{key:"update",value:function update(){var e=this,t=0,i=0;this.systems.forEach((function(e){i+=e.particleNum})),i>this.maxParticles&&this.expandBuffers(i),this.systems.forEach((function(i){var n=i.particles,r=i.particleNum,o=e.quaternion2_,a=e.vector2_,s=e.vector3_;i.emitter.matrixWorld.decompose(a,o,s),e.rotationMat_.setFromMatrix4(i.emitter.matrixWorld);for(var u=0;u<r;u++,t++){var l=n[u];if(e.settings.renderMode===Ne.Mesh){var c=void 0;if(i.worldSpace)c=l.rotation;else{var d=void 0;d=l.parentMatrix?e.quaternion3_.setFromRotationMatrix(l.parentMatrix):o,(c=e.quaternion_).copy(d).multiply(l.rotation)}e.rotationBuffer.setXYZW(t,c.x,c.y,c.z,c.w)}else e.settings.renderMode!==Ne.StretchedBillBoard&&e.settings.renderMode!==Ne.VerticalBillBoard&&e.settings.renderMode!==Ne.HorizontalBillBoard&&e.settings.renderMode!==Ne.BillBoard||e.rotationBuffer.setX(t,l.rotation);var f=void 0;if(i.worldSpace?f=l.position:(f=e.vector_,l.parentMatrix?f.copy(l.position).applyMatrix4(l.parentMatrix):f.copy(l.position).applyMatrix4(i.emitter.matrixWorld)),e.offsetBuffer.setXYZ(t,f.x,f.y,f.z),e.colorBuffer.setXYZW(t,l.color.x,l.color.y,l.color.z,l.color.w),i.worldSpace||l.parentMatrix?e.sizeBuffer.setX(t,l.size):e.sizeBuffer.setX(t,l.size*(Math.abs(s.x)+Math.abs(s.y)+Math.abs(s.z))/3),e.uvTileBuffer.setX(t,l.uvTile),e.settings.renderMode===Ne.StretchedBillBoard&&e.velocityBuffer){var h=i.rendererEmitterSettings.speedFactor;0===h&&(h=.001);var p=i.rendererEmitterSettings.lengthFactor,m=void 0;i.worldSpace?m=l.velocity:(m=e.vector_,l.parentMatrix?(e.rotationMat2_.setFromMatrix4(l.parentMatrix),m.copy(l.velocity).applyMatrix3(e.rotationMat2_)):m.copy(l.velocity).applyMatrix3(e.rotationMat_)),e.velocityBuffer.setXYZW(t,m.x*h,m.y*h,m.z*h,p)}}})),this.geometry.instanceCount=t,t>0&&(this.offsetBuffer.updateRange.count=3*t,this.offsetBuffer.needsUpdate=!0,this.sizeBuffer.updateRange.count=t,this.sizeBuffer.needsUpdate=!0,this.colorBuffer.updateRange.count=4*t,this.colorBuffer.needsUpdate=!0,this.uvTileBuffer.updateRange.count=t,this.uvTileBuffer.needsUpdate=!0,this.settings.renderMode===Ne.StretchedBillBoard&&this.velocityBuffer&&(this.velocityBuffer.updateRange.count=4*t,this.velocityBuffer.needsUpdate=!0),this.settings.renderMode===Ne.Mesh?(this.rotationBuffer.updateRange.count=4*t,this.rotationBuffer.needsUpdate=!0):this.settings.renderMode!==Ne.StretchedBillBoard&&this.settings.renderMode!==Ne.HorizontalBillBoard&&this.settings.renderMode!==Ne.VerticalBillBoard&&this.settings.renderMode!==Ne.BillBoard||(this.rotationBuffer.updateRange.count=t,this.rotationBuffer.needsUpdate=!0))}},{key:"dispose",value:function dispose(){this.geometry.dispose()}}]),SpriteBatch}(Me);new t.Vector3(0,0,1);var ze=function(e){_inherits(TrailBatch,e);var i=_createSuper(TrailBatch);function TrailBatch(e){var n;return _classCallCheck(this,TrailBatch),_defineProperty(_assertThisInitialized(n=i.call(this,e)),"positionBuffer",void 0),_defineProperty(_assertThisInitialized(n),"previousBuffer",void 0),_defineProperty(_assertThisInitialized(n),"nextBuffer",void 0),_defineProperty(_assertThisInitialized(n),"uvBuffer",void 0),_defineProperty(_assertThisInitialized(n),"sideBuffer",void 0),_defineProperty(_assertThisInitialized(n),"widthBuffer",void 0),_defineProperty(_assertThisInitialized(n),"colorBuffer",void 0),_defineProperty(_assertThisInitialized(n),"indexBuffer",void 0),_defineProperty(_assertThisInitialized(n),"vector_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"vector2_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"vector3_",new t.Vector3),_defineProperty(_assertThisInitialized(n),"quaternion_",new t.Quaternion),n.maxParticles=1e4,n.setupBuffers(),n.rebuildMaterial(),n}return _createClass(TrailBatch,[{key:"setupBuffers",value:function setupBuffers(){this.geometry&&this.geometry.dispose(),this.geometry=new t.BufferGeometry,this.indexBuffer=new t.BufferAttribute(new Uint32Array(6*this.maxParticles),1),this.indexBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setIndex(this.indexBuffer),this.positionBuffer=new t.BufferAttribute(new Float32Array(6*this.maxParticles),3),this.positionBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("position",this.positionBuffer),this.previousBuffer=new t.BufferAttribute(new Float32Array(6*this.maxParticles),3),this.previousBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("previous",this.previousBuffer),this.nextBuffer=new t.BufferAttribute(new Float32Array(6*this.maxParticles),3),this.nextBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("next",this.nextBuffer),this.widthBuffer=new t.BufferAttribute(new Float32Array(2*this.maxParticles),1),this.widthBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("width",this.widthBuffer),this.sideBuffer=new t.BufferAttribute(new Float32Array(2*this.maxParticles),1),this.sideBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("side",this.sideBuffer),this.uvBuffer=new t.BufferAttribute(new Float32Array(4*this.maxParticles),2),this.uvBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("uv",this.uvBuffer),this.colorBuffer=new t.BufferAttribute(new Float32Array(8*this.maxParticles),4),this.colorBuffer.setUsage(t.DynamicDrawUsage),this.geometry.setAttribute("color",this.colorBuffer)}},{key:"expandBuffers",value:function expandBuffers(e){for(;e>=this.maxParticles;)this.maxParticles*=2;this.setupBuffers()}},{key:"rebuildMaterial",value:function rebuildMaterial(){this.layers.mask=this.settings.layers.mask;var e={lineWidth:{value:1},map:{value:null},useMap:{value:0},alphaMap:{value:null},useAlphaMap:{value:0},resolution:{value:new t.Vector2(1,1)},sizeAttenuation:{value:1},visibility:{value:1},alphaTest:{value:0}},i={USE_UV:"",USE_COLOR_ALPHA:""};if(this.settings.material.map&&(i.USE_MAP="",i.MAP_UV=getMaterialUVChannelName(this.settings.material.map.channel),e.map=new t.Uniform(this.settings.material.map),e.mapTransform=new t.Uniform((new t.Matrix3).copy(this.settings.material.map.matrix))),this.settings.material.defines&&void 0!==this.settings.material.defines.USE_COLOR_AS_ALPHA&&(i.USE_COLOR_AS_ALPHA=""),this.settings.renderMode!==Ne.Trail)throw new Error("render mode unavailable");this.material=new t.ShaderMaterial({uniforms:e,defines:i,vertexShader:"\n#include <common>\n#include <tile_pars_vertex>\n#include <color_pars_vertex>\n#include <clipping_planes_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <fog_pars_vertex>\n\nattribute vec3 previous;\nattribute vec3 next;\nattribute float side;\nattribute float width;\n\nuniform vec2 resolution;\nuniform float lineWidth;\nuniform float sizeAttenuation;\n    \nvec2 fix(vec4 i, float aspect) {\n    vec2 res = i.xy / i.w;\n    res.x *= aspect;\n    return res;\n}\n    \nvoid main() {\n\n    #include <tile_vertex>\n    \n    float aspect = resolution.x / resolution.y;\n\n    vColor = color;\n\n    mat4 m = projectionMatrix * modelViewMatrix;\n    vec4 finalPosition = m * vec4( position, 1.0 );\n    vec4 prevPos = m * vec4( previous, 1.0 );\n    vec4 nextPos = m * vec4( next, 1.0 );\n\n    vec2 currentP = fix( finalPosition, aspect );\n    vec2 prevP = fix( prevPos, aspect );\n    vec2 nextP = fix( nextPos, aspect );\n\n    float w = lineWidth * width;\n\n    vec2 dir;\n    if( nextP == currentP ) dir = normalize( currentP - prevP );\n    else if( prevP == currentP ) dir = normalize( nextP - currentP );\n    else {\n        vec2 dir1 = normalize( currentP - prevP );\n        vec2 dir2 = normalize( nextP - currentP );\n        dir = normalize( dir1 + dir2 );\n\n        vec2 perp = vec2( -dir1.y, dir1.x );\n        vec2 miter = vec2( -dir.y, dir.x );\n        //w = clamp( w / dot( miter, perp ), 0., 4., * lineWidth * width );\n\n    }\n\n    //vec2 normal = ( cross( vec3( dir, 0. ) vec3( 0., 0., 1. ) ) ).xy;\n    vec4 normal = vec4( -dir.y, dir.x, 0., 1. );\n    normal.xy *= .5 * w;\n    normal *= projectionMatrix;\n    if( sizeAttenuation == 0. ) {\n        normal.xy *= finalPosition.w;\n        normal.xy /= ( vec4( resolution, 0., 1. ) * projectionMatrix ).xy;\n    }\n\n    finalPosition.xy += normal.xy * side;\n\n    gl_Position = finalPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t\n    vec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\n    \n\t#include <fog_vertex>\n}",fragmentShader:"\n\n#include <common>\n#include <tile_pars_fragment>\n#include <map_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nuniform sampler2D alphaMap;\nuniform float useAlphaMap;\nuniform float visibility;\nuniform float alphaTest;\n\nvarying vec4 vColor;\n    \nvoid main() {\n    #include <clipping_planes_fragment>\n    #include <logdepthbuf_fragment>\n\n    vec4 diffuseColor = vColor;\n    \n    #ifdef USE_MAP\n    #include <tile_fragment>\n    #ifndef USE_COLOR_AS_ALPHA\n    #endif\n    #endif\n    if( useAlphaMap == 1. ) diffuseColor.a *= texture2D( alphaMap, vUv).a;\n    if( diffuseColor.a < alphaTest ) discard;\n    gl_FragColor = diffuseColor;\n\n    #include <fog_fragment>\n    #include <tonemapping_fragment>\n}",transparent:this.settings.material.transparent,depthWrite:!this.settings.material.transparent,side:this.settings.material.side,blending:this.settings.material.blending||t.AdditiveBlending})}},{key:"update",value:function update(){var e=this,t=0,i=0,n=0;this.systems.forEach((function(e){for(var t=0;t<e.particleNum;t++)n+=2*e.particles[t].previous.length})),n>this.maxParticles&&this.expandBuffers(n),this.systems.forEach((function(n){var r=e.quaternion_,o=e.vector2_,a=e.vector3_;n.emitter.matrixWorld.decompose(o,r,a);for(var s=n.particles,u=n.particleNum,l=e.settings.uTileCount,c=e.settings.vTileCount,d=1/l,f=1/c,h=0;h<u;h++){var p=s[h],m=p.uvTile%c,v=Math.floor(p.uvTile/c+.001),y=p.previous.values(),g=y.next(),S=g.value,_=S;g.done||(g=y.next());var x=void 0;x=void 0!==g.value?g.value:_;for(var P=0;P<p.previous.length;P++,t+=2){if(e.positionBuffer.setXYZ(t,_.position.x,_.position.y,_.position.z),e.positionBuffer.setXYZ(t+1,_.position.x,_.position.y,_.position.z),n.worldSpace?(e.positionBuffer.setXYZ(t,_.position.x,_.position.y,_.position.z),e.positionBuffer.setXYZ(t+1,_.position.x,_.position.y,_.position.z)):(p.parentMatrix?e.vector_.copy(_.position).applyMatrix4(p.parentMatrix):e.vector_.copy(_.position).applyMatrix4(n.emitter.matrixWorld),e.positionBuffer.setXYZ(t,e.vector_.x,e.vector_.y,e.vector_.z),e.positionBuffer.setXYZ(t+1,e.vector_.x,e.vector_.y,e.vector_.z)),n.worldSpace?(e.previousBuffer.setXYZ(t,S.position.x,S.position.y,S.position.z),e.previousBuffer.setXYZ(t+1,S.position.x,S.position.y,S.position.z)):(p.parentMatrix?e.vector_.copy(S.position).applyMatrix4(p.parentMatrix):e.vector_.copy(S.position).applyMatrix4(n.emitter.matrixWorld),e.previousBuffer.setXYZ(t,e.vector_.x,e.vector_.y,e.vector_.z),e.previousBuffer.setXYZ(t+1,e.vector_.x,e.vector_.y,e.vector_.z)),n.worldSpace?(e.nextBuffer.setXYZ(t,x.position.x,x.position.y,x.position.z),e.nextBuffer.setXYZ(t+1,x.position.x,x.position.y,x.position.z)):(p.parentMatrix?e.vector_.copy(x.position).applyMatrix4(p.parentMatrix):e.vector_.copy(x.position).applyMatrix4(n.emitter.matrixWorld),e.nextBuffer.setXYZ(t,e.vector_.x,e.vector_.y,e.vector_.z),e.nextBuffer.setXYZ(t+1,e.vector_.x,e.vector_.y,e.vector_.z)),e.sideBuffer.setX(t,-1),e.sideBuffer.setX(t+1,1),n.worldSpace)e.widthBuffer.setX(t,_.size),e.widthBuffer.setX(t+1,_.size);else if(p.parentMatrix)e.widthBuffer.setX(t,_.size),e.widthBuffer.setX(t+1,_.size);else{var b=(Math.abs(a.x)+Math.abs(a.y)+Math.abs(a.z))/3;e.widthBuffer.setX(t,_.size*b),e.widthBuffer.setX(t+1,_.size*b)}e.uvBuffer.setXY(t,(P/p.previous.length+m)*d,(c-v-1)*f),e.uvBuffer.setXY(t+1,(P/p.previous.length+m)*d,(c-v)*f),e.colorBuffer.setXYZW(t,_.color.x,_.color.y,_.color.z,_.color.w),e.colorBuffer.setXYZW(t+1,_.color.x,_.color.y,_.color.z,_.color.w),P+1<p.previous.length&&(e.indexBuffer.setX(3*i,t),e.indexBuffer.setX(3*i+1,t+1),e.indexBuffer.setX(3*i+2,t+2),i++,e.indexBuffer.setX(3*i,t+2),e.indexBuffer.setX(3*i+1,t+1),e.indexBuffer.setX(3*i+2,t+3),i++),S=_,_=x,g.done||void 0!==(g=y.next()).value&&(x=g.value)}}})),this.positionBuffer.updateRange.count=3*t,this.positionBuffer.needsUpdate=!0,this.previousBuffer.updateRange.count=3*t,this.previousBuffer.needsUpdate=!0,this.nextBuffer.updateRange.count=3*t,this.nextBuffer.needsUpdate=!0,this.sideBuffer.updateRange.count=t,this.sideBuffer.needsUpdate=!0,this.widthBuffer.updateRange.count=t,this.widthBuffer.needsUpdate=!0,this.uvBuffer.updateRange.count=2*t,this.uvBuffer.needsUpdate=!0,this.colorBuffer.updateRange.count=4*t,this.colorBuffer.needsUpdate=!0,this.indexBuffer.updateRange.count=3*i,this.indexBuffer.needsUpdate=!0,this.geometry.setDrawRange(0,3*i)}},{key:"dispose",value:function dispose(){this.geometry.dispose()}}]),TrailBatch}(Me),Ie=function(e){_inherits(BatchedRenderer,e);var t=_createSuper(BatchedRenderer);function BatchedRenderer(){var e;return _classCallCheck(this,BatchedRenderer),_defineProperty(_assertThisInitialized(e=t.call(this)),"batches",[]),_defineProperty(_assertThisInitialized(e),"systemToBatchIndex",new Map),_defineProperty(_assertThisInitialized(e),"type","BatchedRenderer"),_defineProperty(_assertThisInitialized(e),"depthTexture",null),e}return _createClass(BatchedRenderer,[{key:"addSystem",value:function addSystem(e){e._renderer=this;for(var t,i=e.getRendererSettings(),n=0;n<this.batches.length;n++)if(BatchedRenderer.equals(this.batches[n].settings,i))return this.batches[n].addSystem(e),void this.systemToBatchIndex.set(e,n);switch(i.renderMode){case Ne.Trail:t=new ze(i);break;case Ne.Mesh:case Ne.BillBoard:case Ne.VerticalBillBoard:case Ne.HorizontalBillBoard:case Ne.StretchedBillBoard:t=new Ue(i)}this.depthTexture&&t.applyDepthTexture(this.depthTexture),t.addSystem(e),this.batches.push(t),this.systemToBatchIndex.set(e,this.batches.length-1),this.add(t)}},{key:"deleteSystem",value:function deleteSystem(e){var t=this.systemToBatchIndex.get(e);null!=t&&(this.batches[t].removeSystem(e),this.systemToBatchIndex.delete(e))}},{key:"setDepthTexture",value:function setDepthTexture(e){this.depthTexture=e;var t,i=_createForOfIteratorHelper(this.batches);try{for(i.s();!(t=i.n()).done;)t.value.applyDepthTexture(e)}catch(e){i.e(e)}finally{i.f()}}},{key:"updateSystem",value:function updateSystem(e){this.deleteSystem(e),this.addSystem(e)}},{key:"update",value:function update(e){this.systemToBatchIndex.forEach((function(t,i){i.update(e)}));for(var t=0;t<this.batches.length;t++)this.batches[t].update()}}],[{key:"equals",value:function equals(e,t){return e.material.side===t.material.side&&e.material.blending===t.material.blending&&e.material.transparent===t.material.transparent&&e.material.type===t.material.type&&e.material.alphaTest===t.material.alphaTest&&e.material.map===t.material.map&&e.renderMode===t.renderMode&&e.blendTiles===t.blendTiles&&e.softParticles===t.softParticles&&e.softFarFade===t.softFarFade&&e.softNearFade===t.softNearFade&&e.uTileCount===t.uTileCount&&e.vTileCount===t.vTileCount&&e.instancingGeometry===t.instancingGeometry&&e.renderOrder===t.renderOrder&&e.layers.mask===t.layers.mask}}]),BatchedRenderer}(t.Object3D),Re=Ie;function _initWebGPU(){return(_initWebGPU=_asyncToGenerator(_regeneratorRuntime().mark((function _callee2(){var e,t,i;return _regeneratorRuntime().wrap((function _callee2$(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,null===(e=navigator.gpu)||void 0===e?void 0:e.requestAdapter();case 2:if(t=n.sent){n.next=5;break}throw"need a browser that supports WebGPU";case 5:return n.next=7,null==t?void 0:t.requestDevice();case 7:if(i=n.sent){n.next=10;break}throw"need a browser that supports WebGPU";case 10:return n.abrupt("return",{adapter:t,device:i});case 11:case"end":return n.stop()}}),_callee2)})))).apply(this,arguments)}var Fe=function(){function WebGPURenderer(e,i,n,r,o){var a=this,s=arguments.length>5&&void 0!==arguments[5]&&arguments[5],u=arguments.length>6&&void 0!==arguments[6]?arguments[6]:"";_classCallCheck(this,WebGPURenderer),_defineProperty(this,"numLiveParticles",0),_defineProperty(this,"simulationUBOBuffer",void 0),_defineProperty(this,"simulationParams",void 0),_defineProperty(this,"particlesBuffer",void 0),_defineProperty(this,"particleIndexBuffer",void 0),_defineProperty(this,"computeBindGroup",void 0),_defineProperty(this,"computePipeline",void 0),_defineProperty(this,"context",void 0),_defineProperty(this,"mvp",new t.Matrix4),_defineProperty(this,"uniformBuffer",void 0),_defineProperty(this,"quadVertexBuffer",void 0),_defineProperty(this,"renderBindGroup",void 0),_defineProperty(this,"renderPassDescriptor",void 0),_defineProperty(this,"renderPipeline",void 0),_defineProperty(this,"cpuReadableBuffer",void 0),_defineProperty(this,"frame",function(){var e=_asyncToGenerator(_regeneratorRuntime().mark((function _callee(e){var t,i,n,r;return _regeneratorRuntime().wrap((function _callee$(o){for(;;)switch(o.prev=o.next){case 0:a.deviceContext.device.queue.writeBuffer(a.simulationUBOBuffer,0,new Float32Array([a.simulationParams.simulate?a.simulationParams.deltaTime:0,0,0,0,100*Math.random(),100*Math.random(),1+Math.random(),1+Math.random()])),a.mvp.multiplyMatrices(e.projectionMatrix,e.matrixWorldInverse),a.deviceContext.device.queue.writeBuffer(a.uniformBuffer,0,new Float32Array([e.matrixWorldInverse.elements[0],e.matrixWorldInverse.elements[1],e.matrixWorldInverse.elements[2],e.matrixWorldInverse.elements[3],e.matrixWorldInverse.elements[4],e.matrixWorldInverse.elements[5],e.matrixWorldInverse.elements[6],e.matrixWorldInverse.elements[7],e.matrixWorldInverse.elements[8],e.matrixWorldInverse.elements[9],e.matrixWorldInverse.elements[10],e.matrixWorldInverse.elements[11],e.matrixWorldInverse.elements[12],e.matrixWorldInverse.elements[13],e.matrixWorldInverse.elements[14],e.matrixWorldInverse.elements[15],e.projectionMatrix.elements[0],e.projectionMatrix.elements[1],e.projectionMatrix.elements[2],e.projectionMatrix.elements[3],e.projectionMatrix.elements[4],e.projectionMatrix.elements[5],e.projectionMatrix.elements[6],e.projectionMatrix.elements[7],e.projectionMatrix.elements[8],e.projectionMatrix.elements[9],e.projectionMatrix.elements[10],e.projectionMatrix.elements[11],e.projectionMatrix.elements[12],e.projectionMatrix.elements[13],e.projectionMatrix.elements[14],e.projectionMatrix.elements[15]])),t=a.context.getCurrentTexture(),a.renderPassDescriptor.colorAttachments[0].view=t.createView(),i=a.deviceContext.device.createCommandEncoder(),(n=i.beginComputePass()).setPipeline(a.computePipeline),n.setBindGroup(0,a.computeBindGroup),n.dispatchWorkgroups(Math.ceil(a.numParticles/64)),n.end(),(r=i.beginRenderPass(a.renderPassDescriptor)).setPipeline(a.renderPipeline),r.setBindGroup(0,a.renderBindGroup),r.setVertexBuffer(0,a.quadVertexBuffer),r.draw(6,a.numLiveParticles,0,0),r.end(),a.debug&&i.copyBufferToBuffer(a.particlesBuffer,0,a.cpuReadableBuffer,0,a.numParticles*a.particleInstanceByteSize),a.deviceContext.device.queue.submit([i.finish()]);case 19:case"end":return o.stop()}}),_callee)})));return function(t){return e.apply(this,arguments)}}()),this.deviceContext=e,this.canvas=i,this.numParticles=n,this.particleInstanceByteSize=r,this.debug=s,this.renderCode=u,this.initBuffers(),this.initRenderPipeline(),this.initSimulationPipeline(o)}return _createClass(WebGPURenderer,[{key:"initBuffers",value:function initBuffers(){this.numLiveParticles=this.numParticles,this.particlesBuffer=this.deviceContext.device.createBuffer({size:this.numParticles*this.particleInstanceByteSize,usage:GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC}),this.particleIndexBuffer=this.deviceContext.device.createBuffer({size:4*this.numParticles,usage:GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_DST}),this.debug&&(this.cpuReadableBuffer=this.deviceContext.device.createBuffer({size:this.numParticles*this.particleInstanceByteSize,usage:GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST}));for(var e=new Uint32Array(this.numParticles),t=0;t<this.numParticles;t++)e[t]=t;this.debug&&console.log(e),this.deviceContext.device.queue.writeBuffer(this.particleIndexBuffer,0,e)}},{key:"initRenderPipeline",value:function initRenderPipeline(){var e=window.devicePixelRatio;this.canvas.width=this.canvas.clientWidth*e,this.canvas.height=this.canvas.clientHeight*e,this.context=this.canvas.getContext("webgpu");var t=navigator.gpu.getPreferredCanvasFormat();this.context.configure({device:this.deviceContext.device,format:t,alphaMode:"premultiplied"});var i=this.deviceContext.device.createShaderModule({code:""===this.renderCode?"\n////////////////////////////////////////////////////////////////////////////////\n// Vertex shader\n////////////////////////////////////////////////////////////////////////////////\nstruct RenderParams {\n  modelViewProjectionMatrix : mat4x4f,\n  right : vec3<f32>,\n  up : vec3<f32>\n}\n\nstruct Particle {\n    color: vec4<f32>,\n    position: vec3<f32>,\n    velocity: vec3<f32>,\n    life: f32,\n    age: f32,\n}\n\n@group(0) @binding(0) var<uniform> render_params : RenderParams;\n@group(0) @binding(1) var<storage, read> particles: array<Particle>;\n@group(0) @binding(2) var<storage, read> particleIndices: array<u32>;\n\nstruct VertexInput {\n  /*@location(0) position : vec3f,\n  @location(1) color : vec4f,*/\n  @location(0) quad_pos : vec2f, // -1..+1\n  @builtin(instance_index) instanceIndex: u32,\n}\n\nstruct VertexOutput {\n  @builtin(position) position : vec4f,\n  @location(0) color : vec4f,\n  @location(1) quad_pos : vec2f, // -1..+1\n}\n\n@vertex\nfn vs_main(in : VertexInput) -> VertexOutput {\n  var quad_pos = mat2x3f(render_params.right, render_params.up) * in.quad_pos;\n  \n  var particle = particles[particleIndices[in.instanceIndex]];\n  var position = particle.position + quad_pos * 0.01;\n  var out : VertexOutput;\n  out.position = render_params.modelViewProjectionMatrix * vec4f(position, 1.0);\n  out.color = particle.color;\n  out.quad_pos = in.quad_pos;\n  return out;\n}\n\n////////////////////////////////////////////////////////////////////////////////\n// Fragment shader\n////////////////////////////////////////////////////////////////////////////////\n@fragment\nfn fs_main(in : VertexOutput) -> @location(0) vec4f {\n  var color = vec4<f32>(1.0, 0.0, 0.0, 1.0); //in.color;\n  // Apply a circular particle alpha mask\n  color.a = color.a * max(1.0 - length(in.quad_pos), 0.0);\n  return color;\n}\n\n":this.renderCode});this.renderPipeline=this.deviceContext.device.createRenderPipeline({layout:"auto",vertex:{module:i,entryPoint:"vs_main",buffers:[{arrayStride:8,stepMode:"vertex",attributes:[{shaderLocation:0,offset:0,format:"float32x2"}]}]},fragment:{module:i,entryPoint:"fs_main",targets:[{format:t,blend:{color:{srcFactor:"src-alpha",dstFactor:"one",operation:"add"},alpha:{srcFactor:"zero",dstFactor:"one",operation:"add"}}}]},primitive:{topology:"triangle-list"},depthStencil:{depthWriteEnabled:!1,depthCompare:"less",format:"depth24plus"}});var n=this.deviceContext.device.createTexture({size:[this.canvas.width,this.canvas.height],format:"depth24plus",usage:GPUTextureUsage.RENDER_ATTACHMENT});this.uniformBuffer=this.deviceContext.device.createBuffer({size:128,usage:GPUBufferUsage.UNIFORM|GPUBufferUsage.COPY_DST}),this.renderBindGroup=this.deviceContext.device.createBindGroup({layout:this.renderPipeline.getBindGroupLayout(0),entries:[{binding:0,resource:{buffer:this.uniformBuffer}},{binding:1,resource:{buffer:this.particlesBuffer}},{binding:2,resource:{buffer:this.particleIndexBuffer}}]}),this.renderPassDescriptor={colorAttachments:[{view:void 0,clearValue:[0,0,0,1],loadOp:"clear",storeOp:"store"}],depthStencilAttachment:{view:n.createView(),depthClearValue:1,depthLoadOp:"clear",depthStoreOp:"store"}},this.quadVertexBuffer=this.deviceContext.device.createBuffer({size:48,usage:GPUBufferUsage.VERTEX,mappedAtCreation:!0}),new Float32Array(this.quadVertexBuffer.getMappedRange()).set([-1,-1,1,-1,-1,1,-1,1,1,-1,1,1]),this.quadVertexBuffer.unmap()}},{key:"initSimulationPipeline",value:function initSimulationPipeline(e){this.simulationUBOBuffer=this.deviceContext.device.createBuffer({size:32,usage:GPUBufferUsage.UNIFORM|GPUBufferUsage.COPY_DST}),this.simulationParams={simulate:!0,deltaTime:.01},this.computePipeline=this.deviceContext.device.createComputePipeline({layout:"auto",compute:{module:this.deviceContext.device.createShaderModule({code:e}),entryPoint:"simulate"}}),this.computeBindGroup=this.deviceContext.device.createBindGroup({layout:this.computePipeline.getBindGroupLayout(0),entries:[{binding:0,resource:{buffer:this.simulationUBOBuffer}},{binding:1,resource:{buffer:this.particlesBuffer,offset:0,size:this.numParticles*this.particleInstanceByteSize}},{binding:2,resource:{buffer:this.particleIndexBuffer,offset:0,size:4*this.numParticles}}]})}}]),WebGPURenderer}(),Le=function(e){_inherits(QuarksLoader,e);var i=_createSuper(QuarksLoader);function QuarksLoader(e){return _classCallCheck(this,QuarksLoader),i.call(this,e)}return _createClass(QuarksLoader,[{key:"linkReference",value:function linkReference(e){var t={};e.traverse((function(e){t[e.uuid]=e})),e.traverse((function(e){if("ParticleEmitter"===e.type){var i=e.system;i.emitterShape;for(var n=0;n<i.behaviors.length;n++)i.behaviors[n]instanceof H&&(i.behaviors[n].subParticleSystem=t[i.behaviors[n].subParticleSystem])}}))}},{key:"parse",value:function parse(e,t){var i=_get(_getPrototypeOf(QuarksLoader.prototype),"parse",this).call(this,e,t);return this.linkReference(i),i}},{key:"parseObject",value:function parseObject(e,i,n,r,o){var a,s,u;function getGeometry(e){return void 0===i[e]&&console.warn("THREE.ObjectLoader: Undefined geometry",e),i[e]}function getMaterial(e){if(void 0!==e){if(Array.isArray(e)){for(var t=[],i=0,r=e.length;i<r;i++){var o=e[i];void 0===n[o]&&console.warn("THREE.ObjectLoader: Undefined material",o),t.push(n[o])}return t}return void 0===n[e]&&console.warn("THREE.ObjectLoader: Undefined material",e),n[e]}}function getTexture(e){return void 0===r[e]&&console.warn("THREE.ObjectLoader: Undefined texture",e),r[e]}var l={textures:r,geometries:i,materials:n};switch(e.type){case"ParticleEmitter":a=Ve.fromJSON(e.ps,l,{}).emitter;break;case"Scene":a=new t.Scene,void 0!==e.background&&(Number.isInteger(e.background)?a.background=new t.Color(e.background):a.background=getTexture(e.background)),void 0!==e.environment&&(a.environment=getTexture(e.environment)),void 0!==e.fog&&("Fog"===e.fog.type?a.fog=new t.Fog(e.fog.color,e.fog.near,e.fog.far):"FogExp2"===e.fog.type&&(a.fog=new t.FogExp2(e.fog.color,e.fog.density)),""!==e.fog.name&&(a.fog.name=e.fog.name)),void 0!==e.backgroundBlurriness&&(a.backgroundBlurriness=e.backgroundBlurriness),void 0!==e.backgroundIntensity&&(a.backgroundIntensity=e.backgroundIntensity),void 0!==e.backgroundRotation&&a.backgroundRotation.fromArray(e.backgroundRotation),void 0!==e.environmentIntensity&&(a.environmentIntensity=e.environmentIntensity),void 0!==e.environmentRotation&&a.environmentRotation.fromArray(e.environmentRotation);break;case"PerspectiveCamera":a=new t.PerspectiveCamera(e.fov,e.aspect,e.near,e.far),void 0!==e.focus&&(a.focus=e.focus),void 0!==e.zoom&&(a.zoom=e.zoom),void 0!==e.filmGauge&&(a.filmGauge=e.filmGauge),void 0!==e.filmOffset&&(a.filmOffset=e.filmOffset),void 0!==e.view&&(a.view=Object.assign({},e.view));break;case"OrthographicCamera":a=new t.OrthographicCamera(e.left,e.right,e.top,e.bottom,e.near,e.far),void 0!==e.zoom&&(a.zoom=e.zoom),void 0!==e.view&&(a.view=Object.assign({},e.view));break;case"AmbientLight":a=new t.AmbientLight(e.color,e.intensity);break;case"DirectionalLight":a=new t.DirectionalLight(e.color,e.intensity);break;case"PointLight":a=new t.PointLight(e.color,e.intensity,e.distance,e.decay);break;case"RectAreaLight":a=new t.RectAreaLight(e.color,e.intensity,e.width,e.height);break;case"SpotLight":a=new t.SpotLight(e.color,e.intensity,e.distance,e.angle,e.penumbra,e.decay);break;case"HemisphereLight":a=new t.HemisphereLight(e.color,e.groundColor,e.intensity);break;case"LightProbe":a=(new t.LightProbe).fromJSON(e);break;case"SkinnedMesh":s=getGeometry(e.geometry),u=getMaterial(e.material),a=new t.SkinnedMesh(s,u),void 0!==e.bindMode&&(a.bindMode=e.bindMode),void 0!==e.bindMatrix&&a.bindMatrix.fromArray(e.bindMatrix),void 0!==e.skeleton&&(a.skeleton=e.skeleton);break;case"Mesh":s=getGeometry(e.geometry),u=getMaterial(e.material),a=new t.Mesh(s,u);break;case"InstancedMesh":s=getGeometry(e.geometry),u=getMaterial(e.material);var c=e.count,d=e.instanceMatrix,f=e.instanceColor;(a=new t.InstancedMesh(s,u,c)).instanceMatrix=new t.InstancedBufferAttribute(new Float32Array(d.array),16),void 0!==f&&(a.instanceColor=new t.InstancedBufferAttribute(new Float32Array(f.array),f.itemSize));break;case"BatchedMesh":s=getGeometry(e.geometry),u=getMaterial(e.material),(a=new t.BatchedMesh(e.maxGeometryCount,e.maxVertexCount,e.maxIndexCount,u)).geometry=s,a.perObjectFrustumCulled=e.perObjectFrustumCulled,a.sortObjects=e.sortObjects,a._drawRanges=e.drawRanges,a._reservedRanges=e.reservedRanges,a._visibility=e.visibility,a._active=e.active,a._bounds=e.bounds.map((function(e){var i=new t.Box3;i.min.fromArray(e.boxMin),i.max.fromArray(e.boxMax);var n=new t.Sphere;return n.radius=e.sphereRadius,n.center.fromArray(e.sphereCenter),{boxInitialized:e.boxInitialized,box:i,sphereInitialized:e.sphereInitialized,sphere:n}})),a._maxGeometryCount=e.maxGeometryCount,a._maxVertexCount=e.maxVertexCount,a._maxIndexCount=e.maxIndexCount,a._geometryInitialized=e.geometryInitialized,a._geometryCount=e.geometryCount,a._matricesTexture=getTexture(e.matricesTexture.uuid);break;case"LOD":a=new t.LOD;break;case"Line":a=new t.Line(getGeometry(e.geometry),getMaterial(e.material));break;case"LineLoop":a=new t.LineLoop(getGeometry(e.geometry),getMaterial(e.material));break;case"LineSegments":a=new t.LineSegments(getGeometry(e.geometry),getMaterial(e.material));break;case"PointCloud":case"Points":a=new t.Points(getGeometry(e.geometry),getMaterial(e.material));break;case"Sprite":a=new t.Sprite(getMaterial(e.material));break;case"Group":a=new t.Group;break;case"Bone":a=new t.Bone;break;default:a=new t.Object3D}if(a.uuid=e.uuid,void 0!==e.name&&(a.name=e.name),void 0!==e.matrix?(a.matrix.fromArray(e.matrix),void 0!==e.matrixAutoUpdate&&(a.matrixAutoUpdate=e.matrixAutoUpdate),a.matrixAutoUpdate&&(a.matrix.decompose(a.position,a.quaternion,a.scale),isNaN(a.quaternion.x)&&a.quaternion.set(0,0,0,1))):(void 0!==e.position&&a.position.fromArray(e.position),void 0!==e.rotation&&a.rotation.fromArray(e.rotation),void 0!==e.quaternion&&a.quaternion.fromArray(e.quaternion),void 0!==e.scale&&a.scale.fromArray(e.scale)),void 0!==e.up&&a.up.fromArray(e.up),void 0!==e.castShadow&&(a.castShadow=e.castShadow),void 0!==e.receiveShadow&&(a.receiveShadow=e.receiveShadow),e.shadow&&(void 0!==e.shadow.bias&&(a.shadow.bias=e.shadow.bias),void 0!==e.shadow.normalBias&&(a.normalBias=e.shadow.normalBias),void 0!==e.shadow.radius&&(a.radius=e.shadow.radius),void 0!==e.shadow.mapSize&&a.mapSize.fromArray(e.shadow.mapSize),void 0!==e.shadow.camera&&(a.camera=this.parseObject(e.shadow.camera))),void 0!==e.visible&&(a.visible=e.visible),void 0!==e.frustumCulled&&(a.frustumCulled=e.frustumCulled),void 0!==e.renderOrder&&(a.renderOrder=e.renderOrder),void 0!==e.userData&&(a.userData=e.userData),void 0!==e.layers&&(a.layers.mask=e.layers),void 0!==e.children)for(var h=e.children,p=0;p<h.length;p++)a.add(this.parseObject(h[p],i,n,r,o));if(void 0!==e.animations)for(var m=e.animations,v=0;v<m.length;v++){var y=m[v];a.animations.push(o[y])}if("LOD"===e.type){void 0!==e.autoUpdate&&(a.autoUpdate=e.autoUpdate);for(var g=e.levels,S=0;S<g.length;S++){var _=g[S],x=a.getObjectByProperty("uuid",_.object);void 0!==x&&a.addLevel(x,_.distance)}}return a}}]),QuarksLoader}(t.ObjectLoader),Je=[],Ge=function(e){return e[e.Number=0]="Number",e[e.Vec2=1]="Vec2",e[e.Vec3=2]="Vec3",e[e.Vec4=3]="Vec4",e[e.Boolean=4]="Boolean",e[e.AnyType=5]="AnyType",e[e.NullableAnyType=6]="NullableAnyType",e[e.EventStream=7]="EventStream",e}({}),De=function getAlignOfNodeValueType(e){switch(e){case Ge.Boolean:case Ge.Number:return 4;case Ge.Vec2:return 8;case Ge.Vec3:case Ge.Vec4:return 16;case Ge.AnyType:case Ge.NullableAnyType:default:return 0}},qe=function getSizeOfNodeValueType(e){switch(e){case Ge.Boolean:return 1;case Ge.Number:return 4;case Ge.Vec2:return 8;case Ge.Vec3:return 12;case Ge.Vec4:return 16;case Ge.AnyType:case Ge.NullableAnyType:default:return 0}},We=function genDefaultForNodeValueType(e){switch(e){case Ge.Boolean:return!1;case Ge.Number:return 0;case Ge.Vec2:return new t.Vector2;case Ge.Vec3:return new t.Vector3;case Ge.Vec4:return new t.Vector4;case Ge.AnyType:return 0;case Ge.NullableAnyType:return}},je=function(){function Node(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:-1,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};_classCallCheck(this,Node),_defineProperty(this,"id",void 0),_defineProperty(this,"inputs",[]),_defineProperty(this,"outputs",[]),_defineProperty(this,"definition",void 0),_defineProperty(this,"signatureIndex",-1),_defineProperty(this,"data",void 0),_defineProperty(this,"position",new t.Vector2),_defineProperty(this,"outputValues",[]),this.id=""+Math.round(1e5*Math.random()),this.definition=e,this.signatureIndex=i,this.data=n;for(var r=-1===i?0:i,o=0;o<e.nodeTypeSignatures[r].inputTypes.length;o++)this.inputs.push(void 0);for(var a=0;a<e.nodeTypeSignatures[r].outputTypes.length;a++)this.outputs.push([])}return _createClass(Node,[{key:"inputTypes",get:function get(){var e=-1===this.signatureIndex?0:this.signatureIndex;return this.definition.nodeTypeSignatures[e].inputTypes}},{key:"outputTypes",get:function get(){var e=-1===this.signatureIndex?0:this.signatureIndex;return this.definition.nodeTypeSignatures[e].outputTypes}},{key:"func",value:function func(e,t,i){var n=-1===this.signatureIndex?0:this.signatureIndex;this.definition.nodeTypeSignatures[n].func(e,this.data,t,i)}}]),Node}(),He=_createClass((function Wire(e,t,i,n){_classCallCheck(this,Wire),_defineProperty(this,"input",void 0),_defineProperty(this,"inputIndex",void 0),_defineProperty(this,"output",void 0),_defineProperty(this,"outputIndex",void 0),this.input=e,this.inputIndex=t,this.input.outputs[t].push(this),this.output=i,this.outputIndex=n,this.output.inputs[n]=this})),Xe=_createClass((function Adapter(e,t,i,n){if(_classCallCheck(this,Adapter),_defineProperty(this,"node",void 0),_defineProperty(this,"isInput",void 0),_defineProperty(this,"paramIndex",void 0),_defineProperty(this,"type",void 0),_defineProperty(this,"inputs",void 0),_defineProperty(this,"outputs",void 0),this.type=e,this.node=i,this.isInput=t,this.paramIndex=n,t)switch(e){case Ge.Vec2:this.inputs=[void 0,void 0],this.outputs=[];break;case Ge.Vec3:this.inputs=[void 0,void 0,void 0],this.outputs=[];break;case Ge.Vec4:this.inputs=[void 0,void 0,void 0,void 0],this.outputs=[];break;default:this.inputs=[void 0],this.outputs=[]}else switch(e){case Ge.Vec2:this.inputs=[],this.outputs=[[],[]];break;case Ge.Vec3:this.inputs=[],this.outputs=[[],[],[]];break;case Ge.Vec4:this.inputs=[],this.outputs=[[],[],[],[]];break;default:this.inputs=[],this.outputs=[[]]}})),Qe=function(){function BaseCompiler(){_classCallCheck(this,BaseCompiler),_defineProperty(this,"visited",new Set),_defineProperty(this,"debug",!1),BaseCompiler.Instance=this}return _createClass(BaseCompiler,[{key:"buildExecutionOrder",value:function buildExecutionOrder(e,t){e.nodesInOrder.length=0,this.visited.clear();for(var i=0;i<e.outputNodes.length;i++){var n=e.outputNodes[i];void 0!==n.inputs[0]&&this._traverse(n,e,t)}e.compiled=!0}},{key:"_traverseWire",value:function _traverseWire(e,t,i){}},{key:"_traverse",value:function _traverse(e,t,i){this.visited.add(e.id);for(var n=0;n<e.inputs.length;n++)if(e.inputs[n]instanceof He){var r=e.inputs[n].input;r instanceof je?this.visited.has(r.id)||this._traverse(r,t,i):r instanceof Xe&&(r.isInput||this._traverse(r.node,t,i))}else if(e.inputs[n]instanceof Xe)for(var o=e.inputs[n],a=0;a<o.inputs.length;a++){var s=o.inputs[a];void 0!==s&&(s.input instanceof je?this.visited.has(s.input.id)||this._traverse(s.input,t,i):this.visited.has(s.input.node.id)||this._traverse(s.input.node,t,i))}t.nodesInOrder.push(e)}}]),BaseCompiler}();_defineProperty(Qe,"Instance",void 0);var Ye=function(e){_inherits(Interpreter,e);var t=_createSuper(Interpreter);function Interpreter(){return _classCallCheck(this,Interpreter),t.call(this)}return _createClass(Interpreter,[{key:"executeCompiledGraph",value:function executeCompiledGraph(e,t){for(var i=e.nodesInOrder,n=0;n<i.length;n++){var r=[],o=i[n];this.debug&&console.log("Node:",o);for(var a=0;a<o.inputs.length;a++)o.inputs[a]instanceof He?o.inputs[a].input instanceof je&&r.push(o.inputs[a].input.outputValues[o.inputs[a].inputIndex]):o.inputs[a]instanceof Xe||(void 0!==o.inputs[a]?r.push(o.inputs[a].getValue(t)):r.push(void 0));if(0===o.outputValues.length)for(var s=o.signatureIndex<0?0:o.signatureIndex,u=0;u<o.definition.nodeTypeSignatures[s].outputTypes.length;u++)o.outputValues.push(We(o.definition.nodeTypeSignatures[s].outputTypes[u])),void 0===o.outputValues[u]&&(o.outputValues[u]=We(o.data.type));o.func(t,r,o.outputValues)}}},{key:"run",value:function run(e,t){e.compiled||this.buildExecutionOrder(e,t),this.executeCompiledGraph(e,t)}},{key:"build",value:function build(e,t){return""}}]),Interpreter}(Qe),Ze=function(e){return e[e.Variable=0]="Variable",e[e.Expression=1]="Expression",e[e.Storage=2]="Storage",e[e.Function=3]="Function",e}({}),Ke=function(){function NodeDef(e,t){_classCallCheck(this,NodeDef),_defineProperty(this,"name",void 0),_defineProperty(this,"type",void 0),_defineProperty(this,"nodeTypeSignatures",[]),this.name=e,this.type=t}return _createClass(NodeDef,[{key:"addSignature",value:function addSignature(e,t,i){this.nodeTypeSignatures.push({inputTypes:e,outputTypes:t,func:i})}}]),NodeDef}(),$e=function(e){_inherits(GraphNodeType,e);var t=_createSuper(GraphNodeType);function GraphNodeType(e){var i;_classCallCheck(this,GraphNodeType);for(var n=[],r=0;r<e.inputNodes.length;r++)"input"===e.inputNodes[r].definition.name&&n.push(e.inputNodes[r].data.type);for(var o=[],a=0;a<e.outputNodes.length;a++)"output"===e.outputNodes[a].definition.name&&o.push(e.outputNodes[a].data.type);return _defineProperty(_assertThisInitialized(i=t.call(this,e.name,Ze.Expression)),"nodeGraph",void 0),i.addSignature(n,o,(function(t,i,n,r){t.inputs=n,t.outputs=r,Ye.Instance.run(e,t)})),i.nodeGraph=e,i}return _createClass(GraphNodeType)}(Ke),et={},tt=new Ke("add",Ze.Expression);tt.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]+i[1]})),tt.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Vec2],(function(e,t,i,n){n[0].addVectors(i[0],i[1])})),tt.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){n[0].addVectors(i[0],i[1])})),tt.addSignature([Ge.Vec4,Ge.Vec4],[Ge.Vec4],(function(e,t,i,n){n[0].addVectors(i[0],i[1])})),et.add=tt;var it=new Ke("sub",Ze.Expression);it.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]-i[1]})),it.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Vec2],(function(e,t,i,n){n[0].subVectors(i[0],i[1])})),it.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){n[0].subVectors(i[0],i[1])})),it.addSignature([Ge.Vec4,Ge.Vec4],[Ge.Vec4],(function(e,t,i,n){n[0].subVectors(i[0],i[1])})),et.sub=it;var nt=new Ke("mul",Ze.Expression);nt.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]*i[1]})),nt.addSignature([Ge.Vec2,Ge.Number],[Ge.Vec2],(function(e,t,i,n){n[0].copy(i[0]).multiplyScalar(i[1])})),nt.addSignature([Ge.Vec3,Ge.Number],[Ge.Vec3],(function(e,t,i,n){n[0].copy(i[0]).multiplyScalar(i[1])})),nt.addSignature([Ge.Vec4,Ge.Number],[Ge.Vec4],(function(e,t,i,n){n[0].copy(i[0]).multiplyScalar(i[1])})),et.mul=nt;var rt=new Ke("div",Ze.Expression);rt.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]/i[1]})),rt.addSignature([Ge.Vec2,Ge.Number],[Ge.Vec2],(function(e,t,i,n){n[0].copy(i[0]).divideScalar(i[1])})),rt.addSignature([Ge.Vec3,Ge.Number],[Ge.Vec3],(function(e,t,i,n){n[0].copy(i[0]).divideScalar(i[1])})),rt.addSignature([Ge.Vec4,Ge.Number],[Ge.Vec4],(function(e,t,i,n){n[0].copy(i[0]).divideScalar(i[1])})),et.div=rt;var ot=new Ke("sin",Ze.Expression);ot.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.sin(i[0])})),et.sin=ot;var at=new Ke("cos",Ze.Expression);at.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.cos(i[0])})),et.cos=at;var st=new Ke("tan",Ze.Expression);st.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.tan(i[0])})),et.tan=st;var ut=new Ke("abs",Ze.Expression);ut.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.abs(i[0])})),et.abs=ut;var lt=new Ke("min",Ze.Expression);lt.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.min(i[0],i[1])})),et.min=lt;var ct=new Ke("max",Ze.Expression);ct.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.max(i[0],i[1])})),et.max=ct;var dt=new Ke("dot",Ze.Expression);dt.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Number],(function(e,t,i,n){n[0]=i[0].dot(i[1])})),dt.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Number],(function(e,t,i,n){n[0]=i[0].dot(i[1])})),dt.addSignature([Ge.Vec4,Ge.Vec4],[Ge.Number],(function(e,t,i,n){n[0]=i[0].dot(i[1])})),et.dot=dt;var ft=new Ke("cross",Ze.Expression);ft.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){n[0].crossVectors(i[0],i[1])})),et.cross=ft;var ht=new Ke("length",Ze.Expression);ht.addSignature([Ge.Vec2],[Ge.Number],(function(e,t,i,n){n[0]=i[0].length()})),ht.addSignature([Ge.Vec3],[Ge.Number],(function(e,t,i,n){n[0]=i[0].length()})),ht.addSignature([Ge.Vec4],[Ge.Number],(function(e,t,i,n){n[0]=i[0].length()})),et.length=ht;var pt=new Ke("lengthSq",Ze.Expression);pt.addSignature([Ge.Vec2],[Ge.Number],(function(e,t,i,n){n[0]=i[0].lengthSq()})),pt.addSignature([Ge.Vec3],[Ge.Number],(function(e,t,i,n){n[0]=i[0].lengthSq()})),pt.addSignature([Ge.Vec4],[Ge.Number],(function(e,t,i,n){n[0]=i[0].lengthSq()})),et.lengthSq=pt;var mt=new Ke("normalize",Ze.Expression);mt.addSignature([Ge.Vec2],[Ge.Vec2],(function(e,t,i,n){n[0].copy(i[0]).normalize()})),mt.addSignature([Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){n[0].copy(i[0]).normalize()})),mt.addSignature([Ge.Vec4],[Ge.Vec4],(function(e,t,i,n){n[0].copy(i[0]).normalize()})),et.normalize=mt;var vt=new Ke("distance",Ze.Expression);vt.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Number],(function(e,t,i,n){n[0]=i[0].distanceTo(i[1])})),vt.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Number],(function(e,t,i,n){n[0]=i[0].distanceTo(i[1])})),et.distance=vt;var yt=new Ke("and",Ze.Expression);yt.addSignature([Ge.Boolean,Ge.Boolean],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]&&i[1]})),et.and=yt;var gt=new Ke("or",Ze.Expression);gt.addSignature([Ge.Boolean,Ge.Boolean],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]||i[1]})),et.or=gt;var St=new Ke("not",Ze.Expression);St.addSignature([Ge.Boolean],[Ge.Boolean],(function(e,t,i,n){n[0]=!i[0]})),et.not=St;var _t=new Ke("equal",Ze.Expression);_t.addSignature([Ge.Number,Ge.Number],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]===i[1]})),_t.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0].equals(i[1])})),_t.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0].equals(i[1])})),_t.addSignature([Ge.Vec4,Ge.Vec4],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0].equals(i[1])})),et.equal=_t;var xt=new Ke("lessThan",Ze.Expression);xt.addSignature([Ge.Number,Ge.Number],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]<i[1]})),et.lessThan=xt;var Pt=new Ke("greaterThan",Ze.Expression);Pt.addSignature([Ge.Number,Ge.Number],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]>i[1]})),et.greaterThan=Pt;var bt=new Ke("lessThanOrEqual",Ze.Expression);bt.addSignature([Ge.Number,Ge.Number],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]<=i[1]})),et.lessThanOrEqual=bt;var wt=new Ke("greaterThanOrEqual",Ze.Expression);wt.addSignature([Ge.Number,Ge.Number],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]>=i[1]})),et.greaterThanOrEqual=wt;var Ot=new Ke("if",Ze.Expression);Ot.addSignature([Ge.Boolean,Ge.AnyType,Ge.AnyType],[Ge.AnyType],(function(e,t,i,n){n[0]=i[0]?i[1]:i[2]})),et.if=Ot;var Nt=new Ke("number",Ze.Expression);Nt.addSignature([],[Ge.Number],(function(e,t,i,n){n[0]=t.value})),et.number=Nt;var Mt=new Ke("vec2",Ze.Expression);Mt.addSignature([Ge.Number,Ge.Number],[Ge.Vec2],(function(e,t,i,n){n[0].x=i[0],n[0].y=i[1]})),et.vec2=Mt;var kt=new Ke("vec3",Ze.Expression);kt.addSignature([Ge.Number,Ge.Number,Ge.Number],[Ge.Vec3],(function(e,t,i,n){n[0].x=i[0],n[0].y=i[1],n[0].z=i[2]})),et.vec3=kt;var Ct=new Ke("vec4",Ze.Expression);Ct.addSignature([Ge.Number,Ge.Number,Ge.Number,Ge.Number],[Ge.Vec4],(function(e,t,i,n){n[0].x=i[0],n[0].y=i[1],n[0].z=i[2],n[0].w=i[3]})),et.vec4=Ct;var Tt=new Ke("bool",Ze.Expression);Tt.addSignature([],[Ge.Boolean],(function(e,t,i,n){n[0]=t.value})),et.bool=Tt;var Et=new Ke("particleProperty",Ze.Storage);Et.addSignature([Ge.NullableAnyType],[Ge.NullableAnyType],(function(e,t,i,n){void 0!==i[0]&&(t.type!==Ge.Number?e.particle[t.property].copy(i[0]):e.particle[t.property]=i[0]),void 0!==e.particle[t.property]&&(t.type!==Ge.Number?n[0].copy(e.particle[t.property]):n[0]=e.particle[t.property])})),et.particleProperty=Et;var Bt=new Ke("emit",Ze.Function);Bt.addSignature([Ge.EventStream],[],(function(e,t,i,n){for(var r=i[0],o=0;o<r.length;o++)e.signal(o,r[o])})),et.emit=Bt;var Vt=new Ke("graphProperty",Ze.Storage);Vt.addSignature([Ge.NullableAnyType],[Ge.NullableAnyType],(function(e,t,i,n){void 0!==i[0]&&(t.type!==Ge.Number?e.graph[t.property].copy(i[0]):e.graph[t.property]=i[0]),void 0!==e.graph[t.property]&&(t.type!==Ge.Number?n[0].copy(e.graph[t.property]):n[0]=e.graph[t.property])})),et.graphProperty=Vt;var At=new Ke("startEvent",Ze.Expression);At.addSignature([],[Ge.EventStream],(function(e,t,i,n){n[0]=[{type:"start"}]})),et.startEvent=At;var Ut=new Ke("repeater",Ze.Expression);Ut.addSignature([Ge.EventStream,Ge.Number],[Ge.EventStream],(function(e,t,i,n){for(var r=i[0],o=i[1],a=[],s=0;s<r.length;s++)for(var u=0;u<o;u++)a.push(r[s]);n[0]=a})),et.repeater=Ut;var zt=new Ke("time",Ze.Expression);zt.addSignature([],[Ge.Number],(function(e,t,i,n){n[0]=e.emissionState.time})),et.time=zt;var It=new Ke("delta",Ze.Expression);It.addSignature([],[Ge.Number],(function(e,t,i,n){n[0]=e.delta})),et.delta=It;var Rt=new Ke("output",Ze.Storage);Rt.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]})),Rt.addSignature([Ge.Vec2],[Ge.Vec2],(function(e,t,i,n){n[0]=i[0]})),Rt.addSignature([Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){n[0]=i[0]})),Rt.addSignature([Ge.Vec4],[Ge.Vec4],(function(e,t,i,n){n[0]=i[0]})),Rt.addSignature([Ge.Boolean],[Ge.Boolean],(function(e,t,i,n){n[0]=i[0]})),et.output=Rt;var Ft=new Ke("lerp",Ze.Expression);Ft.addSignature([Ge.Number,Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=i[0]*(1-i[2])+i[1]*i[2]})),Ft.addSignature([Ge.Vec2,Ge.Vec2,Ge.Number],[Ge.Vec2],(function(e,t,i,n){n[0].lerpVectors(i[0],i[1],i[2])})),Ft.addSignature([Ge.Vec3,Ge.Vec3,Ge.Number],[Ge.Vec3],(function(e,t,i,n){n[0].lerpVectors(i[0],i[1],i[2])})),Ft.addSignature([Ge.Vec4,Ge.Vec4,Ge.Number],[Ge.Vec4],(function(e,t,i,n){n[0].lerpVectors(i[0],i[1],i[2])})),et.lerp=Ft;var Lt=new Ke("normDistrib",Ze.Expression);Lt.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=function normalD(e){return 1/Math.sqrt(2*Math.PI)*Math.exp(e*e*-.5)}(i[0])})),et.normDistrib=Lt;var Jt=new Ke("normcdf",Ze.Expression);Jt.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){var r=i[0],o=1;r<0&&(o=-1);var a=1/(1+.3275911*(r=Math.abs(r)/Math.sqrt(2))),s=1-((((1.061405429*a-1.453152027)*a+1.421413741)*a-.284496736)*a+.254829592)*a*Math.exp(-r*r);n[0]=.5*(1+o*s)})),et.normcdf=Jt;var Gt=new Ke("normcdfInv",Ze.Expression),Dt=function rationalApproximation(e){var t=[2.515517,.802853,.010328],i=[1.432788,.189269,.001308];return e-((t[2]*e+t[1])*e+t[0])/(((i[2]*e+i[1])*e+i[0])*e+1)},qt=function normcdfInv(e){return e<.5?-Dt(Math.sqrt(-2*Math.log(e))):Dt(Math.sqrt(-2*Math.log(1-e)))};Gt.addSignature([Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=qt(i[0])})),et.normcdfInv=Gt;var Wt=new Ke("clamp",Ze.Expression);Wt.addSignature([Ge.Number,Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.max(Math.min(i[0],i[2]),i[1])})),et.clamp=Wt;var jt=new Ke("smoothstep",Ze.Expression);jt.addSignature([Ge.Number,Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){var r=Math.max(Math.min(i[0],i[2]),i[1]);n[0]=r*r*(3-2*r)})),et.smoothstep=jt;var Ht=new Ke("random",Ze.Expression);Ht.addSignature([Ge.Number,Ge.Number],[Ge.Number],(function(e,t,i,n){n[0]=Math.random()*(i[1]-i[0])+i[0]})),Ht.addSignature([Ge.Vec2,Ge.Vec2],[Ge.Vec2],(function(e,t,i,n){var r=Math.random();n[0].lerpVectors(i[0],i[1],r)})),Ht.addSignature([Ge.Vec3,Ge.Vec3],[Ge.Vec3],(function(e,t,i,n){var r=Math.random();n[0].lerpVectors(i[0],i[1],r)})),Ht.addSignature([Ge.Vec4,Ge.Vec4],[Ge.Vec4],(function(e,t,i,n){var r=Math.random();n[0].lerpVectors(i[0],i[1],r)})),et.random=Ht;var Xt=new Ke("vrand",Ze.Expression);Xt.addSignature([],[Ge.Vec2],(function(e,t,i,n){var r=qt(Math.random()),o=qt(Math.random()),a=Math.sqrt(r*r+o*o);n[0].set(r/a,o/a)})),Xt.addSignature([],[Ge.Vec3],(function(e,t,i,n){var r=qt(Math.random()),o=qt(Math.random()),a=qt(Math.random()),s=Math.sqrt(r*r+o*o+a*a);n[0].set(r/s,o/s,a/s)})),Xt.addSignature([],[Ge.Vec4],(function(e,t,i,n){var r=qt(Math.random()),o=qt(Math.random()),a=qt(Math.random()),s=qt(Math.random()),u=Math.sqrt(r*r+o*o+a*a+s*s);n[0].set(r/u,o/u,a/u,s/u)})),et.vrand=Xt;var Qt=new Ke("bsdf",Ze.Storage);Qt.addSignature([Ge.Vec3,Ge.Vec3,Ge.Vec3,Ge.Number],[],(function(e,t,i,n){})),et.bsdf=Qt;var Yt=new Set(["output","particleProperty","graphProperty","emit"]),Zt=function(){function NodeGraph(e){_classCallCheck(this,NodeGraph),_defineProperty(this,"uuid",void 0),_defineProperty(this,"name",void 0),_defineProperty(this,"version",void 0),_defineProperty(this,"revision",void 0),_defineProperty(this,"inputNodes",[]),_defineProperty(this,"outputNodes",[]),_defineProperty(this,"allNodes",new Map),_defineProperty(this,"wires",[]),_defineProperty(this,"compiled",!1),_defineProperty(this,"nodesInOrder",[]),this.version="1.0",this.uuid=t.MathUtils.generateUUID(),this.name=e,this.revision=0}return _createClass(NodeGraph,[{key:"addWire",value:function addWire(e){this.wires.push(e),this.revision++}},{key:"addNode",value:function addNode(e){this.allNodes.set(e.id,e),e.definition===et.input?this.inputNodes.push(e):Yt.has(e.definition.name)&&this.outputNodes.push(e),this.revision++}},{key:"getNode",value:function getNode(e){return this.allNodes.get(e)}},{key:"deleteNode",value:function deleteNode(e){this.allNodes.delete(e.id),this.revision++}},{key:"deleteWire",value:function deleteWire(e){var t=e.input.outputs[e.inputIndex].indexOf(e);-1!==t&&e.input.outputs[e.inputIndex].splice(t,1),e.output.inputs[e.outputIndex]=void 0,-1!=(t=this.wires.indexOf(e))&&(this.wires[t]=this.wires[this.wires.length-1],this.wires.pop()),this.revision++}},{key:"toJSON",value:function toJSON(){throw new Error("not implemented")}},{key:"clone",value:function clone(){throw new Error("not implemented")}}]),NodeGraph}();new t.Vector3(0,0,1);var Kt=new t.Quaternion,$t=new t.Vector3,ei=new t.Vector3,ti=new t.PlaneGeometry(1,1,1,1),ii=function(){function NodeVFX(e){var i,r,o,a,s,u,l;_classCallCheck(this,NodeVFX),_defineProperty(this,"emissionGraph",void 0),_defineProperty(this,"updateGraph",void 0),_defineProperty(this,"interpreter",void 0),_defineProperty(this,"autoDestroy",void 0),_defineProperty(this,"prewarm",void 0),_defineProperty(this,"looping",void 0),_defineProperty(this,"duration",void 0),_defineProperty(this,"particleNum",void 0),_defineProperty(this,"paused",void 0),_defineProperty(this,"particles",void 0),_defineProperty(this,"emitter",void 0),_defineProperty(this,"rendererSettings",void 0),_defineProperty(this,"neededToUpdateRender",void 0),_defineProperty(this,"rendererEmitterSettings",void 0),_defineProperty(this,"worldSpace",void 0),_defineProperty(this,"prewarmed",void 0),_defineProperty(this,"emissionState",void 0),_defineProperty(this,"emitEnded",void 0),_defineProperty(this,"markForDestroy",void 0),_defineProperty(this,"previousWorldPos",void 0),_defineProperty(this,"temp",new t.Vector3),_defineProperty(this,"travelDistance",0),_defineProperty(this,"normalMatrix",new t.Matrix3),_defineProperty(this,"_renderer",void 0),_defineProperty(this,"speedFactor",0),this.autoDestroy=void 0!==e.autoDestroy&&e.autoDestroy,this.duration=null!==(i=e.duration)&&void 0!==i?i:1,this.looping=void 0===e.looping||e.looping,this.prewarm=void 0!==e.prewarm&&e.prewarm,this.worldSpace=null!==(r=e.worldSpace)&&void 0!==r&&r,this.rendererEmitterSettings=null!==(o=e.rendererEmitterSettings)&&void 0!==o?o:{},this.emissionGraph=e.emissionGraph,this.updateGraph=e.updateGraph,this.interpreter=new Ye,this.rendererSettings={instancingGeometry:null!==(a=e.instancingGeometry)&&void 0!==a?a:ti,renderMode:null!==(s=e.renderMode)&&void 0!==s?s:Ne.BillBoard,renderOrder:null!==(u=e.renderOrder)&&void 0!==u?u:0,material:e.material,layers:null!==(l=e.layers)&&void 0!==l?l:new t.Layers,uTileCount:1,vTileCount:1,blendTiles:!1,softParticles:!1,softNearFade:0,softFarFade:0},this.neededToUpdateRender=!0,this.particles=new Array,this.emitter=new n(this),this.paused=!1,this.particleNum=0,this.emissionState={time:0},this.emitEnded=!1,this.markForDestroy=!1,this.prewarmed=!1}return _createClass(NodeVFX,[{key:"time",get:function get(){return this.emissionState.time},set:function set(e){this.emissionState.time=e}},{key:"layers",get:function get(){return this.rendererSettings.layers}},{key:"texture",get:function get(){return this.rendererSettings.material.map},set:function set(e){this.rendererSettings.material.map=e,this.neededToUpdateRender=!0}},{key:"material",get:function get(){return this.rendererSettings.material},set:function set(e){this.rendererSettings.material=e,this.neededToUpdateRender=!0}},{key:"instancingGeometry",get:function get(){return this.rendererSettings.instancingGeometry},set:function set(e){this.restart(),this.particles.length=0,this.rendererSettings.instancingGeometry=e,this.neededToUpdateRender=!0}},{key:"renderMode",get:function get(){return this.rendererSettings.renderMode},set:function set(e){if((this.rendererSettings.renderMode!=Ne.Trail&&e===Ne.Trail||this.rendererSettings.renderMode==Ne.Trail&&e!==Ne.Trail)&&(this.restart(),this.particles.length=0),this.rendererSettings.renderMode!==e)switch(e){case Ne.Trail:this.rendererEmitterSettings={startLength:30,followLocalOrigin:!1};break;case Ne.Mesh:this.rendererEmitterSettings={geometry:new t.PlaneGeometry(1,1)};break;case Ne.BillBoard:case Ne.VerticalBillBoard:case Ne.HorizontalBillBoard:case Ne.StretchedBillBoard:this.rendererEmitterSettings={}}this.rendererSettings.renderMode=e,this.neededToUpdateRender=!0}},{key:"renderOrder",get:function get(){return this.rendererSettings.renderOrder},set:function set(e){this.rendererSettings.renderOrder=e,this.neededToUpdateRender=!0}},{key:"blending",get:function get(){return this.rendererSettings.material.blending},set:function set(e){this.rendererSettings.material.blending=e,this.neededToUpdateRender=!0}},{key:"pause",value:function pause(){this.paused=!0}},{key:"play",value:function play(){this.paused=!1}},{key:"spawn",value:function spawn(e,i){Kt.setFromRotationMatrix(i);var n=$t,r=Kt,o=ei;for(i.decompose(n,r,o),this.particleNum++;this.particles.length<this.particleNum;)this.particles.push(new a);var s=this.particles[this.particleNum-1];if(s.reset(),this.interpreter.run(this.updateGraph,{particle:s,emissionState:this.emissionState}),this.rendererSettings.renderMode===Ne.Trail&&this.rendererEmitterSettings.followLocalOrigin){var u=s;u.localPosition=(new t.Vector3).copy(u.position)}this.worldSpace&&(s.position.applyMatrix4(i),s.size*=(Math.abs(o.x)+Math.abs(o.y)+Math.abs(o.z))/3,s.velocity.multiply(o).applyMatrix3(this.normalMatrix),s.rotation&&s.rotation instanceof t.Quaternion&&s.rotation.multiplyQuaternions(Kt,s.rotation))}},{key:"endEmit",value:function endEmit(){this.emitEnded=!0,this.autoDestroy&&(this.markForDestroy=!0)}},{key:"dispose",value:function dispose(){this._renderer&&this._renderer.deleteSystem(this),this.emitter.dispose(),this.emitter.parent&&this.emitter.parent.remove(this.emitter)}},{key:"restart",value:function restart(){this.paused=!1,this.particleNum=0,this.emissionState.time=0,this.emitEnded=!1,this.markForDestroy=!1,this.prewarmed=!1}},{key:"update",value:function update(e){if(!this.paused){for(var t=this.emitter;t.parent;)t=t.parent;if("Scene"===t.type)if(this.emitEnded&&0===this.particleNum)this.markForDestroy&&this.emitter.parent&&this.dispose();else{if(this.looping&&this.prewarm&&!this.prewarmed){this.prewarmed=!0;for(var i=0;i<60*this.duration;i++)this.update(1/60)}e>.1&&(e=.1),this.neededToUpdateRender&&(this._renderer&&this._renderer.updateSystem(this),this.neededToUpdateRender=!1),this.emit(e,this.emissionState,this.emitter.matrixWorld);for(var n={particle:void 0,emissionState:this.emissionState,delta:e},r=0;r<this.particleNum;r++)n.particle=this.particles[r],this.interpreter.run(this.updateGraph,n);for(var o=0;o<this.particleNum;o++)this.rendererEmitterSettings.followLocalOrigin&&this.particles[o].localPosition?(this.particles[o].position.copy(this.particles[o].localPosition),this.particles[o].parentMatrix?this.particles[o].position.applyMatrix4(this.particles[o].parentMatrix):this.particles[o].position.applyMatrix4(this.emitter.matrixWorld)):this.particles[o].position.addScaledVector(this.particles[o].velocity,e),this.particles[o].age+=e;if(this.rendererSettings.renderMode===Ne.Trail)for(var a=0;a<this.particleNum;a++)this.particles[a].update();for(var s=0;s<this.particleNum;s++){var u=this.particles[s];!u.died||u instanceof l&&0!==u.previous.length||(this.particles[s]=this.particles[this.particleNum-1],this.particles[this.particleNum-1]=u,this.particleNum--,s--)}}else this.dispose()}}},{key:"emit",value:function emit(e,i,n){var r=this;i.time>this.duration&&(this.looping?i.time-=this.duration:this.emitEnded||this.endEmit()),this.normalMatrix.getNormalMatrix(n);var o={signal:function signal(){r.spawn(i,n)},emissionState:i,delta:e};this.emitEnded||this.interpreter.run(this.emissionGraph,o),void 0===this.previousWorldPos&&(this.previousWorldPos=new t.Vector3),this.emitter.getWorldPosition(this.previousWorldPos),i.time+=e}},{key:"toJSON",value:function toJSON(e){return{}}},{key:"getRendererSettings",value:function getRendererSettings(){return this.rendererSettings}},{key:"clone",value:function clone(){return this}}]),NodeVFX}(),ni={number:{buildBySigIndex:[function(e,t,i){return"".concat(t[0])}]},vec2:{buildBySigIndex:[function(e,t,i){return"vec2<f32>(".concat(t[0],", ").concat(t[1],")")}]},vec3:{buildBySigIndex:[function(e,t,i){return"vec3<f32>(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")}]},vec4:{buildBySigIndex:[function(e,t,i){return"vec4<f32>(".concat(t[0],", ").concat(t[1],", ").concat(t[2],", ").concat(t[3],")")}]},add:{buildBySigIndex:[function(e,t,i){return"(".concat(t[0]," + ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," + ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," + ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," + ").concat(t[1],")")}]},subtract:{buildBySigIndex:[function(e,t,i){return"(".concat(t[0]," - ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," - ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," - ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," - ").concat(t[1],")")}]},mul:{buildBySigIndex:[function(e,t,i){return"(".concat(t[0]," * ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," * ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," * ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," * ").concat(t[1],")")}]},div:{buildBySigIndex:[function(e,t,i){return"(".concat(t[0]," / ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," / ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," / ").concat(t[1],")")},function(e,t,i){return"(".concat(t[0]," / ").concat(t[1],")")}]},power:{buildBySigIndex:[function(e,t,i){return"pow(".concat(t[0],", ").concat(t[1],")")}]},sqrt:{buildBySigIndex:[function(e,t,i){return"sqrt(".concat(t[0],")")}]},sin:{buildBySigIndex:[function(e,t,i){return"sin(".concat(t[0],")")}]},cos:{buildBySigIndex:[function(e,t,i){return"cos(".concat(t[0],")")}]},tan:{buildBySigIndex:[function(e,t,i){return"tan(".concat(t[0],")")}]},asin:{buildBySigIndex:[function(e,t,i){return"asin(".concat(t[0],")")}]},acos:{buildBySigIndex:[function(e,t,i){return"acos(".concat(t[0],")")}]},atan:{buildBySigIndex:[function(e,t,i){return"atan(".concat(t[0],")")}]},atan2:{buildBySigIndex:[function(e,t,i){return"atan(".concat(t[0],", ").concat(t[1],")")}]},abs:{buildBySigIndex:[function(e,t,i){return"abs(".concat(t[0],")")}]},floor:{buildBySigIndex:[function(e,t,i){return"floor(".concat(t[0],")")}]},ceil:{buildBySigIndex:[function(e,t,i){return"ceil(".concat(t[0],")")}]},round:{buildBySigIndex:[function(e,t,i){return"round(".concat(t[0],")")}]},min:{buildBySigIndex:[function(e,t,i){return"min(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"min(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"min(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"min(".concat(t[0],", ").concat(t[1],")")}]},max:{buildBySigIndex:[function(e,t,i){return"max(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"max(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"max(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"max(".concat(t[0],", ").concat(t[1],")")}]},clamp:{buildBySigIndex:[function(e,t,i){return"clamp(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"clamp(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"clamp(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"clamp(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")}]},mix:{buildBySigIndex:[function(e,t,i){return"mix(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"mix(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"mix(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"mix(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")}]},step:{buildBySigIndex:[function(e,t,i){return"step(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"step(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"step(".concat(t[0],", ").concat(t[1],")")},function(e,t,i){return"step(".concat(t[0],", ").concat(t[1],")")}]},smoothstep:{buildBySigIndex:[function(e,t,i){return"smoothstep(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"smoothstep(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"smoothstep(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")},function(e,t,i){return"smoothstep(".concat(t[0],", ").concat(t[1],", ").concat(t[2],")")}]},length:{buildBySigIndex:[function(e,t,i){return"length(".concat(t[0],")")},function(e,t,i){return"length(".concat(t[0],")")},function(e,t,i){return"length(".concat(t[0],")")}]},delta:{buildBySigIndex:[function(e,t,i){return"sim_params.delta"}]},particleProperty:{buildBySigIndex:[function(e,t,i){return"particle.".concat(e.data.property)}]}},ri=function(e){_inherits(WebGPUCompiler,e);var i=_createSuper(WebGPUCompiler);function WebGPUCompiler(){var e;return _classCallCheck(this,WebGPUCompiler),_defineProperty(_assertThisInitialized(e=i.call(this)),"nodeResult",new Map),_defineProperty(_assertThisInitialized(e),"particleInstanceByteSize",0),_defineProperty(_assertThisInitialized(e),"hasRandom",!1),e}return _createClass(WebGPUCompiler,[{key:"run",value:function run(e,t){throw new Error("Method not implemented.")}},{key:"calculateMemoryLayout",value:function calculateMemoryLayout(e){for(var t=0,i=0;i<e.length;i++){var n=e[i],r=De(n),o=qe(n);t=Math.ceil(t/r)*r,t+=o}return t=16*Math.ceil(t/16)}},{key:"buildPredefinedStructs",value:function buildPredefinedStructs(e,t,i){var n=this;e.push("struct SimulationParams {"),e.push("    delta : f32,"),e.push("    seed : vec4<f32>,"),e.push("}"),e.push("struct Particle {"),e.push("    color: vec4<f32>,"),e.push("    position: vec3<f32>,");var r=t.outputNodes.filter((function(e){return"particleProperty"===e.definition.name&&"position"!==e.data.property&&"color"!==e.data.property&&"life"!==e.data.property&&"size"!==e.data.property&&"rotation"!==e.data.property&&"age"!==e.data.property})).sort((function(e,t){return qe(e.data.type)-qe(t.data.type)}));this.particleInstanceByteSize=this.calculateMemoryLayout([Ge.Vec4,Ge.Vec3].concat(r.map((function(e){return e.data.type}))).concat([Ge.Number,Ge.Number,Ge.Number,Ge.Number])),r.forEach((function(t){e.push("    ".concat(t.data.property,": ").concat(n.getTypeFromNodeType(t.data.type),","))})),e.push("    size: f32,"),e.push("    rotation: f32,"),e.push("    life: f32,"),e.push("    age: f32,"),e.push("}"),e.push("struct Particles {"),e.push("    particles : array<Particle>,"),e.push("}")}},{key:"buildHeader",value:function buildHeader(e,t,i){e.push(si),this.buildPredefinedStructs(e,t,i),e.push("@binding(0) @group(0) var<uniform> sim_params : SimulationParams;"),e.push("@binding(1) @group(0) var<storage, read_write> data : Particles;"),e.push("@binding(2) @group(0) var<storage, read_write> indexList : array<u32>;"),e.push("@compute @workgroup_size(64)"),e.push("fn simulate(@builtin(global_invocation_id) global_invocation_id : vec3<u32>) {"),e.push("  let invo_id = global_invocation_id.x;"),e.push("  let idx = indexList[invo_id];"),this.hasRandom&&e.push("  init_rand(invo_id, sim_params.seed);"),e.push("  var particle = data.particles[idx];")}},{key:"buildFooter",value:function buildFooter(e,t,i){e.push("  particle.age += sim_params.delta;"),e.push("  data.particles[idx] = particle;"),e.push("}")}},{key:"buildWebGPUCode",value:function buildWebGPUCode(e,t){var i=[];return this.buildHeader(i,e,t),this.buildDataFlow(e,i,t),this.buildFooter(i,e,t),i.join("\n")}},{key:"buildDataFlow",value:function buildDataFlow(e,t,i){for(var n=0;n<e.nodesInOrder.length;n++){var r=e.nodesInOrder[n],o=ni[r.definition.name];if(void 0===o)throw new Error("Node ".concat(r.id," ").concat(r.definition.name," has no builder"));for(var a=o.buildBySigIndex[r.signatureIndex],s=[],u=0;u<r.inputs.length;u++)if(r.inputs[u]instanceof He){var l=r.inputs[u].input;l instanceof je?s.push(this.nodeResult.get(l)):s.push(this.buildFromAdapter(l,t,i))}else if(r.inputs[u]instanceof Xe);else if(void 0!==r.inputs[u])s.push(this.buildFromValue(r.inputs[u].getValue(i)));else if(r.definition.type!==Ze.Storage)throw new Error("Node ".concat(r.id," misses input on index ").concat(u));var c=a(r,s,i);1===r.outputs.length?r.definition.type===Ze.Storage?(s.length>0&&t.push("".concat(c," = ").concat(s[0],";")),this.nodeResult.set(r,c)):r.outputs[0].length>1?(t.push("let v".concat(t.length," = ").concat(c,";")),this.nodeResult.set(r,"v"+(t.length-1))):r.outputs[0].length>0&&this.nodeResult.set(r,c):r.outputs.length}}},{key:"build",value:function build(e,t){return e.compiled||this.buildExecutionOrder(e,t),this.buildWebGPUCode(e,t)}},{key:"buildFromValue",value:function buildFromValue(e){if("number"==typeof e)return""+e;if(e instanceof t.Vector2)return"vec2<f32>(".concat(e.x,", ").concat(e.y,")");if(e instanceof t.Vector3)return"vec3<f32>(".concat(e.x,", ").concat(e.y,", ").concat(e.z,")");if(e instanceof t.Vector4)return"vec4<f32>(".concat(e.x,", ").concat(e.y,", ").concat(e.z,", ").concat(e.w,")");throw new Error("Unknown value type ".concat(_typeof(e)))}},{key:"getTypeFromNodeType",value:function getTypeFromNodeType(e){switch(e){case Ge.Number:return"f32";case Ge.Vec2:return"vec<f32>";case Ge.Vec3:return"vec3<f32>";case Ge.Vec4:return"vec4<f32>";default:throw new Error("Unknown node value type ".concat(e))}}},{key:"buildFromAdapter",value:function buildFromAdapter(e,t,i){if(e.isInput)switch(e.node.definition.type){case Ze.Storage:for(var n=0;n<oi.get(e.type);n++)if(e.inputs[n]instanceof He){var r=ni[e.node.definition.name].buildBySigIndex[e.node.signatureIndex];i.param=ai[n],t.push(r(e.node,[this.getResult(e.inputs[n])],i))}break;case Ze.Variable:case Ze.Expression:for(var o="",a=0;a<oi.get(e.type)-1;a++)o=this.getResult(e.inputs[a])+", ";o+=this.getResult(e.inputs[oi.get(e.type)-1]),t.push("".concat(this.getTypeFromNodeType(e.type),"(").concat(o,")"))}return""}},{key:"getResult",value:function getResult(e){var t=e.input;if(t instanceof Xe){if(t.isInput)throw new Error("node ".concat(t.node.id,"'s output adapter has to be output"));return this.nodeResult.get(t.node)+"."+ai[t.outputs.findIndex((function(t){return t.includes(e)}))]}return this.nodeResult.get(t)}}]),WebGPUCompiler}(Qe),oi=new Map([[Ge.Vec2,2],[Ge.Vec3,3],[Ge.Vec4,4]]),ai=["x","y","z","w"],si="\nvar<private> rand_seed : vec2<f32>;\n\nfn init_rand(invocation_id : u32, seed : vec4<f32>) {\n  rand_seed = seed.xz;\n  rand_seed = fract(rand_seed * cos(35.456+f32(invocation_id) * seed.yw));\n  rand_seed = fract(rand_seed * cos(41.235+f32(invocation_id) * seed.xw));\n}\n\nfn rand() -> f32 {\n  rand_seed.x = fract(cos(dot(rand_seed, vec2<f32>(23.14077926, 232.61690225))) * 136.8168);\n  rand_seed.y = fract(cos(dot(rand_seed, vec2<f32>(54.47856553, 345.84153136))) * 534.7645);\n  return rand_seed.y;\n}\n";registerShaderChunks(),console.log("%c Particle system powered by three.quarks. https://quarks.art/","font-size: 14px; font-weight: bold;"),e.Adapter=Xe,e.ApplyCollision=ce,e.ApplyForce=J,e.ApplySequences=le,e.AxisAngleGenerator=k,e.BatchedParticleRenderer=Re,e.BatchedRenderer=Ie,e.BehaviorFromJSON=BehaviorFromJSON,e.BehaviorTypes=me,e.Bezier=c,e.ChangeEmitDirection=D,e.CircleEmitter=ge,e.ColorBySpeed=de,e.ColorGeneratorFromJSON=ColorGeneratorFromJSON,e.ColorOverLife=T,e.ColorRange=v,e.ConeEmitter=ye,e.ConstantColor=P,e.ConstantValue=b,e.DonutEmitter=Se,e.EmitSubParticleSystem=H,e.EmitterFromJSON=EmitterFromJSON,e.EmitterMode=ve,e.EmitterShapes=Oe,e.EulerGenerator=C,e.ForceOverLife=A,e.FrameOverLife=I,e.GeneratorFromJSON=GeneratorFromJSON,e.Gradient=S,e.GraphNodeType=$e,e.GravityForce=G,e.GridEmitter=be,e.HemisphereEmitter=Pe,e.Interpreter=Ye,e.IntervalValue=w,e.LimitSpeedOverLife=pe,e.MeshSurfaceEmitter=we,e.Node=je,e.NodeDef=Ke,e.NodeGraph=Zt,e.NodeParticle=a,e.NodeType=Ze,e.NodeTypes=et,e.NodeVFX=ii,e.NodeValueType=Ge,e.Noise=ae,e.OrbitOverLife=R,e.OutputNodeTypeNames=Yt,e.ParticleEmitter=n,e.ParticleSystem=Ve,e.PiecewiseBezier=N,e.PiecewiseFunction=O,e.Plugins=Je,e.PointEmitter=_e,e.QuarksLoader=Le,e.RandomColor=m,e.RandomColorBetweenGradient=x,e.RandomQuatGenerator=M,e.RecordState=u,e.RenderMode=Ne,e.Rotation3DOverLife=V,e.RotationBySpeed=he,e.RotationGeneratorFromJSON=RotationGeneratorFromJSON,e.RotationOverLife=E,e.SequencerFromJSON=SequencerFromJSON,e.SizeBySpeed=fe,e.SizeOverLife=U,e.SpeedOverLife=z,e.SphereEmitter=xe,e.SpriteBatch=Ue,e.SpriteParticle=s,e.SubParticleEmitMode=j,e.TextureSequencer=se,e.TrailBatch=ze,e.TrailParticle=l,e.TurbulenceField=ie,e.VFXBatch=Me,e.ValueGeneratorFromJSON=ValueGeneratorFromJSON,e.WebGPUCompiler=ri,e.WebGPURenderer=Fe,e.WidthOverLength=L,e.Wire=He,e.genDefaultForNodeValueType=We,e.getAlignOfNodeValueType=De,e.getPhysicsResolver=getPhysicsResolver,e.getSizeOfNodeValueType=qe,e.getValueFromEmitterMode=getValueFromEmitterMode,e.initWebGPU=function initWebGPU(){return _initWebGPU.apply(this,arguments)},e.loadPlugin=function loadPlugin(e){if(!Je.find((function(t){return t.id===e.id}))){e.initialize();var t,i=_createForOfIteratorHelper(e.emitterShapes);try{for(i.s();!(t=i.n()).done;){var n=t.value;Oe[n.type]||(Oe[n.type]=n)}}catch(e){i.e(e)}finally{i.f()}var r,o=_createForOfIteratorHelper(e.behaviors);try{for(o.s();!(r=o.n()).done;){var a=r.value;me[a.type]||(me[a.type]=a)}}catch(e){o.e(e)}finally{o.f()}}},e.registerShaderChunks=registerShaderChunks,e.setPhysicsResolver=function setPhysicsResolver(e){ue=e},e.unloadPlugin=function unloadPlugin(e){var t=Je.find((function(t){return t.id===e}));if(t){var i,n=_createForOfIteratorHelper(t.emitterShapes);try{for(n.s();!(i=n.n()).done;){var r=i.value;Oe[r.type]&&delete Oe[r.type]}}catch(e){n.e(e)}finally{n.f()}var o,a=_createForOfIteratorHelper(t.behaviors);try{for(a.s();!(o=a.n()).done;){var s=o.value;me[s.type]&&delete me[s.type]}}catch(e){a.e(e)}finally{a.f()}}}},"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("three")):"function"==typeof define&&define.amd?define(["exports","three"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).THREE=e.THREE||{},e.THREE.QUARKS={}),e.THREE)}));
